//
// Copyright (c) 2013, Red Hat Inc.
// Copyright (c) 2003, 2012, Oracle and/or its affiliates.
// All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_aarch64.hpp"
#include "adfiles/ad_aarch64.hpp"
#include "memory/allocation.inline.hpp"
#include "asm/macroAssembler.inline.hpp"
#include "code/compiledIC.hpp"
#include "code/vmreg.hpp"
#include "gc_interface/collectedHeap.inline.hpp"
#include "oops/compiledICHolder.hpp"
#include "oops/markOop.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "oops/oop.inline2.hpp"
#include "opto/cfgnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/biasedLocking.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "assembler_aarch64.inline.hpp"
#include "nativeInst_aarch64.hpp"
#include "vmreg_aarch64.inline.hpp"

//SourceForm

#line 802 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"


  // AArch64 has load acquire and store release instructions which we
  // use for ordered memory accesses, e.g. for volatiles.  The ideal
  // graph generator also inserts memory barriers around volatile
  // accesses, and we don't want to generate both barriers and acq/rel
  // instructions.  So, when we emit a MemBarAcquire we look back in
  // the ideal graph for an ordered load and only emit the barrier if
  // we don't find one.

bool preceded_by_ordered_load(const Node *barrier) {
  Node *x = barrier->lookup(TypeFunc::Parms);

  if (! x)
    return false;

  if (x->is_DecodeNarrowPtr())
    x = x->in(1);

  if (x->is_Load())
    return ! x->as_Load()->is_unordered();

  return false;
}

#define __ _masm.

// advance declaratuons for helper functions to convert register
// indices to register objects

// the ad file has to provide implementations of certain methods
// expected by the generic code
//
// REQUIRED FUNCTIONALITY

//=============================================================================

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

int MachCallStaticJavaNode::ret_addr_offset()
{
  // call should be a simple bl
  // unless this is a method handle invoke in which case it is
  // mov(rfp, sp), bl, mov(sp, rfp)
  int off = 4;
  if (_method_handle_invoke) {
    off += 4;
  }
  return off;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  return 16; // movz, movk, movk, bl
}

int MachCallRuntimeNode::ret_addr_offset() {
  // for generated stubs the call will be
  //   bl(addr)
  // for real runtime callouts it iwll be
  //   mov(rscratch1, RuntimeAddress(addr)
  //   blrt rscratch1
  CodeBlob *cb = CodeCache::find_blob(_entry_point);
  if (cb) {
    return 4;
  } else {
    // A 48-bit address.  See movptr().
    return 16;
  }
}

// Indicate if the safepoint node needs the polling page as an input

// the shared code plants the oop data at the start of the generated
// code for the safepoint node and that needs ot be at the load
// instruction itself. so we cannot plant a mov of the safepoint poll
// address followed by a load. setting this to true means the mov is
// scheduled as a prior instruction. that's better for scheduling
// anyway.

bool SafePointNode::needs_polling_address_input()
{
  return true;
}

//=============================================================================

#ifndef PRODUCT
void MachBreakpointNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  st->print("BREAKPOINT");
}
#endif

void MachBreakpointNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);
  __ brk(0);
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(CodeBuffer &cbuf, PhaseRegAlloc*) const {
    MacroAssembler _masm(&cbuf);
    for (int i = 0; i < _count; i++) { 
      __ nop();
    }
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count * NativeInstruction::instruction_size;
  }

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int Compile::ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("-- \t// MachConstantBaseNode (empty encoding)");
}
#endif

#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;

  int framesize = C->frame_slots() << LogBytesPerInt;

  if (C->need_stack_bang(framesize))
    st->print("# stack bang size=%d\n\t", framesize);

  if (framesize == 0) {
    // Is this even possible?
    st->print("stp  lr, rfp, [sp, #%d]!", -(2 * wordSize)); 
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("sub  sp, sp, #%d\n\t", framesize);
    st->print("stp  rfp, lr, [sp, #%d]", framesize - 2 * wordSize);
  } else {
    st->print("stp  lr, rfp, [sp, #%d]!\n\t", -(2 * wordSize)); 
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("sub  sp, sp, rscratch1");
  }
}
#endif

void MachPrologNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);

  // n.b. frame size includes space for return pc and rfp
  long framesize = ((long)C->frame_slots()) << LogBytesPerInt;
  assert(framesize%(2*wordSize) == 0, "must preserve 2*wordSize alignment");

  // insert a nop at the start of the prolog so we can patch in a
  // branch if we need to invalidate the method later
  __ nop();

  if (C->need_stack_bang(framesize))
    __ generate_stack_overflow_check(framesize);

  __ build_frame(framesize);

  if (NotifySimulator) {
    __ notify(Assembler::method_entry);
  }

  if (VerifyStackAtCalls) {
    Unimplemented();
  }

  C->set_frame_complete(cbuf.insts_size());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    Compile::ConstantTable& constant_table = C->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0;
}

//=============================================================================

#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;
  int framesize = C->frame_slots() << LogBytesPerInt;

  st->print("# pop frame %d\n\t",framesize);

  if (framesize == 0) {
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  } else if (framesize < ((1 << 9) + 2 * wordSize)) {
    st->print("ldp  lr, rfp, [sp,#%d]\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, #%d\n\t", framesize);
  } else {
    st->print("mov  rscratch1, #%d\n\t", framesize - 2 * wordSize);
    st->print("add  sp, sp, rscratch1\n\t");
    st->print("ldp  lr, rfp, [sp],#%d\n\t", (2 * wordSize));
  }

  if (do_polling() && C->is_method_compilation()) {
    st->print("# touch polling page\n\t");
    st->print("mov  rscratch1, #" INTPTR_FORMAT "\n\t", p2i(os::get_polling_page()));
    st->print("ldr zr, [rscratch1]");
  }
}
#endif

void MachEpilogNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;
  MacroAssembler _masm(&cbuf);
  int framesize = C->frame_slots() << LogBytesPerInt;

  __ remove_frame(framesize);

  if (NotifySimulator) {
    __ notify(Assembler::method_reentry);
  }

  if (do_polling() && C->is_method_compilation()) {
    __ read_polling_page(rscratch1, os::get_polling_page(), relocInfo::poll_return_type);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // 1 for polling page.
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

// This method seems to be obsolete. It is declared in machnode.hpp
// and defined in all *.ad files, but it is never called. Should we
// get rid of it?
int MachEpilogNode::safepoint_offset() const {
  assert(do_polling(), "no return for this epilog node");
  return 4;
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float or
// rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // we have 30 int registers * 2 halves
  // (rscratch1 and rscratch2 are omitted)

  if (reg < 60) {
    return rc_int;
  }

  // we have 32 float register * 2 halves
  if (reg < 60 + 64) {
    return rc_float;
  }

  // Between float regs & stack is the flags regs.
  assert(OptoReg::is_stack(reg), "blow up if spilling flags");

  return rc_stack;
}

uint MachSpillCopyNode::implementation(CodeBuffer *cbuf, PhaseRegAlloc *ra_, bool do_size, outputStream *st) const {
  Compile* C = ra_->C;

  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");

  if (src_hi != OptoReg::Bad) {
    assert((src_lo&1)==0 && src_lo+1==src_hi &&
           (dst_lo&1)==0 && dst_lo+1==dst_hi,
           "expected aligned-adjacent pairs");
  }

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  switch (src_lo_rc) {
  case rc_int:
    if (dst_lo_rc == rc_int) {	// gpr --> gpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ mov(as_Register(Matcher::_regEncode[dst_lo]),
                 as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("mov  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ movw(as_Register(Matcher::_regEncode[dst_lo]),
                  as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("movw  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else if (dst_lo_rc == rc_float) { // gpr --> fpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovd  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_Register(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovs  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else {			// gpr --> stack spill
      assert(dst_lo_rc == rc_stack, "spill to bad register class");
      int dst_offset = ra_->reg2offset(dst_lo);
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ str(as_Register(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("str  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ strw(as_Register(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("strw  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      }
    }
    return 4;
  case rc_float:
    if (dst_lo_rc == rc_int) {	// fpr --> gpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovd(as_Register(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovd  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovs(as_Register(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovs  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else if (dst_lo_rc == rc_float) { // fpr --> fpr copy
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovd  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ fmovs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                   as_FloatRegister(Matcher::_regEncode[src_lo]));
        } else if (st) {
          st->print("fmovs  %s, %s\t# shuffle",
                    Matcher::regName[dst_lo],
                    Matcher::regName[src_lo]);
        }
      }
    } else {			// fpr --> stack spill
      assert(dst_lo_rc == rc_stack, "spill to bad register class");
      int dst_offset = ra_->reg2offset(dst_lo);
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ strd(as_FloatRegister(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("strd  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ strs(as_FloatRegister(Matcher::_regEncode[src_lo]),
	         Address(sp, dst_offset));
        } else if (st) {
          st->print("strs  %s, [sp, #%d]\t# spill",
                    Matcher::regName[src_lo],
		    dst_offset);
        }
      }
    }
    return 4;
  case rc_stack:
    int src_offset = ra_->reg2offset(src_lo);
    if (dst_lo_rc == rc_int) {	// stack --> gpr load
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldr(as_Register(Matcher::_regEncode[dst_lo]),
                 Address(sp, src_offset));
        } else if (st) {
          st->print("ldr  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
		    src_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrw(as_Register(Matcher::_regEncode[dst_lo]),
                  Address(sp, src_offset));
        } else if (st) {
          st->print("ldr  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
                   src_offset);
        }
      }
      return 4;
    } else if (dst_lo_rc == rc_float) { // stack --> fpr load
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrd(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                 Address(sp, src_offset));
        } else if (st) {
          st->print("ldrd  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
		    src_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrs(as_FloatRegister(Matcher::_regEncode[dst_lo]),
                  Address(sp, src_offset));
        } else if (st) {
          st->print("ldrs  %s, [sp, %d]\t# restore",
                    Matcher::regName[dst_lo],
                   src_offset);
        }
      }
      return 4;
    } else {			// stack --> stack copy
      assert(dst_lo_rc == rc_stack, "spill to bad register class");
      int dst_offset = ra_->reg2offset(dst_lo);
      if (((src_lo & 1) == 0 && src_lo + 1 == src_hi) &&
          (dst_lo & 1) == 0 && dst_lo + 1 == dst_hi) {
          // 64 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldr(rscratch1, Address(sp, src_offset));
          __ str(rscratch1, Address(sp, dst_offset));
        } else if (st) {
          st->print("ldr  rscratch1, [sp, %d]\t# mem-mem spill",
		    src_offset);
          st->print("\n\t");
          st->print("str  rscratch1, [sp, %d]",
		    dst_offset);
        }
      } else {
        // 32 bit
        if (cbuf) {
          MacroAssembler _masm(cbuf);
          __ ldrw(rscratch1, Address(sp, src_offset));
          __ strw(rscratch1, Address(sp, dst_offset));
        } else if (st) {
          st->print("ldrw  rscratch1, [sp, %d]\t# mem-mem spill",
		    src_offset);
          st->print("\n\t");
          st->print("strw  rscratch1, [sp, %d]",
		    dst_offset);
        }
      }
      return 8;
    }
  }

  assert(false," bad rc_class for spill ");
  Unimplemented();
  return 0;

}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  if (!ra_)
    st->print("N%d = SpillCopy(N%d)", _idx, in(1)->_idx);
  else
    implementation(NULL, ra_, false, st);
}
#endif

void MachSpillCopyNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  implementation(&cbuf, ra_, false, NULL);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return implementation(NULL, ra_, true, NULL);
}

//=============================================================================

#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("add %s, rsp, #%d]\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(CodeBuffer &cbuf, PhaseRegAlloc *ra_) const {
  MacroAssembler _masm(&cbuf);

  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg    = ra_->get_encode(this);

  if (Assembler::operand_valid_for_add_sub_immediate(offset)) {
    __ add(as_Register(reg), sp, offset);
  } else {
    ShouldNotReachHere();
  }
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_).
  return 4;
}

//=============================================================================

#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  st->print_cr("# MachUEPNode");
  if (UseCompressedClassPointers) {
    st->print_cr("\tldrw rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    if (Universe::narrow_klass_shift() != 0) {
      st->print_cr("\tdecode_klass_not_null rscratch1, rscratch1");
    }
  } else {
   st->print_cr("\tldr rscratch1, j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
  }
  st->print_cr("\tcmp r0, rscratch1\t # Inline cache check");
  st->print_cr("\tbne, SharedRuntime::_ic_miss_stub");
}
#endif

void MachUEPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const
{
  // This is the unverified entry point.
  MacroAssembler _masm(&cbuf);

  // no need to worry about 4-byte of br alignment on AArch64
  __ cmp_klass(j_rarg0, rscratch2, rscratch1);
  Label skip;
  // TODO
  // can we avoid this skip and still use a reloc?
  __ br(Assembler::EQ, skip);
  __ b(RuntimeAddress(SharedRuntime::get_ic_miss_stub()));
  __ bind(skip);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_);
}

// REQUIRED EMIT CODE

//=============================================================================

// Emit exception handler code.
int HandlerImpl::emit_exception_handler(CodeBuffer& cbuf)
{
  // mov rscratch1 #exception_blob_entry_point
  // br rscratch1
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_exception_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();
  __ b(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(CodeBuffer& cbuf)
{
  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  MacroAssembler _masm(&cbuf);
  address base =
  __ start_a_stub(size_deopt_handler());
  if (base == NULL)  return 0;  // CodeBuffer::expand failed
  int offset = __ offset();

  __ adr(lr, __ pc());
  // should we load this into rscratch1 and use a br?
  __ b(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));

  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// REQUIRED MATCHER CODE

//=============================================================================

const bool Matcher::match_rule_supported(int opcode) {

  // TODO 
  // identify extra cases that we might want to provide match rules for
  // e.g. Op_StrEquals and other intrinsics
  if (!has_match_rule(opcode)) {
    return false;
  }

  return true;  // Per default match rules are supported.
}

int Matcher::regnum_to_fpu_offset(int regnum)
{
  Unimplemented();
  return 0;
}

bool Matcher::is_short_branch_offset(int rule, int br_size, int offset)
{
  Unimplemented();
  return false;
}

const bool Matcher::isSimpleConstant64(jlong value) {
  // Will one (StoreL ConL) be cheaper than two (StoreI ConI)?.
  // Probably always true, even if a temp register is required.
  return true;
}

// true just means we have fast l2f conversion
const bool Matcher::convL2FSupported(void) {
  return true;
}

// Vector width in bytes.
const int Matcher::vector_width_in_bytes(BasicType bt) {
  // TODO fixme
  return 0;
}

// Limits on vector size (number of elements) loaded into vector.
const int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}
const int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Min size which can be loaded into vector is 4 bytes.
  int size = (type2aelembytes(bt) == 1) ? 4 : 2;
  return MIN2(size,max_size);
}

// Vector ideal reg.
const int Matcher::vector_ideal_reg(int len) {
  // TODO fixme
  return Op_RegD;
}

// Only lowest bits of xmm reg are used for vector shift count.
const int Matcher::vector_shift_count_ideal_reg(int size) {
  // TODO fixme
  return Op_RegL;
}

// AES support not yet implemented
const bool Matcher::pass_original_key_for_aes() {
  return false;
}

// x86 supports misaligned vectors store/load.
const bool Matcher::misaligned_vectors_ok() {
  // TODO fixme
  // return !AlignVector; // can be changed by flag
  return false;
}

// false => size gets scaled to BytesPerLong, ok.
const bool Matcher::init_array_count_is_in_bytes = false;

// Threshold size for cleararray.
const int Matcher::init_array_short_size = 18 * BytesPerLong;

// Use conditional move (CMOVL)
const int Matcher::long_cmove_cost() {
  // long cmoves are no more expensive than int cmoves
  return 0;
}

const int Matcher::float_cmove_cost() {
  // float cmoves are no more expensive than int cmoves
  return 0;
}

// Does the CPU require late expand (see block.cpp for description of late expand)?
const bool Matcher::require_postalloc_expand = false;

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?  True for Intel but false for most RISCs
const bool Matcher::clone_shift_expressions = false;

// Do we need to mask the count passed to shift instructions or does
// the cpu only look at the lower 5/6 bits anyway?
const bool Matcher::need_masked_shift_count = false;

// This affects two different things:
//  - how Decode nodes are matched
//  - how ImplicitNullCheck opportunities are recognized
// If true, the matcher will try to remove all Decodes and match them
// (as operands) into nodes. NullChecks are not prepared to deal with 
// Decodes by final_graph_reshaping().
// If false, final_graph_reshaping() forces the decode behind the Cmp
// for a NullCheck. The matcher matches the Decode node into a register.
// Implicit_null_check optimization moves the Decode along with the 
// memory operation back up before the NullCheck.
bool Matcher::narrow_oop_use_complex_address() {
  return Universe::narrow_oop_shift() == 0;
}

bool Matcher::narrow_klass_use_complex_address() {
// TODO
// decide whether we need to set this to true
  return false;
}

// Is it better to copy float constants, or load them directly from
// memory?  Intel can load a float constant from a direct address,
// requiring no extra registers.  Most RISCs will have to materialize
// an address into a register first, so they would do better to copy
// the constant from stack.
const bool Matcher::rematerialize_float_constants = false;

// If CPU can load and store mis-aligned doubles directly then no
// fixup is needed.  Else we split the double into 2 integer pieces
// and move it piece-by-piece.  Only happens when passing doubles into
// C code as the Java calling convention forces doubles to be aligned.
const bool Matcher::misaligned_doubles_ok = true;

// No-op on amd64
void Matcher::pd_implicit_null_fixup(MachNode *node, uint idx) {
  Unimplemented();
}

// Advertise here if the CPU requires explicit rounding operations to
// implement the UseStrictFP mode.
const bool Matcher::strict_fp_requires_explicit_rounding = false;

// Are floats converted to double when stored to stack during
// deoptimization?
bool Matcher::float_in_double() { return true; }

// Do ints take an entire long register or just half?
// The relevant question is how the int is callee-saved:
// the whole long is written but de-opt'ing will have to extract
// the relevant 32 bits.
const bool Matcher::int_in_long = true;

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  R0_num || reg == R0_H_num ||
    reg ==  R1_num || reg == R1_H_num ||
    reg ==  R2_num || reg == R2_H_num ||
    reg ==  R3_num || reg == R3_H_num ||
    reg ==  R4_num || reg == R4_H_num ||
    reg ==  R5_num || reg == R5_H_num ||
    reg ==  R6_num || reg == R6_H_num ||
    reg ==  R7_num || reg == R7_H_num ||
    reg ==  V0_num || reg == V0_H_num ||
    reg ==  V1_num || reg == V1_H_num ||
    reg ==  V2_num || reg == V2_H_num ||
    reg ==  V3_num || reg == V3_H_num ||
    reg ==  V4_num || reg == V4_H_num ||
    reg ==  V5_num || reg == V5_H_num ||
    reg ==  V6_num || reg == V6_H_num ||
    reg ==  V7_num || reg == V7_H_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

RegMask Matcher::divI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODI projection of divmodI.
RegMask Matcher::modI_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for DIVL projection of divmodL.
RegMask Matcher::divL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

// Register for MODL projection of divmodL.
RegMask Matcher::modL_proj_mask() {
  ShouldNotReachHere();
  return RegMask();
}

const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return RegMask();
}

// helper for encoding java_to_runtime calls on sim
//
// this is needed to compute the extra arguments required when
// planting a call to the simulator blrt instruction. the TypeFunc
// can be queried to identify the counts for integral, and floating
// arguments and the return type

static void getCallInfo(const TypeFunc *tf, int &gpcnt, int &fpcnt, int &rtype)
{
  int gps = 0;
  int fps = 0;
  const TypeTuple *domain = tf->domain();
  int max = domain->cnt();
  for (int i = TypeFunc::Parms; i < max; i++) {
    const Type *t = domain->field_at(i);
    switch(t->basic_type()) {
    case T_FLOAT:
    case T_DOUBLE:
      fps++;
    default:
      gps++;
    }
  }
  gpcnt = gps;
  fpcnt = fps;
  BasicType rt = tf->return_type();
  switch (rt) {
  case T_VOID:
    rtype = MacroAssembler::ret_type_void;
    break;
  default:
    rtype = MacroAssembler::ret_type_integral;
    break;
  case T_FLOAT:
    rtype = MacroAssembler::ret_type_float;
    break;
  case T_DOUBLE:
    rtype = MacroAssembler::ret_type_double;
    break;
  }
}

#define MOV_VOLATILE(REG, BASE, INDEX, SCALE, DISP, SCRATCH, INSN)	\
  MacroAssembler _masm(&cbuf);						\
  {									\
    guarantee(INDEX == -1, "mode not permitted for volatile");		\
    guarantee(DISP == 0, "mode not permitted for volatile");		\
    guarantee(SCALE == 0, "mode not permitted for volatile");		\
    __ INSN(REG, as_Register(BASE));					\
  }

typedef void (MacroAssembler::* mem_insn)(Register Rt, const Address &adr);
typedef void (MacroAssembler::* mem_float_insn)(FloatRegister Rt, const Address &adr);

  // Used for all non-volatile memory accesses.  The use of
  // $mem->opcode() to discover whether this pattern uses sign-extended
  // offsets is something of a kludge.
  static void loadStore(MacroAssembler masm, mem_insn insn,
			 Register reg, int opcode,
			 Register base, int index, int size, int disp)
  {
    Address::extend scale;

    // Hooboy, this is fugly.  We need a way to communicate to the
    // encoder that the index needs to be sign extended, so we have to
    // enumerate all the cases.
    switch (opcode) {
    case INDINDEXSCALEDOFFSETI2L:
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDOFFSETI2LN:
    case INDINDEXSCALEDI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

    if (index == -1) {
      (masm.*insn)(reg, Address(base, disp));
    } else {
      if (disp == 0) {
	(masm.*insn)(reg, Address(base, as_Register(index), scale));
      } else {
	masm.lea(rscratch1, Address(base, disp));
	(masm.*insn)(reg, Address(rscratch1, as_Register(index), scale));
      }
    }
  }

  static void loadStore(MacroAssembler masm, mem_float_insn insn,
			 FloatRegister reg, int opcode,
			 Register base, int index, int size, int disp)
  {
    Address::extend scale;

    switch (opcode) {
    case INDINDEXSCALEDOFFSETI2L:
    case INDINDEXSCALEDI2L:
    case INDINDEXSCALEDOFFSETI2LN:
    case INDINDEXSCALEDI2LN:
      scale = Address::sxtw(size);
      break;
    default:
      scale = Address::lsl(size);
    }

     if (index == -1) {
      (masm.*insn)(reg, Address(base, disp));
    } else {
      if (disp == 0) {
	(masm.*insn)(reg, Address(base, as_Register(index), scale));
      } else {
	masm.lea(rscratch1, Address(base, disp));
	(masm.*insn)(reg, Address(rscratch1, as_Register(index), scale));
      }
    }
  }


#line 1125 "../generated/adfiles/ad_aarch64.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( INSN_COST == 100, "Expect (100) to equal 100");
  assert( BRANCH_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( CALL_COST == 200, "Expect (2 * INSN_COST) to equal 200");
  assert( VOLATILE_REF_COST == 1000, "Expect (10 * INSN_COST) to equal 1000");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'N', // R27
  'N', // R27_H
  'N', // R28
  'N', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // V16
  'C', // V16_H
  'C', // V17
  'C', // V17_H
  'C', // V18
  'C', // V18_H
  'C', // V19
  'C', // V19_H
  'C', // V20
  'C', // V20_H
  'C', // V21
  'C', // V21_H
  'C', // V22
  'C', // V22_H
  'C', // V23
  'C', // V23_H
  'C', // V24
  'C', // V24_H
  'C', // V25
  'C', // V25_H
  'C', // V26
  'C', // V26_H
  'C', // V27
  'C', // V27_H
  'C', // V28
  'C', // V28_H
  'C', // V29
  'C', // V29_H
  'C', // V30
  'C', // V30_H
  'C', // V31
  'C', // V31_H
  'C', // V0
  'C', // V0_H
  'C', // V1
  'C', // V1_H
  'C', // V2
  'C', // V2_H
  'C', // V3
  'C', // V3_H
  'C', // V4
  'C', // V4_H
  'C', // V5
  'C', // V5_H
  'C', // V6
  'C', // V6_H
  'C', // V7
  'C', // V7_H
  'C', // V8
  'C', // V8_H
  'C', // V9
  'C', // V9_H
  'C', // V10
  'C', // V10_H
  'C', // V11
  'C', // V11_H
  'C', // V12
  'C', // V12_H
  'C', // V13
  'C', // V13_H
  'C', // V14
  'C', // V14_H
  'C', // V15
  'C', // V15_H
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R12
  'C', // R12_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R0
  'C', // R0_H
  'C', // R1
  'C', // R1_H
  'C', // R2
  'C', // R2_H
  'C', // R3
  'C', // R3_H
  'C', // R4
  'C', // R4_H
  'C', // R5
  'C', // R5_H
  'C', // R6
  'C', // R6_H
  'C', // R7
  'C', // R7_H
  'E', // R19
  'E', // R19_H
  'E', // R20
  'E', // R20_H
  'E', // R21
  'E', // R21_H
  'E', // R22
  'E', // R22_H
  'E', // R23
  'E', // R23_H
  'E', // R24
  'E', // R24_H
  'E', // R25
  'E', // R25_H
  'E', // R26
  'E', // R26_H
  'E', // R27
  'E', // R27_H
  'E', // R28
  'E', // R28_H
  'N', // R29
  'N', // R29_H
  'N', // R30
  'N', // R30_H
  'N', // R31
  'N', // R31_H
  'C', // V16
  'C', // V16_H
  'C', // V17
  'C', // V17_H
  'C', // V18
  'C', // V18_H
  'C', // V19
  'C', // V19_H
  'C', // V20
  'C', // V20_H
  'C', // V21
  'C', // V21_H
  'C', // V22
  'C', // V22_H
  'C', // V23
  'C', // V23_H
  'C', // V24
  'C', // V24_H
  'C', // V25
  'C', // V25_H
  'C', // V26
  'C', // V26_H
  'C', // V27
  'C', // V27_H
  'C', // V28
  'C', // V28_H
  'C', // V29
  'C', // V29_H
  'C', // V30
  'C', // V30_H
  'C', // V31
  'C', // V31_H
  'C', // V0
  'C', // V0_H
  'C', // V1
  'C', // V1_H
  'C', // V2
  'C', // V2_H
  'C', // V3
  'C', // V3_H
  'C', // V4
  'C', // V4_H
  'C', // V5
  'C', // V5_H
  'C', // V6
  'C', // V6_H
  'C', // V7
  'C', // V7_H
  'E', // V8
  'E', // V8_H
  'E', // V9
  'E', // V9_H
  'E', // V10
  'E', // V10_H
  'E', // V11
  'E', // V11_H
  'E', // V12
  'E', // V12_H
  'E', // V13
  'E', // V13_H
  'E', // V14
  'E', // V14_H
  'E', // V15
  'E', // V15_H
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immI_le_4_rule,
  /*   13 */  immI_31_rule,
  /*   14 */  immI_8_rule,
  /*   15 */  immI_16_rule,
  /*   16 */  immI_24_rule,
  /*   17 */  immI_32_rule,
  /*   18 */  immI_48_rule,
  /*   19 */  immI_56_rule,
  /*   20 */  immI_64_rule,
  /*   21 */  immI_255_rule,
  /*   22 */  immI_65535_rule,
  /*   23 */  immL_63_rule,
  /*   24 */  immL_255_rule,
  /*   25 */  immL_65535_rule,
  /*   26 */  immL_4294967295_rule,
  /*   27 */  immL_bitmask_rule,
  /*   28 */  immI_bitmask_rule,
  /*   29 */  immIScale_rule,
  /*   30 */  immI26_rule,
  /*   31 */  immI19_rule,
  /*   32 */  immIU12_rule,
  /*   33 */  immLU12_rule,
  /*   34 */  immIOffset_rule,
  /*   35 */  immLoffset_rule,
  /*   36 */  immIAddSub_rule,
  /*   37 */  immILog_rule,
  /*   38 */  immL_rule,
  /*   39 */  immL0_rule,
  /*   40 */  immL_1_rule,
  /*   41 */  immL_M1_rule,
  /*   42 */  immL_pc_off_rule,
  /*   43 */  immLAddSub_rule,
  /*   44 */  immLLog_rule,
  /*   45 */  immL_32bits_rule,
  /*   46 */  immP_rule,
  /*   47 */  immP0_rule,
  /*   48 */  immP_1_rule,
  /*   49 */  immPollPage_rule,
  /*   50 */  immByteMapBase_rule,
  /*   51 */  immP_M1_rule,
  /*   52 */  immP_M2_rule,
  /*   53 */  immD_rule,
  /*   54 */  immD0_rule,
  /*   55 */  immDPacked_rule,
  /*   56 */  immF_rule,
  /*   57 */  immF0_rule,
  /*   58 */  immFPacked_rule,
  /*   59 */  immN_rule,
  /*   60 */  immN0_rule,
  /*   61 */  immNKlass_rule,
  /*   62 */  iRegI_rule,
  /*   63 */  iRegINoSp_rule,
  /*   64 */  iRegL_rule,
  /*   65 */  iRegLNoSp_rule,
  /*   66 */  iRegP_rule,
  /*   67 */  iRegPNoSp_rule,
  /*   68 */  iRegP_R0_rule,
  /*   69 */  iRegP_R1_rule,
  /*   70 */  iRegP_R2_rule,
  /*   71 */  iRegP_R3_rule,
  /*   72 */  iRegP_R4_rule,
  /*   73 */  iRegP_R5_rule,
  /*   74 */  iRegP_R10_rule,
  /*   75 */  iRegL_R11_rule,
  /*   76 */  iRegP_FP_rule,
  /*   77 */  iRegI_R0_rule,
  /*   78 */  iRegI_R2_rule,
  /*   79 */  iRegI_R3_rule,
  /*   80 */  iRegI_R4_rule,
  /*   81 */  iRegN_rule,
  /*   82 */  iRegNNoSp_rule,
  /*   83 */  iRegIHeapbase_rule,
  /*   84 */  vRegF_rule,
  /*   85 */  vRegD_rule,
  /*   86 */  vRegD_V0_rule,
  /*   87 */  vRegD_V1_rule,
  /*   88 */  vRegD_V2_rule,
  /*   89 */  vRegD_V3_rule,
  /*   90 */  rFlagsReg_rule,
  /*   91 */  rFlagsRegU_rule,
  /*   92 */  inline_cache_RegP_rule,
  /*   93 */  interpreter_method_oop_RegP_rule,
  /*   94 */  thread_RegP_rule,
  /*   95 */  lr_RegP_rule,
  /*   96 */  indirect_rule,
  /*   97 */  indIndexScaledOffsetI_rule,
  /*   98 */  indIndexScaledOffsetL_rule,
  /*   99 */  indIndexScaledOffsetI2L_rule,
  /*  100 */  indIndexScaledI2L_rule,
  /*  101 */  indIndexScaled_rule,
  /*  102 */  indIndex_rule,
  /*  103 */  indOffI_rule,
  /*  104 */  indOffL_rule,
  /*  105 */  indirectN_rule,
  /*  106 */  indIndexScaledOffsetIN_rule,
  /*  107 */  indIndexScaledOffsetLN_rule,
  /*  108 */  indIndexScaledOffsetI2LN_rule,
  /*  109 */  indIndexScaledI2LN_rule,
  /*  110 */  indIndexScaledN_rule,
  /*  111 */  indIndexN_rule,
  /*  112 */  indOffIN_rule,
  /*  113 */  indOffLN_rule,
  /*  114 */  thread_anchor_pc_rule,
  /*  115 */  stackSlotP_rule,
  /*  116 */  stackSlotI_rule,
  /*  117 */  stackSlotF_rule,
  /*  118 */  stackSlotD_rule,
  /*  119 */  stackSlotL_rule,
  /*  120 */  cmpOp_rule,
  /*  121 */  cmpOpU_rule,
  /*  122 */  iRegL2I_rule,
  // last operand
  /*  123 */  memory_rule,
  /*  124 */  iRegIorL2I_rule,
  // last operand class
  /*  125 */  _LShiftL_iRegL_immIScale_rule,
  /*  126 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*  127 */  _ConvI2L_iRegI__rule,
  /*  128 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  129 */  _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  130 */  _DecodeN_iRegN__rule,
  /*  131 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  132 */  _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  133 */  _LoadB_memory__rule,
  /*  134 */  _LoadUB_memory__rule,
  /*  135 */  _LoadS_memory__rule,
  /*  136 */  _LoadUS_memory__rule,
  /*  137 */  _LoadI_memory__rule,
  /*  138 */  _ConvI2L__LoadI_memory___rule,
  /*  139 */  _LoadB_indirect__rule,
  /*  140 */  _LoadUB_indirect__rule,
  /*  141 */  _LoadUS_indirect__rule,
  /*  142 */  _LoadS_indirect__rule,
  /*  143 */  _LoadI_indirect__rule,
  /*  144 */  _ConvI2L__LoadI_indirect___rule,
  /*  145 */  _CastP2X_iRegP__rule,
  /*  146 */  _CastP2X__DecodeN_iRegN___rule,
  /*  147 */  _Binary_iRegP_iRegP_rule,
  /*  148 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  149 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  150 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  151 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  152 */  _Binary_iRegI_iRegI_rule,
  /*  153 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  154 */  _Binary_immI0_iRegI_rule,
  /*  155 */  _Binary_iRegI_immI0_rule,
  /*  156 */  _Binary_immI_1_immI0_rule,
  /*  157 */  _Binary_iRegL_iRegL_rule,
  /*  158 */  _Binary_iRegL_immL0_rule,
  /*  159 */  _Binary_immL0_iRegL_rule,
  /*  160 */  _Binary_iRegP_immP0_rule,
  /*  161 */  _Binary_immP0_iRegP_rule,
  /*  162 */  _Binary_iRegN_iRegN_rule,
  /*  163 */  _Binary_iRegN_immN0_rule,
  /*  164 */  _Binary_immN0_iRegN_rule,
  /*  165 */  _Binary_vRegF_vRegF_rule,
  /*  166 */  _Binary_vRegD_vRegD_rule,
  /*  167 */  _ConvL2I_iRegL__rule,
  /*  168 */  _ConvI2L_iRegIorL2I__rule,
  /*  169 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  170 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  171 */  _MulL_iRegL_iRegL_rule,
  /*  172 */  _RShiftI_iRegI_immI_31_rule,
  /*  173 */  _URShiftI__RShiftI_iRegI_immI_31_immI_31_rule,
  /*  174 */  _RShiftL_iRegL_immL_63_rule,
  /*  175 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  176 */  _XorI_iRegI_immI_M1_rule,
  /*  177 */  _XorL_iRegL_immL_M1_rule,
  /*  178 */  _XorI_iRegI_iRegI_rule,
  /*  179 */  _XorL_iRegL_iRegL_rule,
  /*  180 */  _URShiftI_iRegI_immI_rule,
  /*  181 */  _XorI__URShiftI_iRegI_immI_immI_M1_rule,
  /*  182 */  _URShiftL_iRegL_immI_rule,
  /*  183 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  184 */  _RShiftI_iRegI_immI_rule,
  /*  185 */  _XorI__RShiftI_iRegI_immI_immI_M1_rule,
  /*  186 */  _RShiftL_iRegL_immI_rule,
  /*  187 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  188 */  _LShiftI_iRegI_immI_rule,
  /*  189 */  _XorI__LShiftI_iRegI_immI_immI_M1_rule,
  /*  190 */  _LShiftL_iRegL_immI_rule,
  /*  191 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  192 */  _XorI__URShiftI_iRegI_immI_iRegI_rule,
  /*  193 */  _XorI_iRegI__URShiftI_iRegI_immI_rule,
  /*  194 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  195 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  196 */  _XorI__RShiftI_iRegI_immI_iRegI_rule,
  /*  197 */  _XorI_iRegI__RShiftI_iRegI_immI_rule,
  /*  198 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  199 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  200 */  _XorI__LShiftI_iRegI_immI_iRegI_rule,
  /*  201 */  _XorI_iRegI__LShiftI_iRegI_immI_rule,
  /*  202 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  203 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  204 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  205 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  206 */  _LShiftL_iRegL_iRegI_rule,
  /*  207 */  _SubI_immI_64_iRegI_rule,
  /*  208 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  209 */  _SubI_immI0_iRegI_rule,
  /*  210 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  211 */  _LShiftI_iRegL_iRegI_rule,
  /*  212 */  _SubI_immI_32_iRegI_rule,
  /*  213 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  214 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  215 */  _URShiftL_iRegL_iRegI_rule,
  /*  216 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  217 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  218 */  _URShiftI_iRegL_iRegI_rule,
  /*  219 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  220 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  221 */  _LShiftI_iRegI_immI_16_rule,
  /*  222 */  _RShiftI__LShiftI_iRegI_immI_16_immI_16_rule,
  /*  223 */  _LShiftI_iRegI_immI_24_rule,
  /*  224 */  _RShiftI__LShiftI_iRegI_immI_24_immI_24_rule,
  /*  225 */  _URShiftI__LShiftI_iRegI_immI_24_immI_24_rule,
  /*  226 */  _LShiftL_iRegL_immI_48_rule,
  /*  227 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  228 */  _LShiftL_iRegL_immI_32_rule,
  /*  229 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  230 */  _LShiftL_iRegL_immI_56_rule,
  /*  231 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  232 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  233 */  _AndI_iRegI_immI_255_rule,
  /*  234 */  _AndI_iRegI_immI_65535_rule,
  /*  235 */  _AndL_iRegL_immL_255_rule,
  /*  236 */  _AndL_iRegL_immL_65535_rule,
  /*  237 */  _AndL_iRegL_immL_4294967295_rule,
  /*  238 */  _ConvF2D_vRegF__rule,
  /*  239 */  _SqrtD__ConvF2D_vRegF___rule,
  /*  240 */  _OverflowMulI_iRegI_iRegI_rule,
  /*  241 */  _OverflowMulL_iRegL_iRegL_rule,
  /*  242 */  _CmpI_iRegI_immI0_rule,
  /*  243 */  _CmpL_iRegL_immL0_rule,
  /*  244 */  _CmpP_iRegP_immP0_rule,
  /*  245 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  246 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  247 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  248 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  249 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  250 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  251 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  252 */  _Binary_iRegP_R1_iRegI_R3_rule,
  // last internally defined operand
  /*  253 */  iRegINoSp_rule,
  /*  254 */  iRegLNoSp_rule,
  /*  255 */  iRegPNoSp_rule,
  /*  256 */  iRegPNoSp_rule,
  /*  257 */  iRegPNoSp_rule,
  /*  258 */  iRegPNoSp_rule,
  /*  259 */  iRegPNoSp_rule,
  /*  260 */  iRegNNoSp_rule,
  /*  261 */  iRegNNoSp_rule,
  /*  262 */  iRegNNoSp_rule,
  /*  263 */  vRegF_rule,
  /*  264 */  vRegF_rule,
  /*  265 */  vRegD_rule,
  /*  266 */  vRegD_rule,
  /*  267 */  iRegI_rule,
  /*  268 */  iRegI_rule,
  /*  269 */  iRegI_rule,
  /*  270 */  iRegI_rule,
  /*  271 */  iRegPNoSp_rule,
  /*  272 */  iRegLNoSp_rule,
  /*  273 */  iRegPNoSp_rule,
  /*  274 */  iRegPNoSp_rule,
  /*  275 */  iRegI_rule,
  /*  276 */  rFlagsReg_rule,
  /*  277 */  rFlagsReg_rule,
  /*  278 */  rFlagsReg_rule,
  /*  279 */  vRegF_rule,
  /*  280 */  vRegD_rule,
  /*  281 */  vRegF_rule,
  /*  282 */  vRegD_rule,
  /*  283 */  iRegINoSp_rule,
  /*  284 */  vRegF_rule,
  /*  285 */  iRegLNoSp_rule,
  /*  286 */  vRegD_rule,
  /*  287 */  iRegINoSp_rule,
  /*  288 */  vRegF_rule,
  /*  289 */  iRegLNoSp_rule,
  /*  290 */  vRegD_rule,
  /*  291 */  rFlagsReg_rule,
  /*  292 */  rFlagsReg_rule,
  /*  293 */  rFlagsReg_rule,
  /*  294 */  rFlagsReg_rule,
  /*  295 */  rFlagsReg_rule,
  /*  296 */  rFlagsReg_rule,
  /*  297 */  rFlagsReg_rule,
  /*  298 */  rFlagsReg_rule,
  /*  299 */  rFlagsReg_rule,
  /*  300 */  rFlagsReg_rule,
  /*  301 */  rFlagsReg_rule,
  /*  302 */  rFlagsReg_rule,
  /*  303 */  rFlagsReg_rule,
  /*  304 */  rFlagsReg_rule,
  /*  305 */  rFlagsReg_rule,
  /*  306 */  rFlagsReg_rule,
  /*  307 */  rFlagsRegU_rule,
  /*  308 */  rFlagsRegU_rule,
  /*  309 */  rFlagsRegU_rule,
  /*  310 */  rFlagsRegU_rule,
  /*  311 */  rFlagsReg_rule,
  /*  312 */  rFlagsReg_rule,
  /*  313 */  rFlagsReg_rule,
  /*  314 */  rFlagsReg_rule,
  /*  315 */  rFlagsRegU_rule,
  /*  316 */  rFlagsRegU_rule,
  /*  317 */  rFlagsRegU_rule,
  /*  318 */  rFlagsRegU_rule,
  /*  319 */  rFlagsReg_rule,
  /*  320 */  rFlagsReg_rule,
  /*  321 */  rFlagsReg_rule,
  /*  322 */  rFlagsReg_rule,
  /*  323 */  rFlagsReg_rule,
  /*  324 */  rFlagsReg_rule,
  /*  325 */  rFlagsReg_rule,
  /*  326 */  thread_RegP_rule,
  /*  327 */  iRegINoSp_rule,
  /*  328 */  iRegLNoSp_rule,
  /*  329 */  iRegINoSp_rule,
  /*  330 */  iRegLNoSp_rule,
  /*  331 */  iRegINoSp_rule,
  /*  332 */  iRegLNoSp_rule,
  /*  333 */  iRegINoSp_rule,
  /*  334 */  iRegLNoSp_rule,
  /*  335 */  iRegINoSp_rule,
  /*  336 */  iRegLNoSp_rule,
  /*  337 */  iRegLNoSp_rule,
  /*  338 */  iRegLNoSp_rule,
  /*  339 */  iRegINoSp_rule,
  /*  340 */  iRegPNoSp_rule,
  /*  341 */  iRegNNoSp_rule,
  /*  342 */  iRegPNoSp_rule,
  /*  343 */  iRegNNoSp_rule,
  /*  344 */  vRegF_rule,
  /*  345 */  vRegD_rule,
  /*  346 */  Universe_rule,
  /*  347 */  Universe_rule,
  /*  348 */  Universe_rule,
  /*  349 */  Universe_rule,
  /*  350 */  Universe_rule,
  /*  351 */  Universe_rule,
  /*  352 */  Universe_rule,
  /*  353 */  Universe_rule,
  /*  354 */  Universe_rule,
  /*  355 */  Universe_rule,
  /*  356 */  Universe_rule,
  /*  357 */  Universe_rule,
  /*  358 */  Universe_rule,
  /*  359 */  Universe_rule,
  /*  360 */  Universe_rule,
  /*  361 */  Universe_rule,
  /*  362 */  Universe_rule,
  /*  363 */  Universe_rule,
  /*  364 */  Universe_rule,
  /*  365 */  Universe_rule,
  /*  366 */  Universe_rule,
  /*  367 */  iRegINoSp_rule,
  /*  368 */  iRegLNoSp_rule,
  /*  369 */  iRegINoSp_rule,
  /*  370 */  iRegLNoSp_rule,
  /*  371 */  iRegINoSp_rule,
  /*  372 */  iRegINoSp_rule,
  /*  373 */  iRegLNoSp_rule,
  /*  374 */  iRegLNoSp_rule,
  /*  375 */  iRegINoSp_rule,
  /*  376 */  iRegLNoSp_rule,
  /*  377 */  iRegLNoSp_rule,
  /*  378 */  iRegPNoSp_rule,
  /*  379 */  iRegNNoSp_rule,
  /*  380 */  vRegF_rule,
  /*  381 */  vRegD_rule,
  /*  382 */  iRegINoSp_rule,
  /*  383 */  iRegLNoSp_rule,
  /*  384 */  iRegINoSp_rule,
  /*  385 */  iRegINoSp_rule,
  /*  386 */  Universe_rule,
  /*  387 */  Universe_rule,
  /*  388 */  Universe_rule,
  /*  389 */  Universe_rule,
  /*  390 */  Universe_rule,
  /*  391 */  Universe_rule,
  /*  392 */  Universe_rule,
  /*  393 */  Universe_rule,
  /*  394 */  Universe_rule,
  /*  395 */  iRegINoSp_rule,
  /*  396 */  iRegINoSp_rule,
  /*  397 */  iRegNNoSp_rule,
  /*  398 */  iRegNNoSp_rule,
  /*  399 */  iRegPNoSp_rule,
  /*  400 */  iRegPNoSp_rule,
  /*  401 */  iRegNNoSp_rule,
  /*  402 */  iRegPNoSp_rule,
  /*  403 */  iRegPNoSp_rule,
  /*  404 */  iRegINoSp_rule,
  /*  405 */  iRegINoSp_rule,
  /*  406 */  iRegINoSp_rule,
  /*  407 */  iRegINoSp_rule,
  /*  408 */  iRegI_rule,
  /*  409 */  iRegL_rule,
  /*  410 */  iRegI_rule,
  /*  411 */  iRegP_rule,
  /*  412 */  iRegLNoSp_rule,
  /*  413 */  Universe_rule,
  /*  414 */  iRegLNoSp_rule,
  /*  415 */  Universe_rule,
  /*  416 */  iRegINoSp_rule,
  /*  417 */  Universe_rule,
  /*  418 */  iRegINoSp_rule,
  /*  419 */  Universe_rule,
  /*  420 */  iRegINoSp_rule,
  /*  421 */  iRegINoSp_rule,
  /*  422 */  iRegINoSp_rule,
  /*  423 */  iRegINoSp_rule,
  /*  424 */  iRegINoSp_rule,
  /*  425 */  iRegINoSp_rule,
  /*  426 */  iRegINoSp_rule,
  /*  427 */  iRegINoSp_rule,
  /*  428 */  iRegLNoSp_rule,
  /*  429 */  iRegLNoSp_rule,
  /*  430 */  iRegLNoSp_rule,
  /*  431 */  iRegLNoSp_rule,
  /*  432 */  iRegLNoSp_rule,
  /*  433 */  iRegLNoSp_rule,
  /*  434 */  iRegPNoSp_rule,
  /*  435 */  iRegPNoSp_rule,
  /*  436 */  iRegPNoSp_rule,
  /*  437 */  iRegPNoSp_rule,
  /*  438 */  iRegPNoSp_rule,
  /*  439 */  iRegPNoSp_rule,
  /*  440 */  iRegNNoSp_rule,
  /*  441 */  iRegNNoSp_rule,
  /*  442 */  iRegNNoSp_rule,
  /*  443 */  iRegNNoSp_rule,
  /*  444 */  iRegNNoSp_rule,
  /*  445 */  iRegNNoSp_rule,
  /*  446 */  vRegF_rule,
  /*  447 */  vRegF_rule,
  /*  448 */  vRegD_rule,
  /*  449 */  vRegD_rule,
  /*  450 */  iRegINoSp_rule,
  /*  451 */  iRegINoSp_rule,
  /*  452 */  iRegINoSp_rule,
  /*  453 */  iRegPNoSp_rule,
  /*  454 */  iRegPNoSp_rule,
  /*  455 */  iRegPNoSp_rule,
  /*  456 */  iRegPNoSp_rule,
  /*  457 */  iRegLNoSp_rule,
  /*  458 */  iRegPNoSp_rule,
  /*  459 */  iRegLNoSp_rule,
  /*  460 */  iRegLNoSp_rule,
  /*  461 */  iRegINoSp_rule,
  /*  462 */  iRegINoSp_rule,
  /*  463 */  iRegLNoSp_rule,
  /*  464 */  iRegLNoSp_rule,
  /*  465 */  iRegINoSp_rule,
  /*  466 */  iRegLNoSp_rule,
  /*  467 */  iRegINoSp_rule,
  /*  468 */  iRegLNoSp_rule,
  /*  469 */  iRegLNoSp_rule,
  /*  470 */  iRegLNoSp_rule,
  /*  471 */  iRegLNoSp_rule,
  /*  472 */  iRegINoSp_rule,
  /*  473 */  iRegINoSp_rule,
  /*  474 */  iRegINoSp_rule,
  /*  475 */  iRegLNoSp_rule,
  /*  476 */  iRegLNoSp_rule,
  /*  477 */  iRegLNoSp_rule,
  /*  478 */  iRegINoSp_rule,
  /*  479 */  iRegINoSp_rule,
  /*  480 */  iRegINoSp_rule,
  /*  481 */  iRegINoSp_rule,
  /*  482 */  iRegLNoSp_rule,
  /*  483 */  iRegLNoSp_rule,
  /*  484 */  iRegLNoSp_rule,
  /*  485 */  iRegLNoSp_rule,
  /*  486 */  iRegINoSp_rule,
  /*  487 */  iRegLNoSp_rule,
  /*  488 */  iRegINoSp_rule,
  /*  489 */  iRegINoSp_rule,
  /*  490 */  iRegINoSp_rule,
  /*  491 */  iRegINoSp_rule,
  /*  492 */  iRegINoSp_rule,
  /*  493 */  iRegINoSp_rule,
  /*  494 */  iRegLNoSp_rule,
  /*  495 */  iRegLNoSp_rule,
  /*  496 */  iRegLNoSp_rule,
  /*  497 */  iRegLNoSp_rule,
  /*  498 */  iRegLNoSp_rule,
  /*  499 */  iRegLNoSp_rule,
  /*  500 */  iRegLNoSp_rule,
  /*  501 */  iRegLNoSp_rule,
  /*  502 */  iRegINoSp_rule,
  /*  503 */  iRegINoSp_rule,
  /*  504 */  iRegINoSp_rule,
  /*  505 */  iRegLNoSp_rule,
  /*  506 */  iRegLNoSp_rule,
  /*  507 */  iRegINoSp_rule,
  /*  508 */  iRegINoSp_rule,
  /*  509 */  iRegLNoSp_rule,
  /*  510 */  iRegLNoSp_rule,
  /*  511 */  iRegINoSp_rule,
  /*  512 */  iRegINoSp_rule,
  /*  513 */  iRegLNoSp_rule,
  /*  514 */  iRegLNoSp_rule,
  /*  515 */  iRegINoSp_rule,
  /*  516 */  iRegINoSp_rule,
  /*  517 */  iRegLNoSp_rule,
  /*  518 */  iRegLNoSp_rule,
  /*  519 */  iRegINoSp_rule,
  /*  520 */  iRegINoSp_rule,
  /*  521 */  iRegLNoSp_rule,
  /*  522 */  iRegLNoSp_rule,
  /*  523 */  iRegINoSp_rule,
  /*  524 */  iRegINoSp_rule,
  /*  525 */  iRegLNoSp_rule,
  /*  526 */  iRegLNoSp_rule,
  /*  527 */  iRegINoSp_rule,
  /*  528 */  iRegINoSp_rule,
  /*  529 */  iRegINoSp_rule,
  /*  530 */  iRegINoSp_rule,
  /*  531 */  iRegLNoSp_rule,
  /*  532 */  iRegLNoSp_rule,
  /*  533 */  iRegLNoSp_rule,
  /*  534 */  iRegLNoSp_rule,
  /*  535 */  iRegINoSp_rule,
  /*  536 */  iRegINoSp_rule,
  /*  537 */  iRegINoSp_rule,
  /*  538 */  iRegINoSp_rule,
  /*  539 */  iRegLNoSp_rule,
  /*  540 */  iRegLNoSp_rule,
  /*  541 */  iRegLNoSp_rule,
  /*  542 */  iRegLNoSp_rule,
  /*  543 */  iRegINoSp_rule,
  /*  544 */  iRegINoSp_rule,
  /*  545 */  iRegINoSp_rule,
  /*  546 */  iRegINoSp_rule,
  /*  547 */  iRegLNoSp_rule,
  /*  548 */  iRegLNoSp_rule,
  /*  549 */  iRegLNoSp_rule,
  /*  550 */  iRegLNoSp_rule,
  /*  551 */  iRegINoSp_rule,
  /*  552 */  iRegINoSp_rule,
  /*  553 */  iRegLNoSp_rule,
  /*  554 */  iRegLNoSp_rule,
  /*  555 */  iRegINoSp_rule,
  /*  556 */  iRegINoSp_rule,
  /*  557 */  iRegLNoSp_rule,
  /*  558 */  iRegLNoSp_rule,
  /*  559 */  iRegINoSp_rule,
  /*  560 */  iRegINoSp_rule,
  /*  561 */  iRegLNoSp_rule,
  /*  562 */  iRegLNoSp_rule,
  /*  563 */  iRegINoSp_rule,
  /*  564 */  iRegINoSp_rule,
  /*  565 */  iRegLNoSp_rule,
  /*  566 */  iRegLNoSp_rule,
  /*  567 */  iRegINoSp_rule,
  /*  568 */  iRegINoSp_rule,
  /*  569 */  iRegLNoSp_rule,
  /*  570 */  iRegLNoSp_rule,
  /*  571 */  iRegINoSp_rule,
  /*  572 */  iRegINoSp_rule,
  /*  573 */  iRegLNoSp_rule,
  /*  574 */  iRegLNoSp_rule,
  /*  575 */  iRegINoSp_rule,
  /*  576 */  iRegINoSp_rule,
  /*  577 */  iRegLNoSp_rule,
  /*  578 */  iRegLNoSp_rule,
  /*  579 */  iRegINoSp_rule,
  /*  580 */  iRegINoSp_rule,
  /*  581 */  iRegLNoSp_rule,
  /*  582 */  iRegLNoSp_rule,
  /*  583 */  iRegINoSp_rule,
  /*  584 */  iRegINoSp_rule,
  /*  585 */  iRegLNoSp_rule,
  /*  586 */  iRegLNoSp_rule,
  /*  587 */  iRegINoSp_rule,
  /*  588 */  iRegINoSp_rule,
  /*  589 */  iRegLNoSp_rule,
  /*  590 */  iRegLNoSp_rule,
  /*  591 */  iRegINoSp_rule,
  /*  592 */  iRegINoSp_rule,
  /*  593 */  iRegLNoSp_rule,
  /*  594 */  iRegLNoSp_rule,
  /*  595 */  iRegINoSp_rule,
  /*  596 */  iRegINoSp_rule,
  /*  597 */  iRegLNoSp_rule,
  /*  598 */  iRegLNoSp_rule,
  /*  599 */  iRegINoSp_rule,
  /*  600 */  iRegINoSp_rule,
  /*  601 */  iRegLNoSp_rule,
  /*  602 */  iRegLNoSp_rule,
  /*  603 */  iRegINoSp_rule,
  /*  604 */  iRegINoSp_rule,
  /*  605 */  iRegLNoSp_rule,
  /*  606 */  iRegLNoSp_rule,
  /*  607 */  iRegINoSp_rule,
  /*  608 */  iRegINoSp_rule,
  /*  609 */  iRegLNoSp_rule,
  /*  610 */  iRegLNoSp_rule,
  /*  611 */  iRegINoSp_rule,
  /*  612 */  iRegLNoSp_rule,
  /*  613 */  iRegINoSp_rule,
  /*  614 */  iRegLNoSp_rule,
  /*  615 */  iRegINoSp_rule,
  /*  616 */  iRegLNoSp_rule,
  /*  617 */  iRegLNoSp_rule,
  /*  618 */  iRegINoSp_rule,
  /*  619 */  iRegLNoSp_rule,
  /*  620 */  iRegINoSp_rule,
  /*  621 */  iRegINoSp_rule,
  /*  622 */  iRegLNoSp_rule,
  /*  623 */  iRegLNoSp_rule,
  /*  624 */  iRegLNoSp_rule,
  /*  625 */  iRegLNoSp_rule,
  /*  626 */  iRegINoSp_rule,
  /*  627 */  iRegINoSp_rule,
  /*  628 */  iRegLNoSp_rule,
  /*  629 */  iRegLNoSp_rule,
  /*  630 */  iRegINoSp_rule,
  /*  631 */  iRegINoSp_rule,
  /*  632 */  0,
  /*  633 */  0,
  /*  634 */  iRegL_rule,
  /*  635 */  iRegL_rule,
  /*  636 */  iRegL_rule,
  /*  637 */  iRegL_rule,
  /*  638 */  iRegL_rule,
  /*  639 */  iRegL_rule,
  /*  640 */  iRegL_rule,
  /*  641 */  iRegL_rule,
  /*  642 */  0,
  /*  643 */  0,
  /*  644 */  iRegL_rule,
  /*  645 */  iRegL_rule,
  /*  646 */  iRegL_rule,
  /*  647 */  iRegL_rule,
  /*  648 */  iRegL_rule,
  /*  649 */  iRegL_rule,
  /*  650 */  iRegL_rule,
  /*  651 */  iRegL_rule,
  /*  652 */  iRegLNoSp_rule,
  /*  653 */  iRegLNoSp_rule,
  /*  654 */  iRegLNoSp_rule,
  /*  655 */  iRegINoSp_rule,
  /*  656 */  iRegINoSp_rule,
  /*  657 */  iRegINoSp_rule,
  /*  658 */  iRegINoSp_rule,
  /*  659 */  iRegINoSp_rule,
  /*  660 */  iRegINoSp_rule,
  /*  661 */  iRegLNoSp_rule,
  /*  662 */  iRegLNoSp_rule,
  /*  663 */  iRegLNoSp_rule,
  /*  664 */  iRegLNoSp_rule,
  /*  665 */  iRegLNoSp_rule,
  /*  666 */  iRegLNoSp_rule,
  /*  667 */  iRegLNoSp_rule,
  /*  668 */  iRegLNoSp_rule,
  /*  669 */  iRegINoSp_rule,
  /*  670 */  iRegINoSp_rule,
  /*  671 */  iRegINoSp_rule,
  /*  672 */  iRegINoSp_rule,
  /*  673 */  iRegLNoSp_rule,
  /*  674 */  iRegLNoSp_rule,
  /*  675 */  iRegLNoSp_rule,
  /*  676 */  iRegLNoSp_rule,
  /*  677 */  iRegLNoSp_rule,
  /*  678 */  iRegLNoSp_rule,
  /*  679 */  iRegINoSp_rule,
  /*  680 */  iRegINoSp_rule,
  /*  681 */  iRegLNoSp_rule,
  /*  682 */  iRegLNoSp_rule,
  /*  683 */  iRegLNoSp_rule,
  /*  684 */  vRegF_rule,
  /*  685 */  vRegD_rule,
  /*  686 */  vRegF_rule,
  /*  687 */  vRegD_rule,
  /*  688 */  vRegF_rule,
  /*  689 */  vRegD_rule,
  /*  690 */  vRegF_rule,
  /*  691 */  vRegD_rule,
  /*  692 */  vRegD_rule,
  /*  693 */  vRegF_rule,
  /*  694 */  iRegINoSp_rule,
  /*  695 */  iRegINoSp_rule,
  /*  696 */  iRegINoSp_rule,
  /*  697 */  iRegINoSp_rule,
  /*  698 */  iRegINoSp_rule,
  /*  699 */  iRegINoSp_rule,
  /*  700 */  iRegLNoSp_rule,
  /*  701 */  iRegLNoSp_rule,
  /*  702 */  iRegLNoSp_rule,
  /*  703 */  iRegLNoSp_rule,
  /*  704 */  iRegLNoSp_rule,
  /*  705 */  iRegLNoSp_rule,
  /*  706 */  iRegLNoSp_rule,
  /*  707 */  iRegLNoSp_rule,
  /*  708 */  iRegINoSp_rule,
  /*  709 */  iRegINoSp_rule,
  /*  710 */  iRegINoSp_rule,
  /*  711 */  vRegF_rule,
  /*  712 */  vRegD_rule,
  /*  713 */  iRegINoSp_rule,
  /*  714 */  iRegLNoSp_rule,
  /*  715 */  vRegF_rule,
  /*  716 */  vRegF_rule,
  /*  717 */  iRegINoSp_rule,
  /*  718 */  iRegLNoSp_rule,
  /*  719 */  vRegD_rule,
  /*  720 */  vRegD_rule,
  /*  721 */  stackSlotI_rule,
  /*  722 */  stackSlotF_rule,
  /*  723 */  stackSlotL_rule,
  /*  724 */  stackSlotD_rule,
  /*  725 */  Universe_rule,
  /*  726 */  Universe_rule,
  /*  727 */  Universe_rule,
  /*  728 */  iRegINoSp_rule,
  /*  729 */  iRegINoSp_rule,
  /*  730 */  iRegINoSp_rule,
  /*  731 */  iRegINoSp_rule,
  /*  732 */  iRegINoSp_rule,
  /*  733 */  iRegINoSp_rule,
  /*  734 */  iRegINoSp_rule,
  /*  735 */  iRegINoSp_rule,
  /*  736 */  iRegINoSp_rule,
  /*  737 */  Universe_rule,
  /*  738 */  Universe_rule,
  /*  739 */  Universe_rule,
  /*  740 */  Universe_rule,
  /*  741 */  Universe_rule,
  /*  742 */  Universe_rule,
  /*  743 */  Universe_rule,
  /*  744 */  Universe_rule,
  /*  745 */  Universe_rule,
  /*  746 */  Universe_rule,
  /*  747 */  Universe_rule,
  /*  748 */  Universe_rule,
  /*  749 */  Universe_rule,
  /*  750 */  Universe_rule,
  /*  751 */  Universe_rule,
  /*  752 */  Universe_rule,
  /*  753 */  Universe_rule,
  /*  754 */  iRegP_R0_rule,
  /*  755 */  Universe_rule,
  /*  756 */  Universe_rule,
  /*  757 */  Universe_rule,
  /*  758 */  iRegP_R5_rule,
  /*  759 */  iRegI_R0_rule,
  /*  760 */  iRegI_R0_rule,
  /*  761 */  iRegI_R0_rule,
  /*  762 */  iRegI_R0_rule,
  /*  763 */  iRegI_R0_rule,
  /*  764 */  iRegI_R0_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*   98 */  _AddP_iRegP__LShiftL_iRegL_immIScale_rule,
  /*   99 */  _AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  100 */  iRegP_rule,
  /*  101 */  iRegP_rule,
  /*  102 */  iRegP_rule,
  /*  103 */  iRegP_rule,
  /*  104 */  iRegP_rule,
  /*  105 */  iRegN_rule,
  /*  106 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  107 */  _AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale_rule,
  /*  108 */  _AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  109 */  _DecodeN_iRegN__rule,
  /*  110 */  _DecodeN_iRegN__rule,
  /*  111 */  _DecodeN_iRegN__rule,
  /*  112 */  _DecodeN_iRegN__rule,
  /*  113 */  _DecodeN_iRegN__rule,
  /*  114 */  thread_RegP_rule,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  iRegL_rule,
  // last operand
  /*  123 */  0,
  /*  124 */  0,
  // last operand class
  /*  125 */  iRegL_rule,
  /*  126 */  iRegP_rule,
  /*  127 */  iRegI_rule,
  /*  128 */  _ConvI2L_iRegI__rule,
  /*  129 */  iRegP_rule,
  /*  130 */  iRegN_rule,
  /*  131 */  _DecodeN_iRegN__rule,
  /*  132 */  _DecodeN_iRegN__rule,
  /*  133 */  memory_rule,
  /*  134 */  memory_rule,
  /*  135 */  memory_rule,
  /*  136 */  memory_rule,
  /*  137 */  memory_rule,
  /*  138 */  _LoadI_memory__rule,
  /*  139 */  indirect_rule,
  /*  140 */  indirect_rule,
  /*  141 */  indirect_rule,
  /*  142 */  indirect_rule,
  /*  143 */  indirect_rule,
  /*  144 */  _LoadI_indirect__rule,
  /*  145 */  iRegP_rule,
  /*  146 */  _DecodeN_iRegN__rule,
  /*  147 */  iRegP_rule,
  /*  148 */  iRegLNoSp_rule,
  /*  149 */  iRegINoSp_rule,
  /*  150 */  iRegNNoSp_rule,
  /*  151 */  cmpOp_rule,
  /*  152 */  iRegI_rule,
  /*  153 */  cmpOpU_rule,
  /*  154 */  immI0_rule,
  /*  155 */  iRegI_rule,
  /*  156 */  immI_1_rule,
  /*  157 */  iRegL_rule,
  /*  158 */  iRegL_rule,
  /*  159 */  immL0_rule,
  /*  160 */  iRegP_rule,
  /*  161 */  immP0_rule,
  /*  162 */  iRegN_rule,
  /*  163 */  iRegN_rule,
  /*  164 */  immN0_rule,
  /*  165 */  vRegF_rule,
  /*  166 */  vRegD_rule,
  /*  167 */  iRegL_rule,
  /*  168 */  iRegIorL2I_rule,
  /*  169 */  _ConvI2L_iRegIorL2I__rule,
  /*  170 */  iRegIorL2I_rule,
  /*  171 */  iRegL_rule,
  /*  172 */  iRegI_rule,
  /*  173 */  _RShiftI_iRegI_immI_31_rule,
  /*  174 */  iRegL_rule,
  /*  175 */  _RShiftL_iRegL_immL_63_rule,
  /*  176 */  iRegI_rule,
  /*  177 */  iRegL_rule,
  /*  178 */  iRegI_rule,
  /*  179 */  iRegL_rule,
  /*  180 */  iRegI_rule,
  /*  181 */  _URShiftI_iRegI_immI_rule,
  /*  182 */  iRegL_rule,
  /*  183 */  _URShiftL_iRegL_immI_rule,
  /*  184 */  iRegI_rule,
  /*  185 */  _RShiftI_iRegI_immI_rule,
  /*  186 */  iRegL_rule,
  /*  187 */  _RShiftL_iRegL_immI_rule,
  /*  188 */  iRegI_rule,
  /*  189 */  _LShiftI_iRegI_immI_rule,
  /*  190 */  iRegL_rule,
  /*  191 */  _LShiftL_iRegL_immI_rule,
  /*  192 */  _URShiftI_iRegI_immI_rule,
  /*  193 */  iRegI_rule,
  /*  194 */  _URShiftL_iRegL_immI_rule,
  /*  195 */  iRegL_rule,
  /*  196 */  _RShiftI_iRegI_immI_rule,
  /*  197 */  iRegI_rule,
  /*  198 */  _RShiftL_iRegL_immI_rule,
  /*  199 */  iRegL_rule,
  /*  200 */  _LShiftI_iRegI_immI_rule,
  /*  201 */  iRegI_rule,
  /*  202 */  _LShiftL_iRegL_immI_rule,
  /*  203 */  iRegL_rule,
  /*  204 */  iRegIorL2I_rule,
  /*  205 */  _URShiftI_iRegIorL2I_immI_rule,
  /*  206 */  iRegL_rule,
  /*  207 */  immI_64_rule,
  /*  208 */  iRegL_rule,
  /*  209 */  immI0_rule,
  /*  210 */  iRegL_rule,
  /*  211 */  iRegL_rule,
  /*  212 */  immI_32_rule,
  /*  213 */  iRegL_rule,
  /*  214 */  iRegL_rule,
  /*  215 */  iRegL_rule,
  /*  216 */  iRegL_rule,
  /*  217 */  iRegL_rule,
  /*  218 */  iRegL_rule,
  /*  219 */  iRegL_rule,
  /*  220 */  iRegL_rule,
  /*  221 */  iRegI_rule,
  /*  222 */  _LShiftI_iRegI_immI_16_rule,
  /*  223 */  iRegI_rule,
  /*  224 */  _LShiftI_iRegI_immI_24_rule,
  /*  225 */  _LShiftI_iRegI_immI_24_rule,
  /*  226 */  iRegL_rule,
  /*  227 */  _LShiftL_iRegL_immI_48_rule,
  /*  228 */  iRegL_rule,
  /*  229 */  _LShiftL_iRegL_immI_32_rule,
  /*  230 */  iRegL_rule,
  /*  231 */  _LShiftL_iRegL_immI_56_rule,
  /*  232 */  _LShiftL_iRegL_immI_56_rule,
  /*  233 */  iRegI_rule,
  /*  234 */  iRegI_rule,
  /*  235 */  iRegL_rule,
  /*  236 */  iRegL_rule,
  /*  237 */  iRegL_rule,
  /*  238 */  vRegF_rule,
  /*  239 */  _ConvF2D_vRegF__rule,
  /*  240 */  iRegI_rule,
  /*  241 */  iRegL_rule,
  /*  242 */  iRegI_rule,
  /*  243 */  iRegL_rule,
  /*  244 */  iRegP_rule,
  /*  245 */  iRegP_R4_rule,
  /*  246 */  iRegP_R1_rule,
  /*  247 */  iRegP_R3_rule,
  /*  248 */  iRegP_R1_rule,
  /*  249 */  iRegP_R3_rule,
  /*  250 */  iRegP_R3_rule,
  /*  251 */  iRegP_R1_rule,
  /*  252 */  iRegP_R1_rule,
  // last internally defined operand
  /*  253 */  immI_rule,
  /*  254 */  immL_rule,
  /*  255 */  immP_rule,
  /*  256 */  immP0_rule,
  /*  257 */  immP_1_rule,
  /*  258 */  immPollPage_rule,
  /*  259 */  immByteMapBase_rule,
  /*  260 */  immN_rule,
  /*  261 */  immN0_rule,
  /*  262 */  immNKlass_rule,
  /*  263 */  immFPacked_rule,
  /*  264 */  immF_rule,
  /*  265 */  immDPacked_rule,
  /*  266 */  immD_rule,
  /*  267 */  iRegI_rule,
  /*  268 */  iRegL_rule,
  /*  269 */  iRegI_rule,
  /*  270 */  iRegL_rule,
  /*  271 */  iRegL_rule,
  /*  272 */  iRegP_rule,
  /*  273 */  iRegPNoSp_rule,
  /*  274 */  iRegPNoSp_rule,
  /*  275 */  iRegI_rule,
  /*  276 */  memory_rule,
  /*  277 */  indirect_rule,
  /*  278 */  indirect_rule,
  /*  279 */  vRegF_rule,
  /*  280 */  vRegD_rule,
  /*  281 */  vRegF_rule,
  /*  282 */  vRegD_rule,
  /*  283 */  stackSlotF_rule,
  /*  284 */  stackSlotI_rule,
  /*  285 */  stackSlotD_rule,
  /*  286 */  stackSlotL_rule,
  /*  287 */  vRegF_rule,
  /*  288 */  iRegI_rule,
  /*  289 */  vRegD_rule,
  /*  290 */  iRegL_rule,
  /*  291 */  iRegI_rule,
  /*  292 */  iRegI_rule,
  /*  293 */  iRegL_rule,
  /*  294 */  iRegL_rule,
  /*  295 */  iRegI_rule,
  /*  296 */  iRegI_rule,
  /*  297 */  iRegL_rule,
  /*  298 */  iRegL_rule,
  /*  299 */  immI0_rule,
  /*  300 */  immI0_rule,
  /*  301 */  iRegI_rule,
  /*  302 */  iRegL_rule,
  /*  303 */  iRegI_rule,
  /*  304 */  iRegI_rule,
  /*  305 */  iRegI_rule,
  /*  306 */  iRegI_rule,
  /*  307 */  iRegI_rule,
  /*  308 */  iRegI_rule,
  /*  309 */  iRegI_rule,
  /*  310 */  iRegI_rule,
  /*  311 */  iRegL_rule,
  /*  312 */  iRegL_rule,
  /*  313 */  iRegL_rule,
  /*  314 */  iRegL_rule,
  /*  315 */  iRegP_rule,
  /*  316 */  iRegN_rule,
  /*  317 */  iRegP_rule,
  /*  318 */  iRegN_rule,
  /*  319 */  vRegF_rule,
  /*  320 */  vRegF_rule,
  /*  321 */  vRegD_rule,
  /*  322 */  vRegD_rule,
  /*  323 */  iRegP_rule,
  /*  324 */  iRegP_rule,
  /*  325 */  _PartialSubtypeCheck_iRegP_R4_iRegP_R0_rule,
  /*  326 */  0,
  /*  327 */  memory_rule,
  /*  328 */  _LoadB_memory__rule,
  /*  329 */  memory_rule,
  /*  330 */  _LoadUB_memory__rule,
  /*  331 */  memory_rule,
  /*  332 */  _LoadS_memory__rule,
  /*  333 */  memory_rule,
  /*  334 */  _LoadUS_memory__rule,
  /*  335 */  memory_rule,
  /*  336 */  _LoadI_memory__rule,
  /*  337 */  _ConvI2L__LoadI_memory___rule,
  /*  338 */  memory_rule,
  /*  339 */  memory_rule,
  /*  340 */  memory_rule,
  /*  341 */  memory_rule,
  /*  342 */  memory_rule,
  /*  343 */  memory_rule,
  /*  344 */  memory_rule,
  /*  345 */  memory_rule,
  /*  346 */  memory_rule,
  /*  347 */  memory_rule,
  /*  348 */  memory_rule,
  /*  349 */  memory_rule,
  /*  350 */  memory_rule,
  /*  351 */  memory_rule,
  /*  352 */  memory_rule,
  /*  353 */  memory_rule,
  /*  354 */  memory_rule,
  /*  355 */  memory_rule,
  /*  356 */  memory_rule,
  /*  357 */  thread_anchor_pc_rule,
  /*  358 */  thread_anchor_pc_rule,
  /*  359 */  memory_rule,
  /*  360 */  memory_rule,
  /*  361 */  memory_rule,
  /*  362 */  memory_rule,
  /*  363 */  memory_rule,
  /*  364 */  memory_rule,
  /*  365 */  memory_rule,
  /*  366 */  memory_rule,
  /*  367 */  indirect_rule,
  /*  368 */  _LoadB_indirect__rule,
  /*  369 */  indirect_rule,
  /*  370 */  _LoadUB_indirect__rule,
  /*  371 */  indirect_rule,
  /*  372 */  indirect_rule,
  /*  373 */  _LoadUS_indirect__rule,
  /*  374 */  _LoadS_indirect__rule,
  /*  375 */  indirect_rule,
  /*  376 */  _ConvI2L__LoadI_indirect___rule,
  /*  377 */  indirect_rule,
  /*  378 */  indirect_rule,
  /*  379 */  indirect_rule,
  /*  380 */  indirect_rule,
  /*  381 */  indirect_rule,
  /*  382 */  iRegI_rule,
  /*  383 */  iRegI_rule,
  /*  384 */  iRegI_rule,
  /*  385 */  iRegI_rule,
  /*  386 */  0,
  /*  387 */  0,
  /*  388 */  0,
  /*  389 */  0,
  /*  390 */  0,
  /*  391 */  0,
  /*  392 */  0,
  /*  393 */  0,
  /*  394 */  0,
  /*  395 */  _CastP2X_iRegP__rule,
  /*  396 */  _CastP2X__DecodeN_iRegN___rule,
  /*  397 */  iRegP_rule,
  /*  398 */  iRegP_rule,
  /*  399 */  iRegN_rule,
  /*  400 */  iRegN_rule,
  /*  401 */  iRegP_rule,
  /*  402 */  iRegN_rule,
  /*  403 */  indirect_rule,
  /*  404 */  indirect_rule,
  /*  405 */  indirect_rule,
  /*  406 */  indirect_rule,
  /*  407 */  indirect_rule,
  /*  408 */  indirect_rule,
  /*  409 */  indirect_rule,
  /*  410 */  indirect_rule,
  /*  411 */  indirect_rule,
  /*  412 */  indirect_rule,
  /*  413 */  indirect_rule,
  /*  414 */  indirect_rule,
  /*  415 */  indirect_rule,
  /*  416 */  indirect_rule,
  /*  417 */  indirect_rule,
  /*  418 */  indirect_rule,
  /*  419 */  indirect_rule,
  /*  420 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  421 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  422 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  423 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  424 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  425 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  426 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  427 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  428 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  429 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  430 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  431 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  432 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  433 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  434 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  435 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  436 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  437 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  438 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  439 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  440 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  441 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  442 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  443 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  444 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  445 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  446 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  447 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  448 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  449 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  450 */  iRegIorL2I_rule,
  /*  451 */  iRegI_rule,
  /*  452 */  _ConvL2I_iRegL__rule,
  /*  453 */  iRegP_rule,
  /*  454 */  iRegP_rule,
  /*  455 */  iRegP_rule,
  /*  456 */  iRegP_rule,
  /*  457 */  _ConvI2L_iRegIorL2I__rule,
  /*  458 */  iRegP_rule,
  /*  459 */  iRegL_rule,
  /*  460 */  iRegL_rule,
  /*  461 */  iRegIorL2I_rule,
  /*  462 */  iRegIorL2I_rule,
  /*  463 */  iRegL_rule,
  /*  464 */  iRegL_rule,
  /*  465 */  immI0_rule,
  /*  466 */  immL0_rule,
  /*  467 */  iRegIorL2I_rule,
  /*  468 */  _ConvI2L_iRegIorL2I__rule,
  /*  469 */  _ConvI2L_iRegIorL2I__rule,
  /*  470 */  iRegL_rule,
  /*  471 */  iRegL_rule,
  /*  472 */  iRegIorL2I_rule,
  /*  473 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  474 */  iRegIorL2I_rule,
  /*  475 */  iRegL_rule,
  /*  476 */  _MulL_iRegL_iRegL_rule,
  /*  477 */  iRegL_rule,
  /*  478 */  iRegIorL2I_rule,
  /*  479 */  _RShiftI_iRegI_immI_31_rule,
  /*  480 */  iRegI_rule,
  /*  481 */  _URShiftI__RShiftI_iRegI_immI_31_immI_31_rule,
  /*  482 */  iRegL_rule,
  /*  483 */  _RShiftL_iRegL_immL_63_rule,
  /*  484 */  iRegL_rule,
  /*  485 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  486 */  iRegIorL2I_rule,
  /*  487 */  iRegL_rule,
  /*  488 */  iRegIorL2I_rule,
  /*  489 */  iRegIorL2I_rule,
  /*  490 */  iRegIorL2I_rule,
  /*  491 */  iRegIorL2I_rule,
  /*  492 */  iRegIorL2I_rule,
  /*  493 */  iRegIorL2I_rule,
  /*  494 */  iRegL_rule,
  /*  495 */  iRegL_rule,
  /*  496 */  iRegL_rule,
  /*  497 */  iRegL_rule,
  /*  498 */  _CastP2X_iRegP__rule,
  /*  499 */  iRegL_rule,
  /*  500 */  iRegL_rule,
  /*  501 */  iRegL_rule,
  /*  502 */  iRegI_rule,
  /*  503 */  iRegI_rule,
  /*  504 */  _XorI_iRegI_immI_M1_rule,
  /*  505 */  iRegL_rule,
  /*  506 */  _XorL_iRegL_immL_M1_rule,
  /*  507 */  iRegI_rule,
  /*  508 */  _XorI_iRegI_immI_M1_rule,
  /*  509 */  iRegL_rule,
  /*  510 */  _XorL_iRegL_immL_M1_rule,
  /*  511 */  immI_M1_rule,
  /*  512 */  _XorI_iRegI_iRegI_rule,
  /*  513 */  immL_M1_rule,
  /*  514 */  _XorL_iRegL_iRegL_rule,
  /*  515 */  iRegI_rule,
  /*  516 */  _XorI__URShiftI_iRegI_immI_immI_M1_rule,
  /*  517 */  iRegL_rule,
  /*  518 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  519 */  iRegI_rule,
  /*  520 */  _XorI__RShiftI_iRegI_immI_immI_M1_rule,
  /*  521 */  iRegL_rule,
  /*  522 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  523 */  iRegI_rule,
  /*  524 */  _XorI__LShiftI_iRegI_immI_immI_M1_rule,
  /*  525 */  iRegL_rule,
  /*  526 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  527 */  immI_M1_rule,
  /*  528 */  _XorI__URShiftI_iRegI_immI_iRegI_rule,
  /*  529 */  immI_M1_rule,
  /*  530 */  _XorI_iRegI__URShiftI_iRegI_immI_rule,
  /*  531 */  immL_M1_rule,
  /*  532 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  533 */  immL_M1_rule,
  /*  534 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  535 */  immI_M1_rule,
  /*  536 */  _XorI__RShiftI_iRegI_immI_iRegI_rule,
  /*  537 */  immI_M1_rule,
  /*  538 */  _XorI_iRegI__RShiftI_iRegI_immI_rule,
  /*  539 */  immL_M1_rule,
  /*  540 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  541 */  immL_M1_rule,
  /*  542 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  543 */  immI_M1_rule,
  /*  544 */  _XorI__LShiftI_iRegI_immI_iRegI_rule,
  /*  545 */  immI_M1_rule,
  /*  546 */  _XorI_iRegI__LShiftI_iRegI_immI_rule,
  /*  547 */  immL_M1_rule,
  /*  548 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  549 */  immL_M1_rule,
  /*  550 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  551 */  iRegI_rule,
  /*  552 */  _XorI__URShiftI_iRegI_immI_immI_M1_rule,
  /*  553 */  iRegL_rule,
  /*  554 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  555 */  iRegI_rule,
  /*  556 */  _XorI__RShiftI_iRegI_immI_immI_M1_rule,
  /*  557 */  iRegL_rule,
  /*  558 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  559 */  iRegI_rule,
  /*  560 */  _XorI__LShiftI_iRegI_immI_immI_M1_rule,
  /*  561 */  iRegL_rule,
  /*  562 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  563 */  iRegI_rule,
  /*  564 */  _URShiftI_iRegI_immI_rule,
  /*  565 */  iRegL_rule,
  /*  566 */  _URShiftL_iRegL_immI_rule,
  /*  567 */  iRegI_rule,
  /*  568 */  _RShiftI_iRegI_immI_rule,
  /*  569 */  iRegL_rule,
  /*  570 */  _RShiftL_iRegL_immI_rule,
  /*  571 */  iRegI_rule,
  /*  572 */  _LShiftI_iRegI_immI_rule,
  /*  573 */  iRegL_rule,
  /*  574 */  _LShiftL_iRegL_immI_rule,
  /*  575 */  iRegI_rule,
  /*  576 */  _URShiftI_iRegI_immI_rule,
  /*  577 */  iRegL_rule,
  /*  578 */  _URShiftL_iRegL_immI_rule,
  /*  579 */  iRegI_rule,
  /*  580 */  _RShiftI_iRegI_immI_rule,
  /*  581 */  iRegL_rule,
  /*  582 */  _RShiftL_iRegL_immI_rule,
  /*  583 */  iRegI_rule,
  /*  584 */  _LShiftI_iRegI_immI_rule,
  /*  585 */  iRegL_rule,
  /*  586 */  _LShiftL_iRegL_immI_rule,
  /*  587 */  iRegI_rule,
  /*  588 */  _URShiftI_iRegI_immI_rule,
  /*  589 */  iRegL_rule,
  /*  590 */  _URShiftL_iRegL_immI_rule,
  /*  591 */  iRegI_rule,
  /*  592 */  _RShiftI_iRegI_immI_rule,
  /*  593 */  iRegL_rule,
  /*  594 */  _RShiftL_iRegL_immI_rule,
  /*  595 */  iRegI_rule,
  /*  596 */  _LShiftI_iRegI_immI_rule,
  /*  597 */  iRegL_rule,
  /*  598 */  _LShiftL_iRegL_immI_rule,
  /*  599 */  iRegI_rule,
  /*  600 */  _URShiftI_iRegI_immI_rule,
  /*  601 */  iRegL_rule,
  /*  602 */  _URShiftL_iRegL_immI_rule,
  /*  603 */  iRegI_rule,
  /*  604 */  _RShiftI_iRegI_immI_rule,
  /*  605 */  iRegL_rule,
  /*  606 */  _RShiftL_iRegL_immI_rule,
  /*  607 */  iRegI_rule,
  /*  608 */  _LShiftI_iRegI_immI_rule,
  /*  609 */  iRegL_rule,
  /*  610 */  _LShiftL_iRegL_immI_rule,
  /*  611 */  iRegI_rule,
  /*  612 */  iRegL_rule,
  /*  613 */  iRegI_rule,
  /*  614 */  iRegL_rule,
  /*  615 */  iRegI_rule,
  /*  616 */  iRegL_rule,
  /*  617 */  _LShiftL_iRegL_immI_rule,
  /*  618 */  _LShiftI_iRegI_immI_rule,
  /*  619 */  _LShiftL_iRegL_immI_rule,
  /*  620 */  _LShiftI_iRegI_immI_rule,
  /*  621 */  _URShiftI_iRegI_immI_rule,
  /*  622 */  _URShiftL_iRegL_immI_rule,
  /*  623 */  _AndI__URShiftI_iRegIorL2I_immI_immI_bitmask_rule,
  /*  624 */  _LShiftL_iRegL_immI_rule,
  /*  625 */  _URShiftL_iRegL_immI_rule,
  /*  626 */  _LShiftI_iRegI_immI_rule,
  /*  627 */  _URShiftI_iRegI_immI_rule,
  /*  628 */  _LShiftL_iRegL_immI_rule,
  /*  629 */  _URShiftL_iRegL_immI_rule,
  /*  630 */  _LShiftI_iRegI_immI_rule,
  /*  631 */  _URShiftI_iRegI_immI_rule,
  /*  632 */  0,
  /*  633 */  0,
  /*  634 */  _LShiftL_iRegL_iRegI_rule,
  /*  635 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  636 */  _LShiftL_iRegL_iRegI_rule,
  /*  637 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  638 */  _LShiftI_iRegL_iRegI_rule,
  /*  639 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  640 */  _LShiftI_iRegL_iRegI_rule,
  /*  641 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  642 */  0,
  /*  643 */  0,
  /*  644 */  _URShiftL_iRegL_iRegI_rule,
  /*  645 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  646 */  _URShiftL_iRegL_iRegI_rule,
  /*  647 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  648 */  _URShiftI_iRegL_iRegI_rule,
  /*  649 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  650 */  _URShiftI_iRegL_iRegI_rule,
  /*  651 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  652 */  iRegL_rule,
  /*  653 */  _ConvI2L_iRegIorL2I__rule,
  /*  654 */  iRegL_rule,
  /*  655 */  iRegI_rule,
  /*  656 */  _RShiftI__LShiftI_iRegI_immI_16_immI_16_rule,
  /*  657 */  iRegI_rule,
  /*  658 */  _RShiftI__LShiftI_iRegI_immI_24_immI_24_rule,
  /*  659 */  iRegI_rule,
  /*  660 */  _URShiftI__LShiftI_iRegI_immI_24_immI_24_rule,
  /*  661 */  iRegL_rule,
  /*  662 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  663 */  iRegL_rule,
  /*  664 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  665 */  iRegL_rule,
  /*  666 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  667 */  iRegL_rule,
  /*  668 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  669 */  iRegI_rule,
  /*  670 */  _AndI_iRegI_immI_255_rule,
  /*  671 */  iRegI_rule,
  /*  672 */  _AndI_iRegI_immI_65535_rule,
  /*  673 */  iRegL_rule,
  /*  674 */  _AndL_iRegL_immL_255_rule,
  /*  675 */  iRegL_rule,
  /*  676 */  _AndL_iRegL_immL_65535_rule,
  /*  677 */  iRegL_rule,
  /*  678 */  _AndL_iRegL_immL_4294967295_rule,
  /*  679 */  iRegI_rule,
  /*  680 */  iRegI_rule,
  /*  681 */  iRegL_rule,
  /*  682 */  iRegL_rule,
  /*  683 */  iRegL_rule,
  /*  684 */  vRegF_rule,
  /*  685 */  vRegD_rule,
  /*  686 */  vRegF_rule,
  /*  687 */  vRegD_rule,
  /*  688 */  vRegF_rule,
  /*  689 */  vRegD_rule,
  /*  690 */  vRegF_rule,
  /*  691 */  vRegD_rule,
  /*  692 */  vRegD_rule,
  /*  693 */  _SqrtD__ConvF2D_vRegF___rule,
  /*  694 */  iRegIorL2I_rule,
  /*  695 */  iRegIorL2I_rule,
  /*  696 */  iRegIorL2I_rule,
  /*  697 */  iRegIorL2I_rule,
  /*  698 */  iRegIorL2I_rule,
  /*  699 */  iRegIorL2I_rule,
  /*  700 */  iRegL_rule,
  /*  701 */  iRegL_rule,
  /*  702 */  iRegL_rule,
  /*  703 */  iRegL_rule,
  /*  704 */  iRegL_rule,
  /*  705 */  iRegL_rule,
  /*  706 */  iRegIorL2I_rule,
  /*  707 */  _ConvI2L_iRegI__rule,
  /*  708 */  iRegL_rule,
  /*  709 */  iRegI_rule,
  /*  710 */  iRegP_rule,
  /*  711 */  vRegD_rule,
  /*  712 */  vRegF_rule,
  /*  713 */  vRegF_rule,
  /*  714 */  vRegF_rule,
  /*  715 */  iRegI_rule,
  /*  716 */  iRegL_rule,
  /*  717 */  vRegD_rule,
  /*  718 */  vRegD_rule,
  /*  719 */  iRegI_rule,
  /*  720 */  iRegL_rule,
  /*  721 */  vRegF_rule,
  /*  722 */  iRegI_rule,
  /*  723 */  vRegD_rule,
  /*  724 */  iRegL_rule,
  /*  725 */  iRegL_R11_rule,
  /*  726 */  cmpOp_rule,
  /*  727 */  cmpOp_rule,
  /*  728 */  vRegF_rule,
  /*  729 */  vRegD_rule,
  /*  730 */  vRegF_rule,
  /*  731 */  vRegD_rule,
  /*  732 */  iRegL_rule,
  /*  733 */  iRegI_rule,
  /*  734 */  iRegI_rule,
  /*  735 */  iRegI_rule,
  /*  736 */  iRegI_rule,
  /*  737 */  0,
  /*  738 */  cmpOp_rule,
  /*  739 */  cmpOpU_rule,
  /*  740 */  cmpOp_rule,
  /*  741 */  cmpOp_rule,
  /*  742 */  cmpOp_rule,
  /*  743 */  cmpOp_rule,
  /*  744 */  cmpOpU_rule,
  /*  745 */  iRegP_rule,
  /*  746 */  0,
  /*  747 */  0,
  /*  748 */  0,
  /*  749 */  0,
  /*  750 */  0,
  /*  751 */  0,
  /*  752 */  iRegPNoSp_rule,
  /*  753 */  iRegPNoSp_rule,
  /*  754 */  0,
  /*  755 */  0,
  /*  756 */  0,
  /*  757 */  0,
  /*  758 */  iRegP_R4_rule,
  /*  759 */  _Binary_iRegP_R1_iRegI_R2_rule,
  /*  760 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  761 */  _Binary_iRegP_R1_iRegI_R4_rule,
  /*  762 */  _Binary_iRegP_R1_iRegP_R3_rule,
  /*  763 */  iRegP_R1_rule,
  /*  764 */  iRegP_R2_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  immIU12_rule,
  /*   98 */  immLU12_rule,
  /*   99 */  immLU12_rule,
  /*  100 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  101 */  _LShiftL_iRegL_immIScale_rule,
  /*  102 */  iRegL_rule,
  /*  103 */  immIOffset_rule,
  /*  104 */  immLoffset_rule,
  /*  105 */  0,
  /*  106 */  immIU12_rule,
  /*  107 */  immLU12_rule,
  /*  108 */  immLU12_rule,
  /*  109 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  110 */  _LShiftL_iRegL_immIScale_rule,
  /*  111 */  iRegL_rule,
  /*  112 */  immIOffset_rule,
  /*  113 */  immLoffset_rule,
  /*  114 */  immL_pc_off_rule,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  // last operand
  /*  123 */  0,
  /*  124 */  0,
  // last operand class
  /*  125 */  immIScale_rule,
  /*  126 */  _LShiftL_iRegL_immIScale_rule,
  /*  127 */  0,
  /*  128 */  immIScale_rule,
  /*  129 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  130 */  0,
  /*  131 */  _LShiftL_iRegL_immIScale_rule,
  /*  132 */  _LShiftL__ConvI2L_iRegI__immIScale_rule,
  /*  133 */  0,
  /*  134 */  0,
  /*  135 */  0,
  /*  136 */  0,
  /*  137 */  0,
  /*  138 */  0,
  /*  139 */  0,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  0,
  /*  143 */  0,
  /*  144 */  0,
  /*  145 */  0,
  /*  146 */  0,
  /*  147 */  iRegP_rule,
  /*  148 */  iRegLNoSp_rule,
  /*  149 */  iRegINoSp_rule,
  /*  150 */  iRegNNoSp_rule,
  /*  151 */  rFlagsReg_rule,
  /*  152 */  iRegI_rule,
  /*  153 */  rFlagsRegU_rule,
  /*  154 */  iRegI_rule,
  /*  155 */  immI0_rule,
  /*  156 */  immI0_rule,
  /*  157 */  iRegL_rule,
  /*  158 */  immL0_rule,
  /*  159 */  iRegL_rule,
  /*  160 */  immP0_rule,
  /*  161 */  iRegP_rule,
  /*  162 */  iRegN_rule,
  /*  163 */  immN0_rule,
  /*  164 */  iRegN_rule,
  /*  165 */  vRegF_rule,
  /*  166 */  vRegD_rule,
  /*  167 */  0,
  /*  168 */  0,
  /*  169 */  immIScale_rule,
  /*  170 */  iRegIorL2I_rule,
  /*  171 */  iRegL_rule,
  /*  172 */  immI_31_rule,
  /*  173 */  immI_31_rule,
  /*  174 */  immL_63_rule,
  /*  175 */  immL_63_rule,
  /*  176 */  immI_M1_rule,
  /*  177 */  immL_M1_rule,
  /*  178 */  iRegI_rule,
  /*  179 */  iRegL_rule,
  /*  180 */  immI_rule,
  /*  181 */  immI_M1_rule,
  /*  182 */  immI_rule,
  /*  183 */  immL_M1_rule,
  /*  184 */  immI_rule,
  /*  185 */  immI_M1_rule,
  /*  186 */  immI_rule,
  /*  187 */  immL_M1_rule,
  /*  188 */  immI_rule,
  /*  189 */  immI_M1_rule,
  /*  190 */  immI_rule,
  /*  191 */  immL_M1_rule,
  /*  192 */  iRegI_rule,
  /*  193 */  _URShiftI_iRegI_immI_rule,
  /*  194 */  iRegL_rule,
  /*  195 */  _URShiftL_iRegL_immI_rule,
  /*  196 */  iRegI_rule,
  /*  197 */  _RShiftI_iRegI_immI_rule,
  /*  198 */  iRegL_rule,
  /*  199 */  _RShiftL_iRegL_immI_rule,
  /*  200 */  iRegI_rule,
  /*  201 */  _LShiftI_iRegI_immI_rule,
  /*  202 */  iRegL_rule,
  /*  203 */  _LShiftL_iRegL_immI_rule,
  /*  204 */  immI_rule,
  /*  205 */  immI_bitmask_rule,
  /*  206 */  iRegI_rule,
  /*  207 */  iRegI_rule,
  /*  208 */  _SubI_immI_64_iRegI_rule,
  /*  209 */  iRegI_rule,
  /*  210 */  _SubI_immI0_iRegI_rule,
  /*  211 */  iRegI_rule,
  /*  212 */  iRegI_rule,
  /*  213 */  _SubI_immI_32_iRegI_rule,
  /*  214 */  _SubI_immI0_iRegI_rule,
  /*  215 */  iRegI_rule,
  /*  216 */  _SubI_immI_64_iRegI_rule,
  /*  217 */  _SubI_immI0_iRegI_rule,
  /*  218 */  iRegI_rule,
  /*  219 */  _SubI_immI_32_iRegI_rule,
  /*  220 */  _SubI_immI0_iRegI_rule,
  /*  221 */  immI_16_rule,
  /*  222 */  immI_16_rule,
  /*  223 */  immI_24_rule,
  /*  224 */  immI_24_rule,
  /*  225 */  immI_24_rule,
  /*  226 */  immI_48_rule,
  /*  227 */  immI_48_rule,
  /*  228 */  immI_32_rule,
  /*  229 */  immI_32_rule,
  /*  230 */  immI_56_rule,
  /*  231 */  immI_56_rule,
  /*  232 */  immI_56_rule,
  /*  233 */  immI_255_rule,
  /*  234 */  immI_65535_rule,
  /*  235 */  immL_255_rule,
  /*  236 */  immL_65535_rule,
  /*  237 */  immL_4294967295_rule,
  /*  238 */  0,
  /*  239 */  0,
  /*  240 */  iRegI_rule,
  /*  241 */  iRegL_rule,
  /*  242 */  immI0_rule,
  /*  243 */  immL0_rule,
  /*  244 */  immP0_rule,
  /*  245 */  iRegP_R0_rule,
  /*  246 */  iRegI_R2_rule,
  /*  247 */  iRegI_R4_rule,
  /*  248 */  iRegI_R4_rule,
  /*  249 */  iRegI_R2_rule,
  /*  250 */  immI_le_4_rule,
  /*  251 */  iRegP_R3_rule,
  /*  252 */  iRegI_R3_rule,
  // last internally defined operand
  /*  253 */  0,
  /*  254 */  0,
  /*  255 */  0,
  /*  256 */  0,
  /*  257 */  0,
  /*  258 */  0,
  /*  259 */  0,
  /*  260 */  0,
  /*  261 */  0,
  /*  262 */  0,
  /*  263 */  0,
  /*  264 */  0,
  /*  265 */  0,
  /*  266 */  0,
  /*  267 */  0,
  /*  268 */  0,
  /*  269 */  0,
  /*  270 */  0,
  /*  271 */  0,
  /*  272 */  0,
  /*  273 */  0,
  /*  274 */  0,
  /*  275 */  0,
  /*  276 */  _Binary_iRegP_iRegP_rule,
  /*  277 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  278 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  279 */  0,
  /*  280 */  0,
  /*  281 */  0,
  /*  282 */  0,
  /*  283 */  0,
  /*  284 */  0,
  /*  285 */  0,
  /*  286 */  0,
  /*  287 */  0,
  /*  288 */  0,
  /*  289 */  0,
  /*  290 */  0,
  /*  291 */  iRegI_rule,
  /*  292 */  immIAddSub_rule,
  /*  293 */  iRegL_rule,
  /*  294 */  immLAddSub_rule,
  /*  295 */  iRegI_rule,
  /*  296 */  immIAddSub_rule,
  /*  297 */  iRegL_rule,
  /*  298 */  immLAddSub_rule,
  /*  299 */  iRegI_rule,
  /*  300 */  iRegL_rule,
  /*  301 */  iRegI_rule,
  /*  302 */  iRegL_rule,
  /*  303 */  iRegI_rule,
  /*  304 */  immI0_rule,
  /*  305 */  immIAddSub_rule,
  /*  306 */  immI_rule,
  /*  307 */  iRegI_rule,
  /*  308 */  immI0_rule,
  /*  309 */  immIAddSub_rule,
  /*  310 */  immI_rule,
  /*  311 */  iRegL_rule,
  /*  312 */  immI0_rule,
  /*  313 */  immLAddSub_rule,
  /*  314 */  immL_rule,
  /*  315 */  iRegP_rule,
  /*  316 */  iRegN_rule,
  /*  317 */  immP0_rule,
  /*  318 */  immN0_rule,
  /*  319 */  vRegF_rule,
  /*  320 */  immF0_rule,
  /*  321 */  vRegD_rule,
  /*  322 */  immD0_rule,
  /*  323 */  iRegP_rule,
  /*  324 */  iRegP_rule,
  /*  325 */  immP0_rule,
  /*  326 */  0,
  /*  327 */  0,
  /*  328 */  0,
  /*  329 */  0,
  /*  330 */  0,
  /*  331 */  0,
  /*  332 */  0,
  /*  333 */  0,
  /*  334 */  0,
  /*  335 */  0,
  /*  336 */  0,
  /*  337 */  immL_32bits_rule,
  /*  338 */  0,
  /*  339 */  0,
  /*  340 */  0,
  /*  341 */  0,
  /*  342 */  0,
  /*  343 */  0,
  /*  344 */  0,
  /*  345 */  0,
  /*  346 */  immI0_rule,
  /*  347 */  iRegI_rule,
  /*  348 */  immI0_rule,
  /*  349 */  iRegI_rule,
  /*  350 */  immI0_rule,
  /*  351 */  iRegIorL2I_rule,
  /*  352 */  immI0_rule,
  /*  353 */  iRegL_rule,
  /*  354 */  immL0_rule,
  /*  355 */  iRegP_rule,
  /*  356 */  immP0_rule,
  /*  357 */  immP_M1_rule,
  /*  358 */  immP_M2_rule,
  /*  359 */  iRegN_rule,
  /*  360 */  immN0_rule,
  /*  361 */  vRegF_rule,
  /*  362 */  vRegD_rule,
  /*  363 */  iRegN_rule,
  /*  364 */  0,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  immL_32bits_rule,
  /*  377 */  0,
  /*  378 */  0,
  /*  379 */  0,
  /*  380 */  0,
  /*  381 */  0,
  /*  382 */  0,
  /*  383 */  0,
  /*  384 */  0,
  /*  385 */  0,
  /*  386 */  0,
  /*  387 */  0,
  /*  388 */  0,
  /*  389 */  0,
  /*  390 */  0,
  /*  391 */  0,
  /*  392 */  0,
  /*  393 */  0,
  /*  394 */  0,
  /*  395 */  0,
  /*  396 */  0,
  /*  397 */  0,
  /*  398 */  0,
  /*  399 */  0,
  /*  400 */  0,
  /*  401 */  0,
  /*  402 */  0,
  /*  403 */  0,
  /*  404 */  _Binary_iRegINoSp_iRegINoSp_rule,
  /*  405 */  _Binary_iRegLNoSp_iRegLNoSp_rule,
  /*  406 */  _Binary_iRegP_iRegP_rule,
  /*  407 */  _Binary_iRegNNoSp_iRegNNoSp_rule,
  /*  408 */  iRegINoSp_rule,
  /*  409 */  iRegLNoSp_rule,
  /*  410 */  iRegNNoSp_rule,
  /*  411 */  iRegPNoSp_rule,
  /*  412 */  iRegL_rule,
  /*  413 */  iRegL_rule,
  /*  414 */  immLAddSub_rule,
  /*  415 */  immLAddSub_rule,
  /*  416 */  iRegIorL2I_rule,
  /*  417 */  iRegIorL2I_rule,
  /*  418 */  immIAddSub_rule,
  /*  419 */  immIAddSub_rule,
  /*  420 */  _Binary_iRegI_iRegI_rule,
  /*  421 */  _Binary_iRegI_iRegI_rule,
  /*  422 */  _Binary_immI0_iRegI_rule,
  /*  423 */  _Binary_immI0_iRegI_rule,
  /*  424 */  _Binary_iRegI_immI0_rule,
  /*  425 */  _Binary_iRegI_immI0_rule,
  /*  426 */  _Binary_immI_1_immI0_rule,
  /*  427 */  _Binary_immI_1_immI0_rule,
  /*  428 */  _Binary_iRegL_iRegL_rule,
  /*  429 */  _Binary_iRegL_iRegL_rule,
  /*  430 */  _Binary_iRegL_immL0_rule,
  /*  431 */  _Binary_iRegL_immL0_rule,
  /*  432 */  _Binary_immL0_iRegL_rule,
  /*  433 */  _Binary_immL0_iRegL_rule,
  /*  434 */  _Binary_iRegP_iRegP_rule,
  /*  435 */  _Binary_iRegP_iRegP_rule,
  /*  436 */  _Binary_iRegP_immP0_rule,
  /*  437 */  _Binary_iRegP_immP0_rule,
  /*  438 */  _Binary_immP0_iRegP_rule,
  /*  439 */  _Binary_immP0_iRegP_rule,
  /*  440 */  _Binary_iRegN_iRegN_rule,
  /*  441 */  _Binary_iRegN_iRegN_rule,
  /*  442 */  _Binary_iRegN_immN0_rule,
  /*  443 */  _Binary_iRegN_immN0_rule,
  /*  444 */  _Binary_immN0_iRegN_rule,
  /*  445 */  _Binary_immN0_iRegN_rule,
  /*  446 */  _Binary_vRegF_vRegF_rule,
  /*  447 */  _Binary_vRegF_vRegF_rule,
  /*  448 */  _Binary_vRegD_vRegD_rule,
  /*  449 */  _Binary_vRegD_vRegD_rule,
  /*  450 */  iRegIorL2I_rule,
  /*  451 */  immIAddSub_rule,
  /*  452 */  immIAddSub_rule,
  /*  453 */  iRegL_rule,
  /*  454 */  _ConvI2L_iRegIorL2I__rule,
  /*  455 */  _LShiftL_iRegL_immIScale_rule,
  /*  456 */  _LShiftL__ConvI2L_iRegIorL2I__immIScale_rule,
  /*  457 */  immI_rule,
  /*  458 */  immLAddSub_rule,
  /*  459 */  iRegL_rule,
  /*  460 */  immLAddSub_rule,
  /*  461 */  iRegIorL2I_rule,
  /*  462 */  immIAddSub_rule,
  /*  463 */  iRegL_rule,
  /*  464 */  immLAddSub_rule,
  /*  465 */  iRegIorL2I_rule,
  /*  466 */  iRegIorL2I_rule,
  /*  467 */  iRegIorL2I_rule,
  /*  468 */  _ConvI2L_iRegIorL2I__rule,
  /*  469 */  _ConvI2L_iRegIorL2I__rule,
  /*  470 */  iRegL_rule,
  /*  471 */  iRegL_rule,
  /*  472 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  473 */  iRegIorL2I_rule,
  /*  474 */  _MulI_iRegIorL2I_iRegIorL2I_rule,
  /*  475 */  _MulL_iRegL_iRegL_rule,
  /*  476 */  iRegL_rule,
  /*  477 */  _MulL_iRegL_iRegL_rule,
  /*  478 */  iRegIorL2I_rule,
  /*  479 */  immI_31_rule,
  /*  480 */  _URShiftI__RShiftI_iRegI_immI_31_immI_31_rule,
  /*  481 */  iRegI_rule,
  /*  482 */  iRegL_rule,
  /*  483 */  immL_63_rule,
  /*  484 */  _URShiftL__RShiftL_iRegL_immL_63_immL_63_rule,
  /*  485 */  iRegL_rule,
  /*  486 */  iRegIorL2I_rule,
  /*  487 */  iRegL_rule,
  /*  488 */  iRegIorL2I_rule,
  /*  489 */  immI_rule,
  /*  490 */  iRegIorL2I_rule,
  /*  491 */  immI_rule,
  /*  492 */  iRegIorL2I_rule,
  /*  493 */  immI_rule,
  /*  494 */  iRegIorL2I_rule,
  /*  495 */  immI_rule,
  /*  496 */  iRegIorL2I_rule,
  /*  497 */  immI_rule,
  /*  498 */  immI_rule,
  /*  499 */  iRegIorL2I_rule,
  /*  500 */  immI_rule,
  /*  501 */  immL_M1_rule,
  /*  502 */  immI_M1_rule,
  /*  503 */  _XorI_iRegI_immI_M1_rule,
  /*  504 */  iRegI_rule,
  /*  505 */  _XorL_iRegL_immL_M1_rule,
  /*  506 */  iRegL_rule,
  /*  507 */  _XorI_iRegI_immI_M1_rule,
  /*  508 */  iRegI_rule,
  /*  509 */  _XorL_iRegL_immL_M1_rule,
  /*  510 */  iRegL_rule,
  /*  511 */  _XorI_iRegI_iRegI_rule,
  /*  512 */  immI_M1_rule,
  /*  513 */  _XorL_iRegL_iRegL_rule,
  /*  514 */  immL_M1_rule,
  /*  515 */  _XorI__URShiftI_iRegI_immI_immI_M1_rule,
  /*  516 */  iRegI_rule,
  /*  517 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  518 */  iRegL_rule,
  /*  519 */  _XorI__RShiftI_iRegI_immI_immI_M1_rule,
  /*  520 */  iRegI_rule,
  /*  521 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  522 */  iRegL_rule,
  /*  523 */  _XorI__LShiftI_iRegI_immI_immI_M1_rule,
  /*  524 */  iRegI_rule,
  /*  525 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  526 */  iRegL_rule,
  /*  527 */  _XorI__URShiftI_iRegI_immI_iRegI_rule,
  /*  528 */  immI_M1_rule,
  /*  529 */  _XorI_iRegI__URShiftI_iRegI_immI_rule,
  /*  530 */  immI_M1_rule,
  /*  531 */  _XorL__URShiftL_iRegL_immI_iRegL_rule,
  /*  532 */  immL_M1_rule,
  /*  533 */  _XorL_iRegL__URShiftL_iRegL_immI_rule,
  /*  534 */  immL_M1_rule,
  /*  535 */  _XorI__RShiftI_iRegI_immI_iRegI_rule,
  /*  536 */  immI_M1_rule,
  /*  537 */  _XorI_iRegI__RShiftI_iRegI_immI_rule,
  /*  538 */  immI_M1_rule,
  /*  539 */  _XorL__RShiftL_iRegL_immI_iRegL_rule,
  /*  540 */  immL_M1_rule,
  /*  541 */  _XorL_iRegL__RShiftL_iRegL_immI_rule,
  /*  542 */  immL_M1_rule,
  /*  543 */  _XorI__LShiftI_iRegI_immI_iRegI_rule,
  /*  544 */  immI_M1_rule,
  /*  545 */  _XorI_iRegI__LShiftI_iRegI_immI_rule,
  /*  546 */  immI_M1_rule,
  /*  547 */  _XorL__LShiftL_iRegL_immI_iRegL_rule,
  /*  548 */  immL_M1_rule,
  /*  549 */  _XorL_iRegL__LShiftL_iRegL_immI_rule,
  /*  550 */  immL_M1_rule,
  /*  551 */  _XorI__URShiftI_iRegI_immI_immI_M1_rule,
  /*  552 */  iRegI_rule,
  /*  553 */  _XorL__URShiftL_iRegL_immI_immL_M1_rule,
  /*  554 */  iRegL_rule,
  /*  555 */  _XorI__RShiftI_iRegI_immI_immI_M1_rule,
  /*  556 */  iRegI_rule,
  /*  557 */  _XorL__RShiftL_iRegL_immI_immL_M1_rule,
  /*  558 */  iRegL_rule,
  /*  559 */  _XorI__LShiftI_iRegI_immI_immI_M1_rule,
  /*  560 */  iRegI_rule,
  /*  561 */  _XorL__LShiftL_iRegL_immI_immL_M1_rule,
  /*  562 */  iRegL_rule,
  /*  563 */  _URShiftI_iRegI_immI_rule,
  /*  564 */  iRegI_rule,
  /*  565 */  _URShiftL_iRegL_immI_rule,
  /*  566 */  iRegL_rule,
  /*  567 */  _RShiftI_iRegI_immI_rule,
  /*  568 */  iRegI_rule,
  /*  569 */  _RShiftL_iRegL_immI_rule,
  /*  570 */  iRegL_rule,
  /*  571 */  _LShiftI_iRegI_immI_rule,
  /*  572 */  iRegI_rule,
  /*  573 */  _LShiftL_iRegL_immI_rule,
  /*  574 */  iRegL_rule,
  /*  575 */  _URShiftI_iRegI_immI_rule,
  /*  576 */  iRegI_rule,
  /*  577 */  _URShiftL_iRegL_immI_rule,
  /*  578 */  iRegL_rule,
  /*  579 */  _RShiftI_iRegI_immI_rule,
  /*  580 */  iRegI_rule,
  /*  581 */  _RShiftL_iRegL_immI_rule,
  /*  582 */  iRegL_rule,
  /*  583 */  _LShiftI_iRegI_immI_rule,
  /*  584 */  iRegI_rule,
  /*  585 */  _LShiftL_iRegL_immI_rule,
  /*  586 */  iRegL_rule,
  /*  587 */  _URShiftI_iRegI_immI_rule,
  /*  588 */  iRegI_rule,
  /*  589 */  _URShiftL_iRegL_immI_rule,
  /*  590 */  iRegL_rule,
  /*  591 */  _RShiftI_iRegI_immI_rule,
  /*  592 */  iRegI_rule,
  /*  593 */  _RShiftL_iRegL_immI_rule,
  /*  594 */  iRegL_rule,
  /*  595 */  _LShiftI_iRegI_immI_rule,
  /*  596 */  iRegI_rule,
  /*  597 */  _LShiftL_iRegL_immI_rule,
  /*  598 */  iRegL_rule,
  /*  599 */  _URShiftI_iRegI_immI_rule,
  /*  600 */  iRegI_rule,
  /*  601 */  _URShiftL_iRegL_immI_rule,
  /*  602 */  iRegL_rule,
  /*  603 */  _RShiftI_iRegI_immI_rule,
  /*  604 */  iRegI_rule,
  /*  605 */  _RShiftL_iRegL_immI_rule,
  /*  606 */  iRegL_rule,
  /*  607 */  _LShiftI_iRegI_immI_rule,
  /*  608 */  iRegI_rule,
  /*  609 */  _LShiftL_iRegL_immI_rule,
  /*  610 */  iRegL_rule,
  /*  611 */  _URShiftI_iRegI_immI_rule,
  /*  612 */  _URShiftL_iRegL_immI_rule,
  /*  613 */  _RShiftI_iRegI_immI_rule,
  /*  614 */  _RShiftL_iRegL_immI_rule,
  /*  615 */  _LShiftI_iRegI_immI_rule,
  /*  616 */  _LShiftL_iRegL_immI_rule,
  /*  617 */  immI_rule,
  /*  618 */  immI_rule,
  /*  619 */  immI_rule,
  /*  620 */  immI_rule,
  /*  621 */  immI_bitmask_rule,
  /*  622 */  immL_bitmask_rule,
  /*  623 */  0,
  /*  624 */  _URShiftL_iRegL_immI_rule,
  /*  625 */  _LShiftL_iRegL_immI_rule,
  /*  626 */  _URShiftI_iRegI_immI_rule,
  /*  627 */  _LShiftI_iRegI_immI_rule,
  /*  628 */  _URShiftL_iRegL_immI_rule,
  /*  629 */  _LShiftL_iRegL_immI_rule,
  /*  630 */  _URShiftI_iRegI_immI_rule,
  /*  631 */  _LShiftI_iRegI_immI_rule,
  /*  632 */  0,
  /*  633 */  0,
  /*  634 */  _URShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  635 */  _LShiftL_iRegL_iRegI_rule,
  /*  636 */  _URShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  637 */  _LShiftL_iRegL_iRegI_rule,
  /*  638 */  _URShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  639 */  _LShiftI_iRegL_iRegI_rule,
  /*  640 */  _URShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  641 */  _LShiftI_iRegL_iRegI_rule,
  /*  642 */  0,
  /*  643 */  0,
  /*  644 */  _LShiftL_iRegL__SubI_immI_64_iRegI_rule,
  /*  645 */  _URShiftL_iRegL_iRegI_rule,
  /*  646 */  _LShiftL_iRegL__SubI_immI0_iRegI_rule,
  /*  647 */  _URShiftL_iRegL_iRegI_rule,
  /*  648 */  _LShiftI_iRegL__SubI_immI_32_iRegI_rule,
  /*  649 */  _URShiftI_iRegL_iRegI_rule,
  /*  650 */  _LShiftI_iRegL__SubI_immI0_iRegI_rule,
  /*  651 */  _URShiftI_iRegL_iRegI_rule,
  /*  652 */  _ConvI2L_iRegIorL2I__rule,
  /*  653 */  iRegL_rule,
  /*  654 */  _ConvI2L_iRegIorL2I__rule,
  /*  655 */  _RShiftI__LShiftI_iRegI_immI_16_immI_16_rule,
  /*  656 */  iRegI_rule,
  /*  657 */  _RShiftI__LShiftI_iRegI_immI_24_immI_24_rule,
  /*  658 */  iRegI_rule,
  /*  659 */  _URShiftI__LShiftI_iRegI_immI_24_immI_24_rule,
  /*  660 */  iRegI_rule,
  /*  661 */  _RShiftL__LShiftL_iRegL_immI_48_immI_48_rule,
  /*  662 */  iRegL_rule,
  /*  663 */  _RShiftL__LShiftL_iRegL_immI_32_immI_32_rule,
  /*  664 */  iRegL_rule,
  /*  665 */  _RShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  666 */  iRegL_rule,
  /*  667 */  _URShiftL__LShiftL_iRegL_immI_56_immI_56_rule,
  /*  668 */  iRegL_rule,
  /*  669 */  _AndI_iRegI_immI_255_rule,
  /*  670 */  iRegI_rule,
  /*  671 */  _AndI_iRegI_immI_65535_rule,
  /*  672 */  iRegI_rule,
  /*  673 */  _AndL_iRegL_immL_255_rule,
  /*  674 */  iRegL_rule,
  /*  675 */  _AndL_iRegL_immL_65535_rule,
  /*  676 */  iRegL_rule,
  /*  677 */  _AndL_iRegL_immL_4294967295_rule,
  /*  678 */  iRegL_rule,
  /*  679 */  _AndI_iRegI_immI_255_rule,
  /*  680 */  _AndI_iRegI_immI_65535_rule,
  /*  681 */  _AndL_iRegL_immL_255_rule,
  /*  682 */  _AndL_iRegL_immL_65535_rule,
  /*  683 */  _AndL_iRegL_immL_4294967295_rule,
  /*  684 */  vRegF_rule,
  /*  685 */  vRegD_rule,
  /*  686 */  vRegF_rule,
  /*  687 */  vRegD_rule,
  /*  688 */  vRegF_rule,
  /*  689 */  vRegD_rule,
  /*  690 */  vRegF_rule,
  /*  691 */  vRegD_rule,
  /*  692 */  0,
  /*  693 */  0,
  /*  694 */  iRegIorL2I_rule,
  /*  695 */  immILog_rule,
  /*  696 */  iRegIorL2I_rule,
  /*  697 */  immILog_rule,
  /*  698 */  iRegIorL2I_rule,
  /*  699 */  immILog_rule,
  /*  700 */  iRegL_rule,
  /*  701 */  immLLog_rule,
  /*  702 */  iRegL_rule,
  /*  703 */  immLLog_rule,
  /*  704 */  iRegL_rule,
  /*  705 */  immLLog_rule,
  /*  706 */  0,
  /*  707 */  immL_32bits_rule,
  /*  708 */  0,
  /*  709 */  0,
  /*  710 */  0,
  /*  711 */  0,
  /*  712 */  0,
  /*  713 */  0,
  /*  714 */  0,
  /*  715 */  0,
  /*  716 */  0,
  /*  717 */  0,
  /*  718 */  0,
  /*  719 */  0,
  /*  720 */  0,
  /*  721 */  0,
  /*  722 */  0,
  /*  723 */  0,
  /*  724 */  0,
  /*  725 */  iRegP_R10_rule,
  /*  726 */  _OverflowMulI_iRegI_iRegI_rule,
  /*  727 */  _OverflowMulL_iRegL_iRegL_rule,
  /*  728 */  vRegF_rule,
  /*  729 */  vRegD_rule,
  /*  730 */  immF0_rule,
  /*  731 */  immD0_rule,
  /*  732 */  iRegL_rule,
  /*  733 */  iRegI_rule,
  /*  734 */  immI0_rule,
  /*  735 */  iRegI_rule,
  /*  736 */  iRegI_rule,
  /*  737 */  0,
  /*  738 */  rFlagsReg_rule,
  /*  739 */  rFlagsRegU_rule,
  /*  740 */  _CmpI_iRegI_immI0_rule,
  /*  741 */  _CmpL_iRegL_immL0_rule,
  /*  742 */  _CmpP_iRegP_immP0_rule,
  /*  743 */  rFlagsReg_rule,
  /*  744 */  rFlagsRegU_rule,
  /*  745 */  0,
  /*  746 */  0,
  /*  747 */  0,
  /*  748 */  0,
  /*  749 */  0,
  /*  750 */  0,
  /*  751 */  0,
  /*  752 */  inline_cache_RegP_rule,
  /*  753 */  iRegP_R0_rule,
  /*  754 */  0,
  /*  755 */  0,
  /*  756 */  0,
  /*  757 */  0,
  /*  758 */  iRegP_R0_rule,
  /*  759 */  _Binary_iRegP_R3_iRegI_R4_rule,
  /*  760 */  _Binary_iRegP_R3_iRegI_R2_rule,
  /*  761 */  _Binary_iRegP_R3_immI_le_4_rule,
  /*  762 */  iRegI_R4_rule,
  /*  763 */  iRegP_R2_rule,
  /*  764 */  _Binary_iRegP_R1_iRegI_R3_rule,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMI_LE_4",
  /*   13 */  "IMMI_31",
  /*   14 */  "IMMI_8",
  /*   15 */  "IMMI_16",
  /*   16 */  "IMMI_24",
  /*   17 */  "IMMI_32",
  /*   18 */  "IMMI_48",
  /*   19 */  "IMMI_56",
  /*   20 */  "IMMI_64",
  /*   21 */  "IMMI_255",
  /*   22 */  "IMMI_65535",
  /*   23 */  "IMML_63",
  /*   24 */  "IMML_255",
  /*   25 */  "IMML_65535",
  /*   26 */  "IMML_4294967295",
  /*   27 */  "IMML_BITMASK",
  /*   28 */  "IMMI_BITMASK",
  /*   29 */  "IMMISCALE",
  /*   30 */  "IMMI26",
  /*   31 */  "IMMI19",
  /*   32 */  "IMMIU12",
  /*   33 */  "IMMLU12",
  /*   34 */  "IMMIOFFSET",
  /*   35 */  "IMMLOFFSET",
  /*   36 */  "IMMIADDSUB",
  /*   37 */  "IMMILOG",
  /*   38 */  "IMML",
  /*   39 */  "IMML0",
  /*   40 */  "IMML_1",
  /*   41 */  "IMML_M1",
  /*   42 */  "IMML_PC_OFF",
  /*   43 */  "IMMLADDSUB",
  /*   44 */  "IMMLLOG",
  /*   45 */  "IMML_32BITS",
  /*   46 */  "IMMP",
  /*   47 */  "IMMP0",
  /*   48 */  "IMMP_1",
  /*   49 */  "IMMPOLLPAGE",
  /*   50 */  "IMMBYTEMAPBASE",
  /*   51 */  "IMMP_M1",
  /*   52 */  "IMMP_M2",
  /*   53 */  "IMMD",
  /*   54 */  "IMMD0",
  /*   55 */  "IMMDPACKED",
  /*   56 */  "IMMF",
  /*   57 */  "IMMF0",
  /*   58 */  "IMMFPACKED",
  /*   59 */  "IMMN",
  /*   60 */  "IMMN0",
  /*   61 */  "IMMNKLASS",
  /*   62 */  "IREGI",
  /*   63 */  "IREGINOSP",
  /*   64 */  "IREGL",
  /*   65 */  "IREGLNOSP",
  /*   66 */  "IREGP",
  /*   67 */  "IREGPNOSP",
  /*   68 */  "IREGP_R0",
  /*   69 */  "IREGP_R1",
  /*   70 */  "IREGP_R2",
  /*   71 */  "IREGP_R3",
  /*   72 */  "IREGP_R4",
  /*   73 */  "IREGP_R5",
  /*   74 */  "IREGP_R10",
  /*   75 */  "IREGL_R11",
  /*   76 */  "IREGP_FP",
  /*   77 */  "IREGI_R0",
  /*   78 */  "IREGI_R2",
  /*   79 */  "IREGI_R3",
  /*   80 */  "IREGI_R4",
  /*   81 */  "IREGN",
  /*   82 */  "IREGNNOSP",
  /*   83 */  "IREGIHEAPBASE",
  /*   84 */  "VREGF",
  /*   85 */  "VREGD",
  /*   86 */  "VREGD_V0",
  /*   87 */  "VREGD_V1",
  /*   88 */  "VREGD_V2",
  /*   89 */  "VREGD_V3",
  /*   90 */  "RFLAGSREG",
  /*   91 */  "RFLAGSREGU",
  /*   92 */  "INLINE_CACHE_REGP",
  /*   93 */  "INTERPRETER_METHOD_OOP_REGP",
  /*   94 */  "THREAD_REGP",
  /*   95 */  "LR_REGP",
  /*   96 */  "INDIRECT",
  /*   97 */  "INDINDEXSCALEDOFFSETI",
  /*   98 */  "INDINDEXSCALEDOFFSETL",
  /*   99 */  "INDINDEXSCALEDOFFSETI2L",
  /*  100 */  "INDINDEXSCALEDI2L",
  /*  101 */  "INDINDEXSCALED",
  /*  102 */  "INDINDEX",
  /*  103 */  "INDOFFI",
  /*  104 */  "INDOFFL",
  /*  105 */  "INDIRECTN",
  /*  106 */  "INDINDEXSCALEDOFFSETIN",
  /*  107 */  "INDINDEXSCALEDOFFSETLN",
  /*  108 */  "INDINDEXSCALEDOFFSETI2LN",
  /*  109 */  "INDINDEXSCALEDI2LN",
  /*  110 */  "INDINDEXSCALEDN",
  /*  111 */  "INDINDEXN",
  /*  112 */  "INDOFFIN",
  /*  113 */  "INDOFFLN",
  /*  114 */  "THREAD_ANCHOR_PC",
  /*  115 */  "STACKSLOTP",
  /*  116 */  "STACKSLOTI",
  /*  117 */  "STACKSLOTF",
  /*  118 */  "STACKSLOTD",
  /*  119 */  "STACKSLOTL",
  /*  120 */  "CMPOP",
  /*  121 */  "CMPOPU",
  /*  122 */  "IREGL2I",
  // last operand
  /*  123 */  "MEMORY",
  /*  124 */  "IREGIORL2I",
  // last operand class
  /*  125 */  "_LShiftL_iRegL_immIScale",
  /*  126 */  "_AddP_iRegP__LShiftL_iRegL_immIScale",
  /*  127 */  "_ConvI2L_iRegI_",
  /*  128 */  "_LShiftL__ConvI2L_iRegI__immIScale",
  /*  129 */  "_AddP_iRegP__LShiftL__ConvI2L_iRegI__immIScale",
  /*  130 */  "_DecodeN_iRegN_",
  /*  131 */  "_AddP__DecodeN_iRegN___LShiftL_iRegL_immIScale",
  /*  132 */  "_AddP__DecodeN_iRegN___LShiftL__ConvI2L_iRegI__immIScale",
  /*  133 */  "_LoadB_memory_",
  /*  134 */  "_LoadUB_memory_",
  /*  135 */  "_LoadS_memory_",
  /*  136 */  "_LoadUS_memory_",
  /*  137 */  "_LoadI_memory_",
  /*  138 */  "_ConvI2L__LoadI_memory__",
  /*  139 */  "_LoadB_indirect_",
  /*  140 */  "_LoadUB_indirect_",
  /*  141 */  "_LoadUS_indirect_",
  /*  142 */  "_LoadS_indirect_",
  /*  143 */  "_LoadI_indirect_",
  /*  144 */  "_ConvI2L__LoadI_indirect__",
  /*  145 */  "_CastP2X_iRegP_",
  /*  146 */  "_CastP2X__DecodeN_iRegN__",
  /*  147 */  "_Binary_iRegP_iRegP",
  /*  148 */  "_Binary_iRegLNoSp_iRegLNoSp",
  /*  149 */  "_Binary_iRegINoSp_iRegINoSp",
  /*  150 */  "_Binary_iRegNNoSp_iRegNNoSp",
  /*  151 */  "_Binary_cmpOp_rFlagsReg",
  /*  152 */  "_Binary_iRegI_iRegI",
  /*  153 */  "_Binary_cmpOpU_rFlagsRegU",
  /*  154 */  "_Binary_immI0_iRegI",
  /*  155 */  "_Binary_iRegI_immI0",
  /*  156 */  "_Binary_immI_1_immI0",
  /*  157 */  "_Binary_iRegL_iRegL",
  /*  158 */  "_Binary_iRegL_immL0",
  /*  159 */  "_Binary_immL0_iRegL",
  /*  160 */  "_Binary_iRegP_immP0",
  /*  161 */  "_Binary_immP0_iRegP",
  /*  162 */  "_Binary_iRegN_iRegN",
  /*  163 */  "_Binary_iRegN_immN0",
  /*  164 */  "_Binary_immN0_iRegN",
  /*  165 */  "_Binary_vRegF_vRegF",
  /*  166 */  "_Binary_vRegD_vRegD",
  /*  167 */  "_ConvL2I_iRegL_",
  /*  168 */  "_ConvI2L_iRegIorL2I_",
  /*  169 */  "_LShiftL__ConvI2L_iRegIorL2I__immIScale",
  /*  170 */  "_MulI_iRegIorL2I_iRegIorL2I",
  /*  171 */  "_MulL_iRegL_iRegL",
  /*  172 */  "_RShiftI_iRegI_immI_31",
  /*  173 */  "_URShiftI__RShiftI_iRegI_immI_31_immI_31",
  /*  174 */  "_RShiftL_iRegL_immL_63",
  /*  175 */  "_URShiftL__RShiftL_iRegL_immL_63_immL_63",
  /*  176 */  "_XorI_iRegI_immI_M1",
  /*  177 */  "_XorL_iRegL_immL_M1",
  /*  178 */  "_XorI_iRegI_iRegI",
  /*  179 */  "_XorL_iRegL_iRegL",
  /*  180 */  "_URShiftI_iRegI_immI",
  /*  181 */  "_XorI__URShiftI_iRegI_immI_immI_M1",
  /*  182 */  "_URShiftL_iRegL_immI",
  /*  183 */  "_XorL__URShiftL_iRegL_immI_immL_M1",
  /*  184 */  "_RShiftI_iRegI_immI",
  /*  185 */  "_XorI__RShiftI_iRegI_immI_immI_M1",
  /*  186 */  "_RShiftL_iRegL_immI",
  /*  187 */  "_XorL__RShiftL_iRegL_immI_immL_M1",
  /*  188 */  "_LShiftI_iRegI_immI",
  /*  189 */  "_XorI__LShiftI_iRegI_immI_immI_M1",
  /*  190 */  "_LShiftL_iRegL_immI",
  /*  191 */  "_XorL__LShiftL_iRegL_immI_immL_M1",
  /*  192 */  "_XorI__URShiftI_iRegI_immI_iRegI",
  /*  193 */  "_XorI_iRegI__URShiftI_iRegI_immI",
  /*  194 */  "_XorL__URShiftL_iRegL_immI_iRegL",
  /*  195 */  "_XorL_iRegL__URShiftL_iRegL_immI",
  /*  196 */  "_XorI__RShiftI_iRegI_immI_iRegI",
  /*  197 */  "_XorI_iRegI__RShiftI_iRegI_immI",
  /*  198 */  "_XorL__RShiftL_iRegL_immI_iRegL",
  /*  199 */  "_XorL_iRegL__RShiftL_iRegL_immI",
  /*  200 */  "_XorI__LShiftI_iRegI_immI_iRegI",
  /*  201 */  "_XorI_iRegI__LShiftI_iRegI_immI",
  /*  202 */  "_XorL__LShiftL_iRegL_immI_iRegL",
  /*  203 */  "_XorL_iRegL__LShiftL_iRegL_immI",
  /*  204 */  "_URShiftI_iRegIorL2I_immI",
  /*  205 */  "_AndI__URShiftI_iRegIorL2I_immI_immI_bitmask",
  /*  206 */  "_LShiftL_iRegL_iRegI",
  /*  207 */  "_SubI_immI_64_iRegI",
  /*  208 */  "_URShiftL_iRegL__SubI_immI_64_iRegI",
  /*  209 */  "_SubI_immI0_iRegI",
  /*  210 */  "_URShiftL_iRegL__SubI_immI0_iRegI",
  /*  211 */  "_LShiftI_iRegL_iRegI",
  /*  212 */  "_SubI_immI_32_iRegI",
  /*  213 */  "_URShiftI_iRegL__SubI_immI_32_iRegI",
  /*  214 */  "_URShiftI_iRegL__SubI_immI0_iRegI",
  /*  215 */  "_URShiftL_iRegL_iRegI",
  /*  216 */  "_LShiftL_iRegL__SubI_immI_64_iRegI",
  /*  217 */  "_LShiftL_iRegL__SubI_immI0_iRegI",
  /*  218 */  "_URShiftI_iRegL_iRegI",
  /*  219 */  "_LShiftI_iRegL__SubI_immI_32_iRegI",
  /*  220 */  "_LShiftI_iRegL__SubI_immI0_iRegI",
  /*  221 */  "_LShiftI_iRegI_immI_16",
  /*  222 */  "_RShiftI__LShiftI_iRegI_immI_16_immI_16",
  /*  223 */  "_LShiftI_iRegI_immI_24",
  /*  224 */  "_RShiftI__LShiftI_iRegI_immI_24_immI_24",
  /*  225 */  "_URShiftI__LShiftI_iRegI_immI_24_immI_24",
  /*  226 */  "_LShiftL_iRegL_immI_48",
  /*  227 */  "_RShiftL__LShiftL_iRegL_immI_48_immI_48",
  /*  228 */  "_LShiftL_iRegL_immI_32",
  /*  229 */  "_RShiftL__LShiftL_iRegL_immI_32_immI_32",
  /*  230 */  "_LShiftL_iRegL_immI_56",
  /*  231 */  "_RShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  232 */  "_URShiftL__LShiftL_iRegL_immI_56_immI_56",
  /*  233 */  "_AndI_iRegI_immI_255",
  /*  234 */  "_AndI_iRegI_immI_65535",
  /*  235 */  "_AndL_iRegL_immL_255",
  /*  236 */  "_AndL_iRegL_immL_65535",
  /*  237 */  "_AndL_iRegL_immL_4294967295",
  /*  238 */  "_ConvF2D_vRegF_",
  /*  239 */  "_SqrtD__ConvF2D_vRegF__",
  /*  240 */  "_OverflowMulI_iRegI_iRegI",
  /*  241 */  "_OverflowMulL_iRegL_iRegL",
  /*  242 */  "_CmpI_iRegI_immI0",
  /*  243 */  "_CmpL_iRegL_immL0",
  /*  244 */  "_CmpP_iRegP_immP0",
  /*  245 */  "_PartialSubtypeCheck_iRegP_R4_iRegP_R0",
  /*  246 */  "_Binary_iRegP_R1_iRegI_R2",
  /*  247 */  "_Binary_iRegP_R3_iRegI_R4",
  /*  248 */  "_Binary_iRegP_R1_iRegI_R4",
  /*  249 */  "_Binary_iRegP_R3_iRegI_R2",
  /*  250 */  "_Binary_iRegP_R3_immI_le_4",
  /*  251 */  "_Binary_iRegP_R1_iRegP_R3",
  /*  252 */  "_Binary_iRegP_R1_iRegI_R3",
  // last internally defined operand
  /*  253 */  "loadConI",
  /*  254 */  "loadConL",
  /*  255 */  "loadConP",
  /*  256 */  "loadConP0",
  /*  257 */  "loadConP1",
  /*  258 */  "loadConPollPage",
  /*  259 */  "loadByteMapBase",
  /*  260 */  "loadConN",
  /*  261 */  "loadConN0",
  /*  262 */  "loadConNKlass",
  /*  263 */  "loadConF_packed",
  /*  264 */  "loadConF",
  /*  265 */  "loadConD_packed",
  /*  266 */  "loadConD",
  /*  267 */  "countLeadingZerosI",
  /*  268 */  "countLeadingZerosL",
  /*  269 */  "countTrailingZerosI",
  /*  270 */  "countTrailingZerosL",
  /*  271 */  "castX2P",
  /*  272 */  "castP2X",
  /*  273 */  "checkCastPP",
  /*  274 */  "castPP",
  /*  275 */  "castII",
  /*  276 */  "storePConditional",
  /*  277 */  "storeLConditional",
  /*  278 */  "storeIConditional",
  /*  279 */  "negF_reg_reg",
  /*  280 */  "negD_reg_reg",
  /*  281 */  "absF_reg",
  /*  282 */  "absD_reg",
  /*  283 */  "MoveF2I_stack_reg",
  /*  284 */  "MoveI2F_stack_reg",
  /*  285 */  "MoveD2L_stack_reg",
  /*  286 */  "MoveL2D_stack_reg",
  /*  287 */  "MoveF2I_reg_reg",
  /*  288 */  "MoveI2F_reg_reg",
  /*  289 */  "MoveD2L_reg_reg",
  /*  290 */  "MoveL2D_reg_reg",
  /*  291 */  "overflowAddI_reg_reg",
  /*  292 */  "overflowAddI_reg_imm",
  /*  293 */  "overflowAddL_reg_reg",
  /*  294 */  "overflowAddL_reg_imm",
  /*  295 */  "overflowSubI_reg_reg",
  /*  296 */  "overflowSubI_reg_imm",
  /*  297 */  "overflowSubL_reg_reg",
  /*  298 */  "overflowSubL_reg_imm",
  /*  299 */  "overflowNegI_reg",
  /*  300 */  "overflowNegL_reg",
  /*  301 */  "overflowMulI_reg",
  /*  302 */  "overflowMulL_reg",
  /*  303 */  "compI_reg_reg",
  /*  304 */  "compI_reg_immI0",
  /*  305 */  "compI_reg_immIAddSub",
  /*  306 */  "compI_reg_immI",
  /*  307 */  "compU_reg_reg",
  /*  308 */  "compU_reg_immI0",
  /*  309 */  "compU_reg_immIAddSub",
  /*  310 */  "compU_reg_immI",
  /*  311 */  "compL_reg_reg",
  /*  312 */  "compL_reg_immI0",
  /*  313 */  "compL_reg_immLAddSub",
  /*  314 */  "compL_reg_immL",
  /*  315 */  "compP_reg_reg",
  /*  316 */  "compN_reg_reg",
  /*  317 */  "testP_reg",
  /*  318 */  "testN_reg",
  /*  319 */  "compF_reg_reg",
  /*  320 */  "compF_reg_zero",
  /*  321 */  "compD_reg_reg",
  /*  322 */  "compD_reg_zero",
  /*  323 */  "cmpFastLock",
  /*  324 */  "cmpFastUnlock",
  /*  325 */  "partialSubtypeCheckVsZero",
  /*  326 */  "tlsLoadP",
  /*  327 */  "loadB",
  /*  328 */  "loadB2L",
  /*  329 */  "loadUB",
  /*  330 */  "loadUB2L",
  /*  331 */  "loadS",
  /*  332 */  "loadS2L",
  /*  333 */  "loadUS",
  /*  334 */  "loadUS2L",
  /*  335 */  "loadI",
  /*  336 */  "loadI2L",
  /*  337 */  "loadUI2L",
  /*  338 */  "loadL",
  /*  339 */  "loadRange",
  /*  340 */  "loadP",
  /*  341 */  "loadN",
  /*  342 */  "loadKlass",
  /*  343 */  "loadNKlass",
  /*  344 */  "loadF",
  /*  345 */  "loadD",
  /*  346 */  "storeimmCM0",
  /*  347 */  "storeB",
  /*  348 */  "storeimmB0",
  /*  349 */  "storeC",
  /*  350 */  "storeimmC0",
  /*  351 */  "storeI",
  /*  352 */  "storeimmI0",
  /*  353 */  "storeL",
  /*  354 */  "storeimmL0",
  /*  355 */  "storeP",
  /*  356 */  "storeimmP0",
  /*  357 */  "storeLastJavaPC_no_retaddr",
  /*  358 */  "storeLastJavaPC_with_retaddr",
  /*  359 */  "storeN",
  /*  360 */  "storeImmN0",
  /*  361 */  "storeF",
  /*  362 */  "storeD",
  /*  363 */  "storeNKlass",
  /*  364 */  "prefetchr",
  /*  365 */  "prefetchw",
  /*  366 */  "prefetchnta",
  /*  367 */  "loadB_volatile",
  /*  368 */  "loadB2L_volatile",
  /*  369 */  "loadUB_volatile",
  /*  370 */  "loadUB2L_volatile",
  /*  371 */  "loadS_volatile",
  /*  372 */  "loadUS_volatile",
  /*  373 */  "loadUS2L_volatile",
  /*  374 */  "loadS2L_volatile",
  /*  375 */  "loadI_volatile",
  /*  376 */  "loadUI2L_volatile",
  /*  377 */  "loadL_volatile",
  /*  378 */  "loadP_volatile",
  /*  379 */  "loadN_volatile",
  /*  380 */  "loadF_volatile",
  /*  381 */  "loadD_volatile",
  /*  382 */  "bytes_reverse_int",
  /*  383 */  "bytes_reverse_long",
  /*  384 */  "bytes_reverse_unsigned_short",
  /*  385 */  "bytes_reverse_short",
  /*  386 */  "load_fence",
  /*  387 */  "unnecessary_membar_acquire",
  /*  388 */  "membar_acquire",
  /*  389 */  "membar_acquire_lock",
  /*  390 */  "store_fence",
  /*  391 */  "membar_release",
  /*  392 */  "membar_storestore",
  /*  393 */  "membar_release_lock",
  /*  394 */  "membar_volatile",
  /*  395 */  "convP2I",
  /*  396 */  "convN2I",
  /*  397 */  "encodeHeapOop",
  /*  398 */  "encodeHeapOop_not_null",
  /*  399 */  "decodeHeapOop",
  /*  400 */  "decodeHeapOop_not_null",
  /*  401 */  "encodeKlass_not_null",
  /*  402 */  "decodeKlass_not_null",
  /*  403 */  "loadPLocked",
  /*  404 */  "compareAndSwapI",
  /*  405 */  "compareAndSwapL",
  /*  406 */  "compareAndSwapP",
  /*  407 */  "compareAndSwapN",
  /*  408 */  "get_and_setI",
  /*  409 */  "get_and_setL",
  /*  410 */  "get_and_setN",
  /*  411 */  "get_and_setP",
  /*  412 */  "get_and_addL",
  /*  413 */  "get_and_addL_no_res",
  /*  414 */  "get_and_addLi",
  /*  415 */  "get_and_addLi_no_res",
  /*  416 */  "get_and_addI",
  /*  417 */  "get_and_addI_no_res",
  /*  418 */  "get_and_addIi",
  /*  419 */  "get_and_addIi_no_res",
  /*  420 */  "cmovI_reg_reg",
  /*  421 */  "cmovUI_reg_reg",
  /*  422 */  "cmovI_zero_reg",
  /*  423 */  "cmovUI_zero_reg",
  /*  424 */  "cmovI_reg_zero",
  /*  425 */  "cmovUI_reg_zero",
  /*  426 */  "cmovI_reg_zero_one",
  /*  427 */  "cmovUI_reg_zero_one",
  /*  428 */  "cmovL_reg_reg",
  /*  429 */  "cmovUL_reg_reg",
  /*  430 */  "cmovL_reg_zero",
  /*  431 */  "cmovUL_reg_zero",
  /*  432 */  "cmovL_zero_reg",
  /*  433 */  "cmovUL_zero_reg",
  /*  434 */  "cmovP_reg_reg",
  /*  435 */  "cmovUP_reg_reg",
  /*  436 */  "cmovP_reg_zero",
  /*  437 */  "cmovUP_reg_zero",
  /*  438 */  "cmovP_zero_reg",
  /*  439 */  "cmovUP_zero_reg",
  /*  440 */  "cmovN_reg_reg",
  /*  441 */  "cmovUN_reg_reg",
  /*  442 */  "cmovN_reg_zero",
  /*  443 */  "cmovUN_reg_zero",
  /*  444 */  "cmovN_zero_reg",
  /*  445 */  "cmovUN_zero_reg",
  /*  446 */  "cmovF_reg",
  /*  447 */  "cmovUF_reg",
  /*  448 */  "cmovD_reg",
  /*  449 */  "cmovUD_reg",
  /*  450 */  "addI_reg_reg",
  /*  451 */  "addI_reg_imm",
  /*  452 */  "addI_reg_imm_i2l",
  /*  453 */  "addP_reg_reg",
  /*  454 */  "addP_reg_reg_ext",
  /*  455 */  "addP_reg_reg_lsl",
  /*  456 */  "addP_reg_reg_ext_shift",
  /*  457 */  "lshift_ext",
  /*  458 */  "addP_reg_imm",
  /*  459 */  "addL_reg_reg",
  /*  460 */  "addL_reg_imm",
  /*  461 */  "subI_reg_reg",
  /*  462 */  "subI_reg_imm",
  /*  463 */  "subL_reg_reg",
  /*  464 */  "subL_reg_imm",
  /*  465 */  "negI_reg",
  /*  466 */  "negL_reg",
  /*  467 */  "mulI",
  /*  468 */  "smulI",
  /*  469 */  "smulI_0",
  /*  470 */  "mulL",
  /*  471 */  "mulHiL_rReg",
  /*  472 */  "maddI",
  /*  473 */  "maddI_0",
  /*  474 */  "msubI",
  /*  475 */  "maddL",
  /*  476 */  "maddL_0",
  /*  477 */  "msubL",
  /*  478 */  "divI",
  /*  479 */  "signExtract",
  /*  480 */  "div2Round",
  /*  481 */  "div2Round_0",
  /*  482 */  "divL",
  /*  483 */  "signExtractL",
  /*  484 */  "div2RoundL",
  /*  485 */  "div2RoundL_0",
  /*  486 */  "modI",
  /*  487 */  "modL",
  /*  488 */  "lShiftI_reg_reg",
  /*  489 */  "lShiftI_reg_imm",
  /*  490 */  "urShiftI_reg_reg",
  /*  491 */  "urShiftI_reg_imm",
  /*  492 */  "rShiftI_reg_reg",
  /*  493 */  "rShiftI_reg_imm",
  /*  494 */  "lShiftL_reg_reg",
  /*  495 */  "lShiftL_reg_imm",
  /*  496 */  "urShiftL_reg_reg",
  /*  497 */  "urShiftL_reg_imm",
  /*  498 */  "urShiftP_reg_imm",
  /*  499 */  "rShiftL_reg_reg",
  /*  500 */  "rShiftL_reg_imm",
  /*  501 */  "regL_not_reg",
  /*  502 */  "regI_not_reg",
  /*  503 */  "AndI_reg_not_reg",
  /*  504 */  "AndI_reg_not_reg_0",
  /*  505 */  "AndL_reg_not_reg",
  /*  506 */  "AndL_reg_not_reg_0",
  /*  507 */  "OrI_reg_not_reg",
  /*  508 */  "OrI_reg_not_reg_0",
  /*  509 */  "OrL_reg_not_reg",
  /*  510 */  "OrL_reg_not_reg_0",
  /*  511 */  "XorI_reg_not_reg",
  /*  512 */  "XorI_reg_not_reg_0",
  /*  513 */  "XorL_reg_not_reg",
  /*  514 */  "XorL_reg_not_reg_0",
  /*  515 */  "AndI_reg_URShift_not_reg",
  /*  516 */  "AndI_reg_URShift_not_reg_0",
  /*  517 */  "AndL_reg_URShift_not_reg",
  /*  518 */  "AndL_reg_URShift_not_reg_0",
  /*  519 */  "AndI_reg_RShift_not_reg",
  /*  520 */  "AndI_reg_RShift_not_reg_0",
  /*  521 */  "AndL_reg_RShift_not_reg",
  /*  522 */  "AndL_reg_RShift_not_reg_0",
  /*  523 */  "AndI_reg_LShift_not_reg",
  /*  524 */  "AndI_reg_LShift_not_reg_0",
  /*  525 */  "AndL_reg_LShift_not_reg",
  /*  526 */  "AndL_reg_LShift_not_reg_0",
  /*  527 */  "XorI_reg_URShift_not_reg",
  /*  528 */  "XorI_reg_URShift_not_reg_1",
  /*  529 */  "XorI_reg_URShift_not_reg_0",
  /*  530 */  "XorI_reg_URShift_not_reg_2",
  /*  531 */  "XorL_reg_URShift_not_reg",
  /*  532 */  "XorL_reg_URShift_not_reg_1",
  /*  533 */  "XorL_reg_URShift_not_reg_0",
  /*  534 */  "XorL_reg_URShift_not_reg_2",
  /*  535 */  "XorI_reg_RShift_not_reg",
  /*  536 */  "XorI_reg_RShift_not_reg_1",
  /*  537 */  "XorI_reg_RShift_not_reg_0",
  /*  538 */  "XorI_reg_RShift_not_reg_2",
  /*  539 */  "XorL_reg_RShift_not_reg",
  /*  540 */  "XorL_reg_RShift_not_reg_1",
  /*  541 */  "XorL_reg_RShift_not_reg_0",
  /*  542 */  "XorL_reg_RShift_not_reg_2",
  /*  543 */  "XorI_reg_LShift_not_reg",
  /*  544 */  "XorI_reg_LShift_not_reg_1",
  /*  545 */  "XorI_reg_LShift_not_reg_0",
  /*  546 */  "XorI_reg_LShift_not_reg_2",
  /*  547 */  "XorL_reg_LShift_not_reg",
  /*  548 */  "XorL_reg_LShift_not_reg_1",
  /*  549 */  "XorL_reg_LShift_not_reg_0",
  /*  550 */  "XorL_reg_LShift_not_reg_2",
  /*  551 */  "OrI_reg_URShift_not_reg",
  /*  552 */  "OrI_reg_URShift_not_reg_0",
  /*  553 */  "OrL_reg_URShift_not_reg",
  /*  554 */  "OrL_reg_URShift_not_reg_0",
  /*  555 */  "OrI_reg_RShift_not_reg",
  /*  556 */  "OrI_reg_RShift_not_reg_0",
  /*  557 */  "OrL_reg_RShift_not_reg",
  /*  558 */  "OrL_reg_RShift_not_reg_0",
  /*  559 */  "OrI_reg_LShift_not_reg",
  /*  560 */  "OrI_reg_LShift_not_reg_0",
  /*  561 */  "OrL_reg_LShift_not_reg",
  /*  562 */  "OrL_reg_LShift_not_reg_0",
  /*  563 */  "AndI_reg_URShift_reg",
  /*  564 */  "AndI_reg_URShift_reg_0",
  /*  565 */  "AndL_reg_URShift_reg",
  /*  566 */  "AndL_reg_URShift_reg_0",
  /*  567 */  "AndI_reg_RShift_reg",
  /*  568 */  "AndI_reg_RShift_reg_0",
  /*  569 */  "AndL_reg_RShift_reg",
  /*  570 */  "AndL_reg_RShift_reg_0",
  /*  571 */  "AndI_reg_LShift_reg",
  /*  572 */  "AndI_reg_LShift_reg_0",
  /*  573 */  "AndL_reg_LShift_reg",
  /*  574 */  "AndL_reg_LShift_reg_0",
  /*  575 */  "XorI_reg_URShift_reg",
  /*  576 */  "XorI_reg_URShift_reg_0",
  /*  577 */  "XorL_reg_URShift_reg",
  /*  578 */  "XorL_reg_URShift_reg_0",
  /*  579 */  "XorI_reg_RShift_reg",
  /*  580 */  "XorI_reg_RShift_reg_0",
  /*  581 */  "XorL_reg_RShift_reg",
  /*  582 */  "XorL_reg_RShift_reg_0",
  /*  583 */  "XorI_reg_LShift_reg",
  /*  584 */  "XorI_reg_LShift_reg_0",
  /*  585 */  "XorL_reg_LShift_reg",
  /*  586 */  "XorL_reg_LShift_reg_0",
  /*  587 */  "OrI_reg_URShift_reg",
  /*  588 */  "OrI_reg_URShift_reg_0",
  /*  589 */  "OrL_reg_URShift_reg",
  /*  590 */  "OrL_reg_URShift_reg_0",
  /*  591 */  "OrI_reg_RShift_reg",
  /*  592 */  "OrI_reg_RShift_reg_0",
  /*  593 */  "OrL_reg_RShift_reg",
  /*  594 */  "OrL_reg_RShift_reg_0",
  /*  595 */  "OrI_reg_LShift_reg",
  /*  596 */  "OrI_reg_LShift_reg_0",
  /*  597 */  "OrL_reg_LShift_reg",
  /*  598 */  "OrL_reg_LShift_reg_0",
  /*  599 */  "AddI_reg_URShift_reg",
  /*  600 */  "AddI_reg_URShift_reg_0",
  /*  601 */  "AddL_reg_URShift_reg",
  /*  602 */  "AddL_reg_URShift_reg_0",
  /*  603 */  "AddI_reg_RShift_reg",
  /*  604 */  "AddI_reg_RShift_reg_0",
  /*  605 */  "AddL_reg_RShift_reg",
  /*  606 */  "AddL_reg_RShift_reg_0",
  /*  607 */  "AddI_reg_LShift_reg",
  /*  608 */  "AddI_reg_LShift_reg_0",
  /*  609 */  "AddL_reg_LShift_reg",
  /*  610 */  "AddL_reg_LShift_reg_0",
  /*  611 */  "SubI_reg_URShift_reg",
  /*  612 */  "SubL_reg_URShift_reg",
  /*  613 */  "SubI_reg_RShift_reg",
  /*  614 */  "SubL_reg_RShift_reg",
  /*  615 */  "SubI_reg_LShift_reg",
  /*  616 */  "SubL_reg_LShift_reg",
  /*  617 */  "sbfmL",
  /*  618 */  "sbfmwI",
  /*  619 */  "ubfmL",
  /*  620 */  "ubfmwI",
  /*  621 */  "ubfxwI",
  /*  622 */  "ubfxL",
  /*  623 */  "ubfxIConvI2L",
  /*  624 */  "extrOrL",
  /*  625 */  "extrOrL_0",
  /*  626 */  "extrOrI",
  /*  627 */  "extrOrI_0",
  /*  628 */  "extrAddL",
  /*  629 */  "extrAddL_0",
  /*  630 */  "extrAddI",
  /*  631 */  "extrAddI_0",
  /*  632 */  "rolL_rReg",
  /*  633 */  "rolI_rReg",
  /*  634 */  "rolL_rReg_Var_C_64",
  /*  635 */  "rolL_rReg_Var_C_64_0",
  /*  636 */  "rolL_rReg_Var_C0",
  /*  637 */  "rolL_rReg_Var_C0_0",
  /*  638 */  "rolI_rReg_Var_C_32",
  /*  639 */  "rolI_rReg_Var_C_32_0",
  /*  640 */  "rolI_rReg_Var_C0",
  /*  641 */  "rolI_rReg_Var_C0_0",
  /*  642 */  "rorL_rReg",
  /*  643 */  "rorI_rReg",
  /*  644 */  "rorL_rReg_Var_C_64",
  /*  645 */  "rorL_rReg_Var_C_64_0",
  /*  646 */  "rorL_rReg_Var_C0",
  /*  647 */  "rorL_rReg_Var_C0_0",
  /*  648 */  "rorI_rReg_Var_C_32",
  /*  649 */  "rorI_rReg_Var_C_32_0",
  /*  650 */  "rorI_rReg_Var_C0",
  /*  651 */  "rorI_rReg_Var_C0_0",
  /*  652 */  "AddExtI",
  /*  653 */  "AddExtI_0",
  /*  654 */  "SubExtI",
  /*  655 */  "AddExtI_sxth",
  /*  656 */  "AddExtI_sxth_0",
  /*  657 */  "AddExtI_sxtb",
  /*  658 */  "AddExtI_sxtb_0",
  /*  659 */  "AddExtI_uxtb",
  /*  660 */  "AddExtI_uxtb_0",
  /*  661 */  "AddExtL_sxth",
  /*  662 */  "AddExtL_sxth_0",
  /*  663 */  "AddExtL_sxtw",
  /*  664 */  "AddExtL_sxtw_0",
  /*  665 */  "AddExtL_sxtb",
  /*  666 */  "AddExtL_sxtb_0",
  /*  667 */  "AddExtL_uxtb",
  /*  668 */  "AddExtL_uxtb_0",
  /*  669 */  "AddExtI_uxtb_and",
  /*  670 */  "AddExtI_uxtb_and_0",
  /*  671 */  "AddExtI_uxth_and",
  /*  672 */  "AddExtI_uxth_and_0",
  /*  673 */  "AddExtL_uxtb_and",
  /*  674 */  "AddExtL_uxtb_and_0",
  /*  675 */  "AddExtL_uxth_and",
  /*  676 */  "AddExtL_uxth_and_0",
  /*  677 */  "AddExtL_uxtw_and",
  /*  678 */  "AddExtL_uxtw_and_0",
  /*  679 */  "SubExtI_uxtb_and",
  /*  680 */  "SubExtI_uxth_and",
  /*  681 */  "SubExtL_uxtb_and",
  /*  682 */  "SubExtL_uxth_and",
  /*  683 */  "SubExtL_uxtw_and",
  /*  684 */  "addF_reg_reg",
  /*  685 */  "addD_reg_reg",
  /*  686 */  "subF_reg_reg",
  /*  687 */  "subD_reg_reg",
  /*  688 */  "mulF_reg_reg",
  /*  689 */  "mulD_reg_reg",
  /*  690 */  "divF_reg_reg",
  /*  691 */  "divD_reg_reg",
  /*  692 */  "sqrtD_reg",
  /*  693 */  "sqrtF_reg",
  /*  694 */  "andI_reg_reg",
  /*  695 */  "andI_reg_imm",
  /*  696 */  "orI_reg_reg",
  /*  697 */  "orI_reg_imm",
  /*  698 */  "xorI_reg_reg",
  /*  699 */  "xorI_reg_imm",
  /*  700 */  "andL_reg_reg",
  /*  701 */  "andL_reg_imm",
  /*  702 */  "orL_reg_reg",
  /*  703 */  "orL_reg_imm",
  /*  704 */  "xorL_reg_reg",
  /*  705 */  "xorL_reg_imm",
  /*  706 */  "convI2L_reg_reg",
  /*  707 */  "convUI2L_reg_reg",
  /*  708 */  "convL2I_reg",
  /*  709 */  "convI2B",
  /*  710 */  "convP2B",
  /*  711 */  "convD2F_reg",
  /*  712 */  "convF2D_reg",
  /*  713 */  "convF2I_reg_reg",
  /*  714 */  "convF2L_reg_reg",
  /*  715 */  "convI2F_reg_reg",
  /*  716 */  "convL2F_reg_reg",
  /*  717 */  "convD2I_reg_reg",
  /*  718 */  "convD2L_reg_reg",
  /*  719 */  "convI2D_reg_reg",
  /*  720 */  "convL2D_reg_reg",
  /*  721 */  "MoveF2I_reg_stack",
  /*  722 */  "MoveI2F_reg_stack",
  /*  723 */  "MoveD2L_reg_stack",
  /*  724 */  "MoveL2D_reg_stack",
  /*  725 */  "clearArray_reg_reg",
  /*  726 */  "overflowMulI_reg_branch",
  /*  727 */  "overflowMulL_reg_branch",
  /*  728 */  "compF3_reg_reg",
  /*  729 */  "compD3_reg_reg",
  /*  730 */  "compF3_reg_immF0",
  /*  731 */  "compD3_reg_immD0",
  /*  732 */  "cmpL3_reg_reg",
  /*  733 */  "cmpLTMask_reg_reg",
  /*  734 */  "cmpLTMask_reg_zero",
  /*  735 */  "minI_rReg",
  /*  736 */  "maxI_rReg",
  /*  737 */  "branch",
  /*  738 */  "branchCon",
  /*  739 */  "branchConU",
  /*  740 */  "cmpI_imm0_branch",
  /*  741 */  "cmpL_imm0_branch",
  /*  742 */  "cmpP_imm0_branch",
  /*  743 */  "branchLoopEnd",
  /*  744 */  "branchLoopEndU",
  /*  745 */  "safePoint",
  /*  746 */  "CallStaticJavaDirect",
  /*  747 */  "CallStaticJavaDirectHandle",
  /*  748 */  "CallDynamicJavaDirect",
  /*  749 */  "CallRuntimeDirect",
  /*  750 */  "CallLeafDirect",
  /*  751 */  "CallLeafNoFPDirect",
  /*  752 */  "TailCalljmpInd",
  /*  753 */  "TailjmpInd",
  /*  754 */  "CreateException",
  /*  755 */  "RethrowException",
  /*  756 */  "Ret",
  /*  757 */  "ShouldNotReachHere",
  /*  758 */  "partialSubtypeCheck",
  /*  759 */  "string_compare",
  /*  760 */  "string_indexof",
  /*  761 */  "string_indexof_con",
  /*  762 */  "string_equals",
  /*  763 */  "array_equals",
  /*  764 */  "encode_iso_array",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  true,
  /*   60 */  true,
  /*   61 */  true,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  false,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  true,
  /*  121 */  true,
  /*  122 */  false,
  // last operand
  /*  123 */  false,
  /*  124 */  false,
  // last operand class
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  // last internally defined operand
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // RegFlags: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // _last_machine_leaf: 13
  0, // AbsD: 14
  0, // AbsF: 15
  0, // AbsI: 16
  0, // AddD: 17
  0, // AddF: 18
  0, // AddI: 19
  0, // AddL: 20
  0, // AddP: 21
  0, // Allocate: 22
  0, // AllocateArray: 23
  0, // AndI: 24
  0, // AndL: 25
  0, // AryEq: 26
  0, // AtanD: 27
  1, // Binary: 28
  1, // Bool: 29
  0, // BoxLock: 30
  0, // ReverseBytesI: 31
  0, // ReverseBytesL: 32
  0, // ReverseBytesUS: 33
  0, // ReverseBytesS: 34
  0, // CProj: 35
  0, // CallDynamicJava: 36
  0, // CallJava: 37
  0, // CallLeaf: 38
  0, // CallLeafNoFP: 39
  0, // CallRuntime: 40
  0, // CallStaticJava: 41
  0, // CastII: 42
  0, // CastX2P: 43
  0, // CastP2X: 44
  0, // CastPP: 45
  0, // Catch: 46
  0, // CatchProj: 47
  0, // CheckCastPP: 48
  0, // ClearArray: 49
  0, // ConstraintCast: 50
  0, // CMoveD: 51
  0, // CMoveF: 52
  0, // CMoveI: 53
  0, // CMoveL: 54
  0, // CMoveP: 55
  0, // CMoveN: 56
  1, // CmpN: 57
  1, // CmpD: 58
  0, // CmpD3: 59
  1, // CmpF: 60
  0, // CmpF3: 61
  1, // CmpI: 62
  1, // CmpL: 63
  0, // CmpL3: 64
  0, // CmpLTMask: 65
  1, // CmpP: 66
  1, // CmpU: 67
  0, // CompareAndSwapI: 68
  0, // CompareAndSwapL: 69
  0, // CompareAndSwapP: 70
  0, // CompareAndSwapN: 71
  0, // GetAndAddI: 72
  0, // GetAndAddL: 73
  0, // GetAndSetI: 74
  0, // GetAndSetL: 75
  0, // GetAndSetP: 76
  0, // GetAndSetN: 77
  0, // Con: 78
  0, // ConN: 79
  0, // ConNKlass: 80
  0, // ConD: 81
  0, // ConF: 82
  0, // ConI: 83
  0, // ConL: 84
  0, // ConP: 85
  0, // Conv2B: 86
  0, // ConvD2F: 87
  0, // ConvD2I: 88
  0, // ConvD2L: 89
  0, // ConvF2D: 90
  0, // ConvF2I: 91
  0, // ConvF2L: 92
  0, // ConvI2D: 93
  0, // ConvI2F: 94
  0, // ConvI2L: 95
  0, // ConvL2D: 96
  0, // ConvL2F: 97
  0, // ConvL2I: 98
  0, // CosD: 99
  0, // CountedLoop: 100
  0, // CountedLoopEnd: 101
  0, // CountLeadingZerosI: 102
  0, // CountLeadingZerosL: 103
  0, // CountTrailingZerosI: 104
  0, // CountTrailingZerosL: 105
  0, // CreateEx: 106
  0, // DecodeN: 107
  0, // DecodeNKlass: 108
  0, // DivD: 109
  0, // DivF: 110
  0, // DivI: 111
  0, // DivL: 112
  0, // DivMod: 113
  0, // DivModI: 114
  0, // DivModL: 115
  0, // EncodeISOArray: 116
  0, // EncodeP: 117
  0, // EncodePKlass: 118
  0, // ExpD: 119
  1, // FastLock: 120
  1, // FastUnlock: 121
  0, // Goto: 122
  0, // Halt: 123
  0, // If: 124
  0, // IfFalse: 125
  0, // IfTrue: 126
  0, // Initialize: 127
  0, // JProj: 128
  0, // Jump: 129
  0, // JumpProj: 130
  0, // LShiftI: 131
  0, // LShiftL: 132
  0, // LoadB: 133
  0, // LoadUB: 134
  0, // LoadUS: 135
  0, // LoadD: 136
  0, // LoadD_unaligned: 137
  0, // LoadF: 138
  0, // LoadI: 139
  0, // LoadKlass: 140
  0, // LoadNKlass: 141
  0, // LoadL: 142
  0, // LoadL_unaligned: 143
  0, // LoadPLocked: 144
  0, // LoadP: 145
  0, // LoadN: 146
  0, // LoadRange: 147
  0, // LoadS: 148
  0, // Lock: 149
  0, // LogD: 150
  0, // Log10D: 151
  0, // Loop: 152
  0, // LoopLimit: 153
  0, // Mach: 154
  0, // MachProj: 155
  0, // MaxI: 156
  0, // MemBarAcquire: 157
  0, // LoadFence: 158
  0, // MemBarAcquireLock: 159
  0, // MemBarCPUOrder: 160
  0, // MemBarRelease: 161
  0, // StoreFence: 162
  0, // MemBarReleaseLock: 163
  0, // MemBarVolatile: 164
  0, // MemBarStoreStore: 165
  0, // MergeMem: 166
  0, // MinI: 167
  0, // ModD: 168
  0, // ModF: 169
  0, // ModI: 170
  0, // ModL: 171
  0, // MoveI2F: 172
  0, // MoveF2I: 173
  0, // MoveL2D: 174
  0, // MoveD2L: 175
  0, // MulD: 176
  0, // MulF: 177
  0, // MulHiL: 178
  0, // MulI: 179
  0, // MulL: 180
  0, // Multi: 181
  0, // NegD: 182
  0, // NegF: 183
  0, // NeverBranch: 184
  0, // Opaque1: 185
  0, // Opaque2: 186
  0, // Opaque3: 187
  0, // OrI: 188
  0, // OrL: 189
  1, // OverflowAddI: 190
  1, // OverflowSubI: 191
  1, // OverflowMulI: 192
  1, // OverflowAddL: 193
  1, // OverflowSubL: 194
  1, // OverflowMulL: 195
  0, // PCTable: 196
  0, // Parm: 197
  0, // PartialSubtypeCheck: 198
  0, // Phi: 199
  0, // PopCountI: 200
  0, // PopCountL: 201
  0, // PowD: 202
  0, // PrefetchAllocation: 203
  0, // PrefetchRead: 204
  0, // PrefetchWrite: 205
  0, // Proj: 206
  0, // RShiftI: 207
  0, // RShiftL: 208
  0, // Region: 209
  0, // Rethrow: 210
  0, // Return: 211
  0, // Root: 212
  0, // RoundDouble: 213
  0, // RoundFloat: 214
  0, // SafePoint: 215
  0, // SafePointScalarObject: 216
  0, // SCMemProj: 217
  0, // SinD: 218
  0, // SqrtD: 219
  0, // Start: 220
  0, // StartOSR: 221
  0, // StoreB: 222
  0, // StoreC: 223
  0, // StoreCM: 224
  0, // StorePConditional: 225
  0, // StoreIConditional: 226
  0, // StoreLConditional: 227
  0, // StoreD: 228
  0, // StoreF: 229
  0, // StoreI: 230
  0, // StoreL: 231
  0, // StoreP: 232
  0, // StoreN: 233
  0, // StoreNKlass: 234
  0, // StrComp: 235
  0, // StrEquals: 236
  0, // StrIndexOf: 237
  0, // SubD: 238
  0, // SubF: 239
  0, // SubI: 240
  0, // SubL: 241
  0, // TailCall: 242
  0, // TailJump: 243
  0, // TanD: 244
  0, // ThreadLocal: 245
  0, // Unlock: 246
  0, // URShiftI: 247
  0, // URShiftL: 248
  0, // XorI: 249
  0, // XorL: 250
  0, // Vector: 251
  0, // AddVB: 252
  0, // AddVS: 253
  0, // AddVI: 254
  0, // AddVL: 255
  0, // AddVF: 256
  0, // AddVD: 257
  0, // SubVB: 258
  0, // SubVS: 259
  0, // SubVI: 260
  0, // SubVL: 261
  0, // SubVF: 262
  0, // SubVD: 263
  0, // MulVS: 264
  0, // MulVI: 265
  0, // MulVF: 266
  0, // MulVD: 267
  0, // DivVF: 268
  0, // DivVD: 269
  0, // LShiftCntV: 270
  0, // RShiftCntV: 271
  0, // LShiftVB: 272
  0, // LShiftVS: 273
  0, // LShiftVI: 274
  0, // LShiftVL: 275
  0, // RShiftVB: 276
  0, // RShiftVS: 277
  0, // RShiftVI: 278
  0, // RShiftVL: 279
  0, // URShiftVB: 280
  0, // URShiftVS: 281
  0, // URShiftVI: 282
  0, // URShiftVL: 283
  0, // AndV: 284
  0, // OrV: 285
  0, // XorV: 286
  0, // LoadVector: 287
  0, // StoreVector: 288
  0, // Pack: 289
  0, // PackB: 290
  0, // PackS: 291
  0, // PackI: 292
  0, // PackL: 293
  0, // PackF: 294
  0, // PackD: 295
  0, // Pack2L: 296
  0, // Pack2D: 297
  0, // ReplicateB: 298
  0, // ReplicateS: 299
  0, // ReplicateI: 300
  0, // ReplicateL: 301
  0, // ReplicateF: 302
  0, // ReplicateD: 303
  0, // Extract: 304
  0, // ExtractB: 305
  0, // ExtractUB: 306
  0, // ExtractC: 307
  0, // ExtractS: 308
  0, // ExtractI: 309
  0, // ExtractL: 310
  0, // ExtractF: 311
  0 // no trailing comma // ExtractD: 312
};
//  The following instructions can cisc-spill



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R12",
  "R12_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R18",
  "R18_H",
  "R0",
  "R0_H",
  "R1",
  "R1_H",
  "R2",
  "R2_H",
  "R3",
  "R3_H",
  "R4",
  "R4_H",
  "R5",
  "R5_H",
  "R6",
  "R6_H",
  "R7",
  "R7_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R23",
  "R23_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R27",
  "R27_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "V16",
  "V16_H",
  "V17",
  "V17_H",
  "V18",
  "V18_H",
  "V19",
  "V19_H",
  "V20",
  "V20_H",
  "V21",
  "V21_H",
  "V22",
  "V22_H",
  "V23",
  "V23_H",
  "V24",
  "V24_H",
  "V25",
  "V25_H",
  "V26",
  "V26_H",
  "V27",
  "V27_H",
  "V28",
  "V28_H",
  "V29",
  "V29_H",
  "V30",
  "V30_H",
  "V31",
  "V31_H",
  "V0",
  "V0_H",
  "V1",
  "V1_H",
  "V2",
  "V2_H",
  "V3",
  "V3_H",
  "V4",
  "V4_H",
  "V5",
  "V5_H",
  "V6",
  "V6_H",
  "V7",
  "V7_H",
  "V8",
  "V8_H",
  "V9",
  "V9_H",
  "V10",
  "V10_H",
  "V11",
  "V11_H",
  "V12",
  "V12_H",
  "V13",
  "V13_H",
  "V14",
  "V14_H",
  "V15",
  "V15_H",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	r10->as_VMReg()        ,
	r10->as_VMReg()->next(),
	r11->as_VMReg()        ,
	r11->as_VMReg()->next(),
	r12->as_VMReg()        ,
	r12->as_VMReg()->next(),
	r13->as_VMReg()        ,
	r13->as_VMReg()->next(),
	r14->as_VMReg()        ,
	r14->as_VMReg()->next(),
	r15->as_VMReg()        ,
	r15->as_VMReg()->next(),
	r16->as_VMReg()        ,
	r16->as_VMReg()->next(),
	r17->as_VMReg()        ,
	r17->as_VMReg()->next(),
	r18->as_VMReg()        ,
	r18->as_VMReg()->next(),
	r0->as_VMReg()         ,
	r0->as_VMReg()->next() ,
	r1->as_VMReg()         ,
	r1->as_VMReg()->next() ,
	r2->as_VMReg()         ,
	r2->as_VMReg()->next() ,
	r3->as_VMReg()         ,
	r3->as_VMReg()->next() ,
	r4->as_VMReg()         ,
	r4->as_VMReg()->next() ,
	r5->as_VMReg()         ,
	r5->as_VMReg()->next() ,
	r6->as_VMReg()         ,
	r6->as_VMReg()->next() ,
	r7->as_VMReg()         ,
	r7->as_VMReg()->next() ,
	r19->as_VMReg()        ,
	r19->as_VMReg()->next(),
	r20->as_VMReg()        ,
	r20->as_VMReg()->next(),
	r21->as_VMReg()        ,
	r21->as_VMReg()->next(),
	r22->as_VMReg()        ,
	r22->as_VMReg()->next(),
	r23->as_VMReg()        ,
	r23->as_VMReg()->next(),
	r24->as_VMReg()        ,
	r24->as_VMReg()->next(),
	r25->as_VMReg()        ,
	r25->as_VMReg()->next(),
	r26->as_VMReg()        ,
	r26->as_VMReg()->next(),
	r27->as_VMReg()        ,
	r27->as_VMReg()->next(),
	r28->as_VMReg()        ,
	r28->as_VMReg()->next(),
	r29->as_VMReg()        ,
	r29->as_VMReg()->next(),
	r30->as_VMReg()        ,
	r30->as_VMReg()->next(),
	r31_sp->as_VMReg()     ,
	r31_sp->as_VMReg()->next(),
	v16->as_VMReg()        ,
	v16->as_VMReg()->next(),
	v17->as_VMReg()        ,
	v17->as_VMReg()->next(),
	v18->as_VMReg()        ,
	v18->as_VMReg()->next(),
	v19->as_VMReg()        ,
	v19->as_VMReg()->next(),
	v20->as_VMReg()        ,
	v20->as_VMReg()->next(),
	v21->as_VMReg()        ,
	v21->as_VMReg()->next(),
	v22->as_VMReg()        ,
	v22->as_VMReg()->next(),
	v23->as_VMReg()        ,
	v23->as_VMReg()->next(),
	v24->as_VMReg()        ,
	v24->as_VMReg()->next(),
	v25->as_VMReg()        ,
	v25->as_VMReg()->next(),
	v26->as_VMReg()        ,
	v26->as_VMReg()->next(),
	v27->as_VMReg()        ,
	v27->as_VMReg()->next(),
	v28->as_VMReg()        ,
	v28->as_VMReg()->next(),
	v29->as_VMReg()        ,
	v29->as_VMReg()->next(),
	v30->as_VMReg()        ,
	v30->as_VMReg()->next(),
	v31->as_VMReg()        ,
	v31->as_VMReg()->next(),
	v0->as_VMReg()         ,
	v0->as_VMReg()->next() ,
	v1->as_VMReg()         ,
	v1->as_VMReg()->next() ,
	v2->as_VMReg()         ,
	v2->as_VMReg()->next() ,
	v3->as_VMReg()         ,
	v3->as_VMReg()->next() ,
	v4->as_VMReg()         ,
	v4->as_VMReg()->next() ,
	v5->as_VMReg()         ,
	v5->as_VMReg()->next() ,
	v6->as_VMReg()         ,
	v6->as_VMReg()->next() ,
	v7->as_VMReg()         ,
	v7->as_VMReg()->next() ,
	v8->as_VMReg()         ,
	v8->as_VMReg()->next() ,
	v9->as_VMReg()         ,
	v9->as_VMReg()->next() ,
	v10->as_VMReg()        ,
	v10->as_VMReg()->next(),
	v11->as_VMReg()        ,
	v11->as_VMReg()->next(),
	v12->as_VMReg()        ,
	v12->as_VMReg()->next(),
	v13->as_VMReg()        ,
	v13->as_VMReg()->next(),
	v14->as_VMReg()        ,
	v14->as_VMReg()->next(),
	v15->as_VMReg()        ,
	v15->as_VMReg()->next(),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x0',  // R0
  (unsigned char)'\x0',  // R0_H
  (unsigned char)'\x1',  // R1
  (unsigned char)'\x1',  // R1_H
  (unsigned char)'\x2',  // R2
  (unsigned char)'\x2',  // R2_H
  (unsigned char)'\x3',  // R3
  (unsigned char)'\x3',  // R3_H
  (unsigned char)'\x4',  // R4
  (unsigned char)'\x4',  // R4_H
  (unsigned char)'\x5',  // R5
  (unsigned char)'\x5',  // R5_H
  (unsigned char)'\x6',  // R6
  (unsigned char)'\x6',  // R6_H
  (unsigned char)'\x7',  // R7
  (unsigned char)'\x7',  // R7_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\x10',  // V16
  (unsigned char)'\x10',  // V16_H
  (unsigned char)'\x11',  // V17
  (unsigned char)'\x11',  // V17_H
  (unsigned char)'\x12',  // V18
  (unsigned char)'\x12',  // V18_H
  (unsigned char)'\x13',  // V19
  (unsigned char)'\x13',  // V19_H
  (unsigned char)'\x14',  // V20
  (unsigned char)'\x14',  // V20_H
  (unsigned char)'\x15',  // V21
  (unsigned char)'\x15',  // V21_H
  (unsigned char)'\x16',  // V22
  (unsigned char)'\x16',  // V22_H
  (unsigned char)'\x17',  // V23
  (unsigned char)'\x17',  // V23_H
  (unsigned char)'\x18',  // V24
  (unsigned char)'\x18',  // V24_H
  (unsigned char)'\x19',  // V25
  (unsigned char)'\x19',  // V25_H
  (unsigned char)'\x1A',  // V26
  (unsigned char)'\x1A',  // V26_H
  (unsigned char)'\x1B',  // V27
  (unsigned char)'\x1B',  // V27_H
  (unsigned char)'\x1C',  // V28
  (unsigned char)'\x1C',  // V28_H
  (unsigned char)'\x1D',  // V29
  (unsigned char)'\x1D',  // V29_H
  (unsigned char)'\x1E',  // V30
  (unsigned char)'\x1E',  // V30_H
  (unsigned char)'\x1F',  // V31
  (unsigned char)'\x1F',  // V31_H
  (unsigned char)'\x0',  // V0
  (unsigned char)'\x0',  // V0_H
  (unsigned char)'\x1',  // V1
  (unsigned char)'\x1',  // V1_H
  (unsigned char)'\x2',  // V2
  (unsigned char)'\x2',  // V2_H
  (unsigned char)'\x3',  // V3
  (unsigned char)'\x3',  // V3_H
  (unsigned char)'\x4',  // V4
  (unsigned char)'\x4',  // V4_H
  (unsigned char)'\x5',  // V5
  (unsigned char)'\x5',  // V5_H
  (unsigned char)'\x6',  // V6
  (unsigned char)'\x6',  // V6_H
  (unsigned char)'\x7',  // V7
  (unsigned char)'\x7',  // V7_H
  (unsigned char)'\x8',  // V8
  (unsigned char)'\x8',  // V8_H
  (unsigned char)'\x9',  // V9
  (unsigned char)'\x9',  // V9_H
  (unsigned char)'\xA',  // V10
  (unsigned char)'\xA',  // V10_H
  (unsigned char)'\xB',  // V11
  (unsigned char)'\xB',  // V11_H
  (unsigned char)'\xC',  // V12
  (unsigned char)'\xC',  // V12_H
  (unsigned char)'\xD',  // V13
  (unsigned char)'\xD',  // V13_H
  (unsigned char)'\xE',  // V14
  (unsigned char)'\xE',  // V14_H
  (unsigned char)'\xF',  // V15
  (unsigned char)'\xF',  // V15_H
  (unsigned char)'\x20' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone(Compile* C) const {
  return  new (C) labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone(Compile* C) const {
  return  new (C) methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegINoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *iRegLNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *iRegPNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_PTR_REG_mask();
}

const RegMask *iRegP_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R0_REG_mask();
}

const RegMask *iRegP_R1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R1_REG_mask();
}

const RegMask *iRegP_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R2_REG_mask();
}

const RegMask *iRegP_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R3_REG_mask();
}

const RegMask *iRegP_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R4_REG_mask();
}

const RegMask *iRegP_R5Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R5_REG_mask();
}

const RegMask *iRegP_R10Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R10_REG_mask();
}

const RegMask *iRegL_R11Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &R11_REG_mask();
}

const RegMask *iRegP_FPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FP_REG_mask();
}

const RegMask *iRegI_R0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R0_REG_mask();
}

const RegMask *iRegI_R2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R2_REG_mask();
}

const RegMask *iRegI_R3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R3_REG_mask();
}

const RegMask *iRegI_R4Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_R4_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *iRegNNoSpOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &NO_SPECIAL_REG32_mask();
}

const RegMask *iRegIHeapbaseOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &HEAPBASE_REG_mask();
}

const RegMask *vRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *vRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *vRegD_V0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V0_REG_mask();
}

const RegMask *vRegD_V1Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V1_REG_mask();
}

const RegMask *vRegD_V2Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V2_REG_mask();
}

const RegMask *vRegD_V3Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &V3_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *inline_cache_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *interpreter_method_oop_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &METHOD_REG_mask();
}

const RegMask *thread_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &THREAD_REG_mask();
}

const RegMask *lr_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LR_REG_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indIndexScaledOffsetIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledI2LOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG32_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &PTR_REG_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indOffIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indirectNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledOffsetINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexScaledOffsetI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledI2LNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indIndexScaledNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indIndexNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG32_mask();
  case 1: return &ANY_REG_mask();
  }
  ShouldNotReachHere();
  return NULL;
}

const RegMask *indOffINOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *indOffLNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG32_mask();
}

const RegMask *thread_anchor_pcOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *iRegL2IOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

//------------------Define members for classes derived from MachNode----------

// Copy _idx, inputs and operands to new node
void MachNode::fill_new_machnode( MachNode* node, Compile* C) const {
  // This architecture does not have cisc or short branch instructions
  ShouldNotCallThis();
}

void overflowMulI_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulI_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void overflowMulL_reg_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void overflowMulL_reg_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpI_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpI_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpL_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpL_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpP_imm0_branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpP_imm0_branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallStaticJavaDirectHandleNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP1Node::reloc() const {
  return 1;
}

int loadConPollPageNode::reloc() const {
  return 1;
}

int loadByteMapBaseNode::reloc() const {
  return 1;
}

int loadConF_packedNode::reloc() const {
  return 2;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConD_packedNode::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int storeimmCM0Node::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 2;
}

int storeimmB0Node::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 2;
}

int storeimmC0Node::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 3;
}

int storeimmI0Node::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storeimmL0Node::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeimmP0Node::reloc() const {
  return 3;
}

int storeLastJavaPC_no_retaddrNode::reloc() const {
  return 1;
}

int storeLastJavaPC_with_retaddrNode::reloc() const {
  return 1;
}

int storeNNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int prefetchrNode::reloc() const {
  return 1;
}

int prefetchwNode::reloc() const {
  return 1;
}

int prefetchntaNode::reloc() const {
  return 1;
}

int storePConditionalNode::reloc() const {
  return 1;
}

int get_and_addINode::reloc() const {
  return 1;
}

int get_and_addI_no_resNode::reloc() const {
  return 1;
}

int cmovP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovUP_reg_zeroNode::reloc() const {
  return 1;
}

int cmovP_zero_regNode::reloc() const {
  return 1;
}

int cmovUP_zero_regNode::reloc() const {
  return 1;
}

int addI_reg_regNode::reloc() const {
  return 2;
}

int addP_reg_reg_extNode::reloc() const {
  return 1;
}

int addP_reg_reg_ext_shiftNode::reloc() const {
  return 1;
}

int lshift_extNode::reloc() const {
  return 1;
}

int subI_reg_regNode::reloc() const {
  return 2;
}

int subI_reg_immNode::reloc() const {
  return 1;
}

int negI_regNode::reloc() const {
  return 1;
}

int negL_regNode::reloc() const {
  return 1;
}

int mulINode::reloc() const {
  return 2;
}

int smulINode::reloc() const {
  return 2;
}

int smulI_0Node::reloc() const {
  return 2;
}

int maddINode::reloc() const {
  return 3;
}

int maddI_0Node::reloc() const {
  return 3;
}

int msubINode::reloc() const {
  return 3;
}

int divINode::reloc() const {
  return 2;
}

int modINode::reloc() const {
  return 2;
}

int lShiftI_reg_regNode::reloc() const {
  return 2;
}

int lShiftI_reg_immNode::reloc() const {
  return 1;
}

int urShiftI_reg_regNode::reloc() const {
  return 2;
}

int urShiftI_reg_immNode::reloc() const {
  return 1;
}

int rShiftI_reg_regNode::reloc() const {
  return 2;
}

int rShiftI_reg_immNode::reloc() const {
  return 1;
}

int lShiftL_reg_regNode::reloc() const {
  return 1;
}

int urShiftL_reg_regNode::reloc() const {
  return 1;
}

int rShiftL_reg_regNode::reloc() const {
  return 1;
}

int ubfxIConvI2LNode::reloc() const {
  return 1;
}

int AddExtINode::reloc() const {
  return 1;
}

int AddExtI_0Node::reloc() const {
  return 1;
}

int SubExtINode::reloc() const {
  return 1;
}

int andI_reg_regNode::reloc() const {
  return 2;
}

int andI_reg_immNode::reloc() const {
  return 1;
}

int orI_reg_regNode::reloc() const {
  return 2;
}

int orI_reg_immNode::reloc() const {
  return 1;
}

int xorI_reg_regNode::reloc() const {
  return 2;
}

int xorI_reg_immNode::reloc() const {
  return 1;
}

int convI2L_reg_regNode::reloc() const {
  return 1;
}

int testP_regNode::reloc() const {
  return 1;
}

int compF_reg_zeroNode::reloc() const {
  return 1;
}

int compD_reg_zeroNode::reloc() const {
  return 1;
}

int compF3_reg_immF0Node::reloc() const {
  return 1;
}

int compD3_reg_immD0Node::reloc() const {
  return 1;
}

int cmpP_imm0_branchNode::reloc() const {
  return 1;
}

int safePointNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectHandleNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int TailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int partialSubtypeCheckVsZeroNode::reloc() const {
  return 1;
}


void loadBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1913 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsbw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7069 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1919 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7086 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1931 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7103 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUB2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1931 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrb, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7120 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1937 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrshw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7137 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1943 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7154 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUSNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1955 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7171 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUS2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1955 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrh, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7188 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7205 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrsw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7222 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7240 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1979 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7257 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadRangeNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7274 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1979 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7291 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7308 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1979 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldr, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7325 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1967 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrw, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7342 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1985 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrs, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7359 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1991 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister dst_reg = as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::ldrd, dst_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7376 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2521 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    u_int32_t con = (u_int32_t)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (con == 0) {
      __ movw(dst_reg, zr);
    } else {
      __ movw(dst_reg, con);
    }
  
#line 7398 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 2532 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    u_int64_t con = (u_int64_t)opnd_array(1)->constantL();
    if (con == 0) {
      __ mov(dst_reg, zr);
    } else {
      __ mov(dst_reg, con);
    }
  
#line 7420 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2543 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL || con == (address)1) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      if (rtype == relocInfo::oop_type) {
        __ movoop(dst_reg, (jobject)con, /*immediate*/true);
      } else if (rtype == relocInfo::metadata_type) {
        __ mov_metadata(dst_reg, (Metadata*)con);
      } else {
        assert(rtype == relocInfo::none, "unexpected reloc type");
	if (con < (address)(uintptr_t)os::vm_page_size()) {
	  __ mov(dst_reg, con);
	} else {
	  unsigned long offset;
	  __ adrp(dst_reg, con, offset);
	  __ add(dst_reg, dst_reg, offset);
	}
      }
    }
  
#line 7456 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2568 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 7473 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConP1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2574 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, (u_int64_t)1);
  
#line 7490 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConPollPageNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2580 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address page = (address)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    unsigned long off;
    __ adrp(dst_reg, Address(page, relocInfo::poll_type), off);
    assert(off == 0, "assumed offset == 0");
  
#line 7510 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadByteMapBaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2589 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    address page = (address)opnd_array(1)->constant();
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    unsigned long off;
    __ adrp(dst_reg, ExternalAddress(page), off);
    assert(off == 0, "assumed offset == 0");
  
#line 7530 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2598 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::oop_type, "unexpected reloc type");
      __ set_narrow_oop(dst_reg, (jobject)con);
    }
  
#line 7554 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2611 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ mov(dst_reg, zr);
  
#line 7571 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 2617 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    address con = (address)opnd_array(1)->constant();
    if (con == NULL) {
      ShouldNotReachHere();
    } else {
      relocInfo::relocType rtype = opnd_array(1)->constant_reloc();
      assert(rtype == relocInfo::metadata_type, "unexpected reloc type");
      __ set_narrow_klass(dst_reg, (Klass *)con);
    }
  
#line 7595 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConF_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5663 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), (double)opnd_array(1)->constantF());
  
#line 7611 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5681 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 7627 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 5682 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 7636 "../generated/adfiles/ad_aarch64.cpp"
  }
}
void loadConD_packedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->constantD());
  
#line 7651 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {
    MacroAssembler _masm(&cbuf);

#line 5711 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 7667 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 5712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"
    _constant = C->constant_table().add(this, opnd_array(1));
#line 7676 "../generated/adfiles/ad_aarch64.cpp"
  }
}
void storeimmCM0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2003 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7693 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeBNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strb, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7711 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmB0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2003 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strb, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7729 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeCNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2009 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strh, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7747 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmC0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2015 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strh, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7765 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7783 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2027 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::strw, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7801 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2033 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7827 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmL0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2047 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7845 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storePNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2033 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    // we sometimes get asked to store the stack pointer into the
    // current thread -- we cannot do that directly on AArch64
    if (src_reg == r31_sp) {
      MacroAssembler _masm(&cbuf);
      assert(as_Register(opnd_array(1)->base(ra_,this,idx1)) == rthread, "unexpected store for sp");
      __ mov(rscratch2, sp);
      src_reg = rscratch2;
    }
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::str, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7871 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeimmP0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2047 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    loadStore(_masm, &MacroAssembler::str, zr, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7889 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLastJavaPC_no_retaddrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dummy_m1
  {

#line 2115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Compile* C = ra_->C;
    int nargs = C->tf()->domain()->cnt() - TypeFunc::Parms;
    if ((0x0 /*primary()*/)) { nargs++; }
    assert(nargs <= 8, "opto runtime stub has more than 8 args!");
    MacroAssembler _masm(&cbuf);
    address pc = __ pc();
    int call_offset = (nargs + 11) * 4;
    int field_offset = in_bytes(JavaThread::frame_anchor_offset()) +
                       in_bytes(JavaFrameAnchor::last_Java_pc_offset());
    __ lea(rscratch1, InternalAddress(pc + call_offset));
    __ str(rscratch1, Address(rthread, field_offset));
  
#line 7915 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLastJavaPC_with_retaddrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dummy_m2
  {

#line 2115 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Compile* C = ra_->C;
    int nargs = C->tf()->domain()->cnt() - TypeFunc::Parms;
    if ((0x1 /*primary()*/)) { nargs++; }
    assert(nargs <= 8, "opto runtime stub has more than 8 args!");
    MacroAssembler _masm(&cbuf);
    address pc = __ pc();
    int call_offset = (nargs + 11) * 4;
    int field_offset = in_bytes(JavaThread::frame_anchor_offset()) +
                       in_bytes(JavaFrameAnchor::last_Java_pc_offset());
    __ lea(rscratch1, InternalAddress(pc + call_offset));
    __ str(rscratch1, Address(rthread, field_offset));
  
#line 7941 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7959 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeImmN0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(R27_enc);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7977 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeFNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2053 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strs, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 7995 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeDNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2059 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    FloatRegister src_reg = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strd, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8013 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeNKlassNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 2021 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */);
    loadStore(MacroAssembler(&cbuf), &MacroAssembler::strw, src_reg, opnd_array(1)->opcode(),
               as_Register(opnd_array(1)->base(ra_,this,idx1)), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1));
  
#line 8031 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchrNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2404 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PLDL1KEEP);
      __ nop();
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        // __ prfm(Address(base, index_reg, Address::lsl(scale)), PLDL1KEEP);
        __ nop();
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PLDL1KEEP);
        __ nop();
      }
    }
  
#line 8064 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2426 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1KEEP);
      __ nop();
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1KEEP);
        __ nop();
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1KEEP);
        __ nop();
      }
    }
  
#line 8097 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void prefetchntaNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 2448 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
      __ prfm(Address(base, disp), PSTL1STRM);
      __ nop();
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ prfm(Address(base, index_reg, Address::lsl(scale)), PSTL1STRM);
        __ nop();
      } else {
        __ lea(rscratch1, Address(base, disp));
	__ prfm(Address(rscratch1, index_reg, Address::lsl(scale)), PSTL1STRM);
        __ nop();
      }
    }
  
#line 8130 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2154 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarb);
    __ sxtb(dst_reg, dst_reg);
  
#line 8148 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadB2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2154 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarb);
    __ sxtb(dst_reg, dst_reg);
  
#line 8166 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUB_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2166 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarb);
  
#line 8182 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUB2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2166 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarb);
  
#line 8198 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadS_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2171 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarh);
    __ sxthw(dst_reg, dst_reg);
  
#line 8216 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUS_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2185 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarh);
  
#line 8232 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUS2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2190 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarh);
  
#line 8248 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadS2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2178 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    MOV_VOLATILE(dst_reg, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarh);
    __ sxth(dst_reg, dst_reg);
  
#line 8266 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadI_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2200 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarw);
  
#line 8282 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadUI2L_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 2200 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarw);
  
#line 8299 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadL_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2205 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldar);
  
#line 8315 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadP_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2205 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldar);
  
#line 8331 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadN_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2200 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarw);
  
#line 8347 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadF_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2210 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(rscratch1, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldarw);
    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), rscratch1);
  
#line 8364 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void loadD_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2216 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MOV_VOLATILE(rscratch1, opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1),
	     rscratch1, ldar);
    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), rscratch1);
  
#line 8381 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_intNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6238 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ revw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8397 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_longNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6251 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8413 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6264 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8429 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void bytes_reverse_shortNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6278 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rev16w(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */), 0U, 15U);
  
#line 8446 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countLeadingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6294 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8462 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countLeadingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6306 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 8478 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countTrailingZerosINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6319 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rbitw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clzw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 8495 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void countTrailingZerosLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rbit(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    __ clz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 8512 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void load_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6350 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 8528 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void unnecessary_membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6363 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ block_comment("membar_acquire (elided)");
  
#line 8544 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_acquireNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6376 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 8560 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_acquire_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6390 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadLoad|Assembler::LoadStore);
  
#line 8576 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void store_fenceNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6403 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 8592 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_releaseNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6415 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 8608 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_storestoreNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6427 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::StoreStore);
  
#line 8624 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_release_lockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6439 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::LoadStore|Assembler::StoreStore);
  
#line 8640 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void membar_volatileNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 6452 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ membar(Assembler::StoreLoad);
    
#line 8656 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void castX2PNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6468 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 8674 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void castP2XNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6483 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ mov(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
    }
  
#line 8692 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convP2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6498 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 8708 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convN2INode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6514 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 8724 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6529 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ encode_heap_oop(d, s);
  
#line 8742 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6542 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 8758 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeHeapOopNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6554 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop(d, s);
  
#line 8776 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6568 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ decode_heap_oop_not_null(d, s);
  
#line 8794 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6586 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ encode_klass_not_null(dst_reg, src_reg);
  
#line 8812 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void decodeKlass_not_nullNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6601 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    if (dst_reg != src_reg) {
      __ decode_klass_not_null(dst_reg, src_reg);
    } else {
      __ decode_klass_not_null(dst_reg);
    }
  
#line 8834 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void checkCastPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void loadPLockedNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 2258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch1, Address(base, disp));
        __ ldaxr(dst_reg, rscratch1);
      } else {
        // TODO
        // should we ever get anything other than this case?
        __ ldaxr(dst_reg, base);
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch1, Address(base, index_reg, Address::lsl(scale)));
        __ ldaxr(dst_reg, rscratch1);
      } else {
        __ lea(rscratch1, Address(base, disp));
        __ lea(rscratch1, Address(rscratch1, index_reg, Address::lsl(scale)));
	__ ldaxr(dst_reg, rscratch1);
      }
    }
  
#line 8913 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storePConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// heap_top_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2287 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register src_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        __ stlxr(rscratch1, src_reg, rscratch2);
      } else {
        // TODO
        // should we ever get anything other than this case?
        __ stlxr(rscratch1, src_reg, base);
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        __ stlxr(rscratch1, src_reg, rscratch2);
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
	__ stlxr(rscratch1, src_reg, rscratch2);
      }
    }
    __ cmpw(rscratch1, zr);
  
#line 8956 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeLConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9008 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void storeIConditionalNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2356 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9060 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2356 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9112 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9122 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9174 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9184 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxr(rscratch1, addr_reg);
    __ cmp(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxr(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9236 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9246 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compareAndSwapNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2356 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register old_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register new_reg = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register base = as_Register(opnd_array(1)->base(ra_,this,idx1));
    Register addr_reg;
    int index = opnd_array(1)->index(ra_,this,idx1);
    int scale = opnd_array(1)->scale();
    int disp = opnd_array(1)->disp(ra_,this,idx1);
    if (index == -1) {
       if (disp != 0) {      
        __ lea(rscratch2, Address(base, disp));
        addr_reg = rscratch2;
      } else {
        // TODO
        // should we ever get anything other than this case?
        addr_reg = base;
      }
    } else {
      Register index_reg = as_Register(index);
      if (disp == 0) {
        __ lea(rscratch2, Address(base, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      } else {
        __ lea(rscratch2, Address(base, disp));
        __ lea(rscratch2, Address(rscratch2, index_reg, Address::lsl(scale)));
        addr_reg = rscratch2;
      }
    }
    Label retry_load, done;
    __ bind(retry_load);
    __ ldxrw(rscratch1, addr_reg);
    __ cmpw(rscratch1, old_reg);
    __ br(Assembler::NE, done);
    __ stlxrw(rscratch1, new_reg, addr_reg);
    __ cbnzw(rscratch1, retry_load);
    __ bind(done);
  
#line 9298 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2396 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register res_reg = as_Register(opnd_array(0)->reg(ra_,this)/* res */);
    __ cset(res_reg, Assembler::EQ);
  
#line 9308 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6820 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9325 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6829 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9342 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setNNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6838 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchgw(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9359 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_setPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newv
  {
    MacroAssembler _masm(&cbuf);

#line 6847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_xchg(opnd_array(0)->as_Register(ra_,this)/* prev */, opnd_array(2)->as_Register(ra_,this,idx2)/* newv */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9376 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6858 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9393 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addL_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6869 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9410 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6879 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9427 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addLi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6890 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_add(noreg, opnd_array(2)->constantL(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9444 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6900 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9461 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addI_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->as_Register(ra_,this,idx2)/* incr */, as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9478 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addIiNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6921 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(opnd_array(0)->as_Register(ra_,this)/* newval */, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9495 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void get_and_addIi_no_resNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// incr
  {
    MacroAssembler _masm(&cbuf);

#line 6932 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ atomic_addw(noreg, opnd_array(2)->constant(), as_Register(opnd_array(1)->base(ra_,this,idx1)));
  
#line 9512 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6957 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9534 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 6973 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9556 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 6998 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9578 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7014 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9600 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7030 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9622 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7046 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9644 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7067 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     zr,
	     zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9669 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUI_reg_zero_oneNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7086 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // equivalently
    // cset(as_Register($dst$$reg),
    //      negate_condition((Assembler::Condition)$cmp$$cmpcode));
    __ csincw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     zr,
	     zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9694 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7105 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9716 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7121 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9738 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7139 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9760 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7155 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9782 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7171 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9804 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUL_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9826 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7203 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9848 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7219 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9870 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7237 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9892 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7253 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            zr,
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9914 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7269 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9936 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUP_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7285 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ csel(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
            zr,
            (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9958 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7301 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 9980 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7317 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10002 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7335 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10024 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 7351 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             zr,
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src */),
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10046 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10068 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUN_zero_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7383 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src */),
             zr,
             (Assembler::Condition)opnd_array(1)->ccode());
  
#line 10090 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7400 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 10113 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7418 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcsels(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 10136 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7436 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 10159 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmovUD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7454 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ fcseld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
              as_FloatRegister(opnd_array(4)->reg(ra_,this,idx4)/* src2 */),
              as_FloatRegister(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              cond);
  
#line 10182 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7483 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10201 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2632 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 10227 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addI_reg_imm_i2lNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2632 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 10253 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7527 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10272 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7542 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
  
#line 10291 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_lslNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7557 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
		   Address::lsl(opnd_array(3)->constant())));
  
#line 10311 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_reg_ext_shiftNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7572 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lea(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   Address(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
		   Address::sxtw(opnd_array(3)->constant())));
  
#line 10331 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lshift_extNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  {
    MacroAssembler _masm(&cbuf);

#line 7587 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sbfiz(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
          as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
          opnd_array(2)->constant()& 63, MIN(32, (-opnd_array(2)->constant()) & 63));
  
#line 10350 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2646 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 10376 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7621 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10395 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2646 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x0 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 10421 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7652 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10440 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2632 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constant();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ subw(dst_reg, src_reg, -con);
    } else {
      __ addw(dst_reg, src_reg, con);
    }
  
#line 10466 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7684 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10485 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2646 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    Register src_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    int32_t con = (int32_t)opnd_array(2)->constantL();
    // add has primary == 0, subtract has primary == 1
    if ((0x1 /*primary()*/)) { con = -con; }
    if (con < 0) {
      __ sub(dst_reg, src_reg, -con);
    } else {
      __ add(dst_reg, src_reg, con);
    }
  
#line 10511 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7716 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ negw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 10529 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 7732 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ neg(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	   as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src */));
  
#line 10547 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7748 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mulw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10566 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void smulINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7763 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10585 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void smulI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 7763 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
	     as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */));
  
#line 10604 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7780 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mul(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10623 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulHiL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7796 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smulh(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	     as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10642 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7813 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10663 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 7813 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ maddw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 10684 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void msubINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7829 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ msubw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
             as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10705 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10726 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void maddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 7847 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ madd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src3 */));
  
#line 10747 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void msubLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src3
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7863 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ msub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src3 */));
  
#line 10768 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2660 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 10788 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void signExtractNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7889 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 31);
  
#line 10806 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7900 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 31);
  
#line 10827 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2Round_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7900 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 31);
  
#line 10848 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2668 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, false, rscratch1);
  
#line 10868 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void signExtractLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7925 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 63);
  
#line 10886 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7936 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 63);
  
#line 10907 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void div2RoundL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// div2
  {
    MacroAssembler _masm(&cbuf);

#line 7936 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	      Assembler::LSR, 63);
  
#line 10928 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void modINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2676 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivl(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 10948 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void modLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 2684 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
   Register dst_reg = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
   Register src1_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
   Register src2_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    __ corrected_idivq(dst_reg, src1_reg, src2_reg, true, rscratch1);
  
#line 10968 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7980 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 10987 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 7996 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 11006 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8012 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11025 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8028 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 11044 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8044 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11063 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8060 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x1f);
  
#line 11082 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8081 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lslv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11101 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void lShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8097 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsl(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            opnd_array(2)->constant()& 0x3f);
  
#line 11120 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8113 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11139 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8129 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 11158 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void urShiftP_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8145 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ lsr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 11177 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8161 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 11196 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rShiftL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 8177 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           opnd_array(2)->constant()& 0x3f);
  
#line 11215 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void regL_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8195 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 11235 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void regI_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8211 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              zr,
              Assembler::LSL, 0);
  
#line 11255 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8228 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11276 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8228 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11297 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11318 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8245 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11339 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8262 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11360 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8262 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11381 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8279 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11402 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// m1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8279 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11423 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8296 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11444 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8296 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11465 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// m1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8313 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL, 0);
  
#line 11486 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// m1
  {
    MacroAssembler _masm(&cbuf);

#line 8313 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL, 0);
  
#line 11507 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8330 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11530 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8330 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11553 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11576 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8348 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11599 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8366 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11622 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8366 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11645 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11668 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8384 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11691 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8402 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 11714 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8402 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bicw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 11737 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 11760 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8420 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ bic(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 11783 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11806 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11829 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 11852 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8438 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11875 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8456 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11898 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8456 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 11921 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8456 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSR,
              opnd_array(4)->constant()& 0x3f);
  
#line 11944 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8456 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11967 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 11990 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12013 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 12036 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8474 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12059 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12082 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12105 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::ASR,
              opnd_array(4)->constant()& 0x3f);
  
#line 12128 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12151 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8510 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12174 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8510 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12197 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8510 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 12220 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8510 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eonw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12243 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8528 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12266 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_1Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8528 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12289 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src4
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8528 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
              Assembler::LSL,
              opnd_array(4)->constant()& 0x3f);
  
#line 12312 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_not_reg_2Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8528 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eon(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12335 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12358 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8546 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12381 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12404 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8564 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12427 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8582 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12450 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8582 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12473 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8600 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12496 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8600 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12519 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12542 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8618 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ornw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12565 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src4
  {
    MacroAssembler _masm(&cbuf);

#line 8636 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12588 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_not_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src4
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8636 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orn(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12611 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8655 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12633 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8655 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12655 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8674 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12677 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8674 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12699 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12721 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8693 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12743 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12765 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12787 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8731 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12809 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8731 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12831 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8750 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 12853 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AndL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8750 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 12875 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8769 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12897 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8769 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12919 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8788 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12941 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8788 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 12963 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8807 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 12985 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8807 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13007 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13029 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8826 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13051 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8845 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13073 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8845 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13095 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8864 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13117 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void XorL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8864 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13139 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13161 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8883 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13183 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13205 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13227 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8921 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13249 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8921 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13271 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13293 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8940 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13315 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13337 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8959 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13359 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8978 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13381 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void OrL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8978 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13403 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 8997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13425 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 8997 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13447 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9016 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13469 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_URShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9016 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13491 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9035 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13513 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9035 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13535 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9054 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13557 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_RShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9054 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::ASR,
              opnd_array(2)->constant()& 0x3f);
  
#line 13579 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13601 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddI_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13623 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9092 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13645 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddL_reg_LShift_reg_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src3
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9092 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
              Assembler::LSL,
              opnd_array(2)->constant()& 0x3f);
  
#line 13667 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9111 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13689 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_URShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9130 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13711 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9149 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13733 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_RShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9168 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::ASR,
              opnd_array(3)->constant()& 0x3f);
  
#line 13755 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubI_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9187 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13777 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubL_reg_LShift_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  {
    MacroAssembler _masm(&cbuf);

#line 9206 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
              as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
              as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
              Assembler::LSL,
              opnd_array(3)->constant()& 0x3f);
  
#line 13799 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sbfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9230 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ sbfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13822 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sbfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9253 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ sbfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13845 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfmLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9276 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 63 - lshift;
    int r = (rshift - lshift) & 63;
    __ ubfm(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13868 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfmwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift_count
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift_count
  {
    MacroAssembler _masm(&cbuf);

#line 9299 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int lshift = opnd_array(2)->constant(), rshift = opnd_array(3)->constant();
    int s = 31 - lshift;
    int r = (rshift - lshift) & 31;
    __ ubfmw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    r, s);
  
#line 13891 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxwINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9318 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfxw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 13913 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9333 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constantL();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 13935 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ubfxIConvI2LNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9351 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int rshift = opnd_array(2)->constant();
    long mask = opnd_array(3)->constant();
    int width = exact_log2(mask+1);
    __ ubfx(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), rshift, width);
  
#line 13957 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9371 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 13977 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9371 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 13997 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9386 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 14017 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrOrI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9386 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 14037 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9401 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 63);
  
#line 14057 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddL_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9401 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 63);
  
#line 14077 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9416 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src2 */),
            opnd_array(4)->constant()& 31);
  
#line 14097 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void extrAddI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// lshift
  {
    MacroAssembler _masm(&cbuf);

#line 9416 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ extrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */),
            opnd_array(2)->constant()& 31);
  
#line 14117 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rolL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9432 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    rscratch1);
    
#line 14136 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rolI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9448 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ subw(rscratch1, zr, as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    rscratch1);
    
#line 14155 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rorL_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9500 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rorv(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    
#line 14173 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void rorI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {
    MacroAssembler _masm(&cbuf);

#line 9515 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ rorvw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* shift */));
    
#line 14191 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9566 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 14209 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9566 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 14227 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9579 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 14245 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9593 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 14265 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9593 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 14285 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9606 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 14305 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9606 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 14325 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9619 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14345 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9619 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14365 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxthNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9632 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxth);
   
#line 14385 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxth_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9632 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxth);
   
#line 14405 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtwNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9645 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtw);
   
#line 14425 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtw_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9645 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtw);
   
#line 14445 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9658 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::sxtb);
   
#line 14465 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_sxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9658 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::sxtb);
   
#line 14485 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtbNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rshift
  {
    MacroAssembler _masm(&cbuf);

#line 9671 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14505 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9671 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(4)->reg(ra_,this,idx4)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14525 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9685 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14544 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9685 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14563 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14582 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtI_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9698 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ addw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 14601 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9711 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14620 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtb_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9711 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtb);
   
#line 14639 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9724 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14658 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxth_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9724 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxth);
   
#line 14677 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9737 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 14696 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void AddExtL_uxtw_and_0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src1
  {
    MacroAssembler _masm(&cbuf);

#line 9737 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ add(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(3)->reg(ra_,this,idx3)/* src1 */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src2 */), ext::uxtw);
   
#line 14715 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtI_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9750 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14734 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtI_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9763 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14753 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxtb_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtb);
   
#line 14772 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxth_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9789 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxth);
   
#line 14791 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void SubExtL_uxtw_andNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 9802 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     __ sub(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */), ext::uxtw);
   
#line 14810 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9820 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fadds(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14829 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void addD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9835 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ faddd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14848 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9850 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsubs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14867 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void subD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9865 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsubd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14886 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9880 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmuls(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14905 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void mulD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 9895 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmuld(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14924 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10043 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdivs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14943 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void divD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10058 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fdivd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 14962 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fnegs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14979 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void negD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10087 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fnegd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 14996 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void absF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10100 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fabss(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15013 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void absD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10113 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fabsd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15030 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sqrtD_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10126 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsqrtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15047 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void sqrtF_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10139 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fsqrts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */),
             as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15064 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10161 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15083 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10176 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    (unsigned long)(opnd_array(2)->constant()));
  
#line 15102 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10193 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15121 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10208 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constant()));
  
#line 15140 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10225 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15159 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10240 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eorw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constant()));
  
#line 15178 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10258 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
	    as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
	    as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15197 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void andL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10273 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ andr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
            as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            (unsigned long)(opnd_array(2)->constantL()));
  
#line 15216 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10290 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15235 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void orL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10305 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ orr(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (unsigned long)(opnd_array(2)->constantL()));
  
#line 15254 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10322 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 15273 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void xorL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 10337 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ eor(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
           as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
           (unsigned long)(opnd_array(2)->constantL()));
  
#line 15292 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10352 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ sbfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 15308 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convUI2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {
    MacroAssembler _masm(&cbuf);

#line 10365 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ubfm(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, 31);
  
#line 15325 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2I_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10378 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ movw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15341 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10395 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cset(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::NE);
  
#line 15358 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convP2BNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10413 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), zr);
    __ cset(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::NE);
  
#line 15375 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2F_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10427 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15391 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2D_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10440 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvts(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15407 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10453 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzsw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15423 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convF2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10466 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzs(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15439 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10479 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfws(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15455 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10492 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15471 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10505 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzdw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15487 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10518 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcvtzd(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15503 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convI2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10531 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfwd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15519 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void convL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10544 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ scvtfd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15535 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10563 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrw(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15551 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10581 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15567 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10599 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldr(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15583 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_stack_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10617 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ ldrd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), Address(sp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 15599 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10635 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strs(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15615 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10653 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strw(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15631 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10671 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ strd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */), Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15647 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10689 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ str(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address(sp, opnd_array(0)->disp(ra_,this,0)));
  
#line 15663 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveF2I_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10707 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15679 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveI2F_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10725 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovs(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 15695 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveD2L_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10743 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(opnd_array(0)->as_Register(ra_,this)/* dst */, as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src */));
  
#line 15711 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void MoveL2D_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {
    MacroAssembler _masm(&cbuf);

#line 10761 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fmovd(as_FloatRegister(opnd_array(0)->reg(ra_,this)/* dst */), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 15727 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void clearArray_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {

#line 2470 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register cnt_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* cnt */);
    Register base_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* base */);
    // base is word aligned
    // cnt is count of words

    Label loop;
    Label entry;

//  Algorithm:
//
//    scratch1 = cnt & 7;
//    cnt -= scratch1;
//    p += scratch1;
//    switch (scratch1) {
//      do {
//        cnt -= 8;
//          p[-8] = 0;
//        case 7:
//          p[-7] = 0;
//        case 6:
//          p[-6] = 0;
//          // ...
//        case 1:
//          p[-1] = 0;
//        case 0:
//          p += 8;
//      } while (cnt);
//    }

    const int unroll = 8; // Number of str(zr) instructions we'll unroll

    __ andr(rscratch1, cnt_reg, unroll - 1);  // tmp1 = cnt % unroll
    __ sub(cnt_reg, cnt_reg, rscratch1);      // cnt -= unroll
    // base_reg always points to the end of the region we're about to zero
    __ add(base_reg, base_reg, rscratch1, Assembler::LSL, exact_log2(wordSize));
    __ adr(rscratch2, entry);
    __ sub(rscratch2, rscratch2, rscratch1, Assembler::LSL, 2);
    __ br(rscratch2);
    __ bind(loop);
    __ sub(cnt_reg, cnt_reg, unroll);
    for (int i = -unroll; i < 0; i++)
      __ str(zr, Address(base_reg, i * wordSize));
    __ bind(entry);
    __ add(base_reg, base_reg, unroll * wordSize);
    __ cbnz(cnt_reg, loop);
  
#line 15788 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10794 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 15805 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10807 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmnw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 15822 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10820 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmn(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 15839 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowAddL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10833 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmn(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 15856 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10846 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 15873 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubI_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10859 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 15890 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10872 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 15907 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowSubL_reg_immNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10885 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 15924 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowNegI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    MacroAssembler _masm(&cbuf);

#line 10898 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 15941 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowNegL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op1
  {
    MacroAssembler _masm(&cbuf);

#line 10911 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(zr, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */);
  
#line 15958 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulI_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10928 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ smull(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 15979 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulI_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 10950 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ smull(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);
    __ subs(zr, rscratch1, rscratch1, ext::sxtw);      // NE => overflow
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 16002 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulL_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {
    MacroAssembler _masm(&cbuf);

#line 10972 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ mul(rscratch1, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 31);    // Top is pure sign ext
    __ movw(rscratch1, 0x80000000);                    // Develop 0 (EQ),
    __ cselw(rscratch1, rscratch1, zr, Assembler::NE); // or 0x80000000 (NE)
    __ cmpw(rscratch1, 1);                             // 0x80000000 - 1 => VS
  
#line 16024 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void overflowMulL_reg_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 10996 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    __ mul(rscratch1, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */);   // Result bits 0..63
    __ smulh(rscratch2, opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* op2 */); // Result bits 64..127
    __ cmp(rscratch2, rscratch1, Assembler::ASR, 31);    // Top is pure sign ext
    __ br(cond == Assembler::VS ? Assembler::NE : Assembler::EQ, *L);
  
#line 16048 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 16067 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 16090 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 16113 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compI_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int32_t val = (u_int32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 16133 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2694 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 16152 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 16175 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immIAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2701 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int32_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subsw(zr, reg, val);
    } else {
      __ addsw(zr, reg, -val);
    }
  
#line 16198 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compU_reg_immINode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2712 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int32_t val = (u_int32_t)opnd_array(2)->constant();
    __ movw(rscratch1, val);
    __ cmpw(reg1, rscratch1);
  
#line 16218 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2720 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 16237 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immI0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2727 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constant();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (u_int64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 16264 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immLAddSubNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2727 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    int64_t val = opnd_array(2)->constantL();
    if (val >= 0) {
      __ subs(zr, reg, val);
    } else if (val != -val) {
      __ adds(zr, reg, -val);
    } else {
    // aargh, Long.MIN_VALUE is a special case
      __ orr(rscratch1, zr, (u_int64_t)val);
      __ subs(zr, reg, rscratch1);
    }
  
#line 16291 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compL_reg_immLNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2742 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    u_int64_t val = (u_int64_t)opnd_array(2)->constantL();
    __ mov(rscratch1, val);
    __ cmp(reg1, rscratch1);
  
#line 16311 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compP_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2750 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmp(reg1, reg2);
  
#line 16330 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compN_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 2757 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg1 = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    Register reg2 = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* op2 */);
    __ cmpw(reg1, reg2);
  
#line 16349 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void testP_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2764 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmp(reg, zr);
  
#line 16367 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void testN_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 2770 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* op1 */);
    __ cmpw(reg, zr);
  
#line 16385 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11251 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16402 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11265 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmps(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0D);
  
#line 16419 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11280 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
  
#line 16436 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11294 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ fcmpd(as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */), 0.0D);
  
#line 16453 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11312 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16479 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11340 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    FloatRegister s2 = as_FloatRegister(opnd_array(2)->reg(ra_,this,idx2)/* src2 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, s2);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16505 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compF3_reg_immF0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11367 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmps(s1, 0.0D);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16530 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void compD3_reg_immD0Node::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11394 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label done;
    FloatRegister s1 = as_FloatRegister(opnd_array(1)->reg(ra_,this,idx1)/* src1 */);
    Register d = as_Register(opnd_array(0)->reg(ra_,this)/* dst */);
    __ fcmpd(s1, 0.0D);
    // installs 0 if EQ else -1
    __ csinvw(d, zr, zr, Assembler::EQ);
    // keeps -1 if less or unordered else installs 1
    __ csnegw(d, d, d, Assembler::LT);
    __ bind(done);
  
#line 16555 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpL3_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11423 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmp(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ csetw(opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::NE);
    __ cnegw(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, Assembler::LT);
  
#line 16574 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_regNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {
    MacroAssembler _masm(&cbuf);

#line 11444 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* p */), as_Register(opnd_array(2)->reg(ra_,this,idx2)/* q */));
    __ csetw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), Assembler::LT);
    __ subw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), zr, as_Register(opnd_array(0)->reg(ra_,this)/* dst */));
  
#line 16593 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpLTMask_reg_zeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {
    MacroAssembler _masm(&cbuf);

#line 11462 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ asrw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */), as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src */), 31);
  
#line 16610 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void minI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11485 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             Assembler::LT);
  
#line 16632 "../generated/adfiles/ad_aarch64.cpp"
  }
}

uint minI_rRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void maxI_rRegNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {
    MacroAssembler _masm(&cbuf);

#line 11511 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ cmpw(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
            as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */));
    __ cselw(as_Register(opnd_array(0)->reg(ra_,this)/* dst */),
             as_Register(opnd_array(1)->reg(ra_,this,idx1)/* src1 */),
             as_Register(opnd_array(2)->reg(ra_,this,idx2)/* src2 */),
             Assembler::GT);
  
#line 16659 "../generated/adfiles/ad_aarch64.cpp"
  }
}

uint maxI_rRegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2776 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(1)->label();
    __ b(*L);
  
#line 16681 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchConNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2782 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16700 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchConUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2788 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16719 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpI_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11595 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnzw(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 16743 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpL_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11614 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 16767 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpP_imm0_branchNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {
    MacroAssembler _masm(&cbuf);

#line 11633 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    Label* L = opnd_array(4)->label();
    Assembler::Condition cond = (Assembler::Condition)opnd_array(1)->ccode();
    if (cond == Assembler::EQ)
      __ cbz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
    else
      __ cbnz(opnd_array(2)->as_Register(ra_,this,idx2)/* op1 */, *L);
  
#line 16791 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchLoopEndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2782 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16810 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void branchLoopEndUNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 2788 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Label *L = opnd_array(3)->label();
    __ br ((Assembler::Condition)opnd_array(1)->ccode(), *L);
  
#line 16829 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpFastLockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 2923 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register oop = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* object */);
    Register box = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* box */);
    Register disp_hdr = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    Register tmp = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* tmp2 */);
    Label cont;
    Label object_has_monitor;
    Label cas_failed;

    assert_different_registers(oop, box, tmp, disp_hdr);

    // Load markOop from object into displaced_header.
    __ ldr(disp_hdr, Address(oop, oopDesc::mark_offset_in_bytes()));

    // Always do locking in runtime.
    if (EmitSync & 0x01) {
      __ cmp(oop, zr);
      return;
    }
    
    if (UseBiasedLocking) {
      __ biased_locking_enter(disp_hdr, oop, box, tmp, true, cont);
    }

    // Handle existing monitor
    if (EmitSync & 0x02) {
      // we can use AArch64's bit test and branch here but
      // markoopDesc does not define a bit index just the bit value
      // so assert in case the bit pos changes
#     define __monitor_value_log2 1
      assert(markOopDesc::monitor_value == (1 << __monitor_value_log2), "incorrect bit position");
      __ tbnz(disp_hdr, __monitor_value_log2, object_has_monitor);
#     undef __monitor_value_log2
    }

    // Set displaced_header to be (markOop of object | UNLOCK_VALUE).
    __ orr(disp_hdr, disp_hdr, markOopDesc::unlocked_value);

    // Load Compare Value application register.

    // Initialize the box. (Must happen before we update the object mark!)
    __ str(disp_hdr, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // Compare object markOop with mark and if equal exchange scratch1
    // with object markOop.
    // Note that this is simply a CAS: it does not generate any
    // barriers.  These are separately generated by
    // membar_acquire_lock().
    {
      Label retry_load;
      __ bind(retry_load);
      __ ldxr(tmp, oop);
      __ cmp(tmp, disp_hdr);
      __ br(Assembler::NE, cas_failed);
      __ stxr(tmp, box, oop);
      __ cbzw(tmp, cont);
      __ b(retry_load);
    }

    // Formerly:
    // __ cmpxchgptr(/*oldv=*/disp_hdr,
    //               /*newv=*/box,
    //               /*addr=*/oop,
    //               /*tmp=*/tmp,
    //               cont,
    //               /*fail*/NULL);

    assert(oopDesc::mark_offset_in_bytes() == 0, "offset of _mark is not 0");

    // If the compare-and-exchange succeeded, then we found an unlocked
    // object, will have now locked it will continue at label cont

    __ bind(cas_failed);
    // We did not see an unlocked object so try the fast recursive case.

    // Check if the owner is self by comparing the value in the
    // markOop of object (disp_hdr) with the stack pointer.
    __ mov(rscratch1, sp);
    __ sub(disp_hdr, disp_hdr, rscratch1);
    __ mov(tmp, (address) (~(os::vm_page_size()-1) | markOopDesc::lock_mask_in_place));
    // If condition is true we are cont and hence we can store 0 as the
    // displaced header in the box, which indicates that it is a recursive lock.
    __ ands(tmp/*==0?*/, disp_hdr, tmp);
    __ str(tmp/*==0, perhaps*/, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ b(cont);

      __ bind(object_has_monitor);
      // The object's monitor m is unlocked iff m->owner == NULL,
      // otherwise m->owner may contain a thread or a stack address.
      //
      // Try to CAS m->owner from NULL to current thread.
      __ add(tmp, disp_hdr, (ObjectMonitor::owner_offset_in_bytes()-markOopDesc::monitor_value));
      __ mov(disp_hdr, zr);

      {
	Label retry_load, fail;
	__ bind(retry_load);
	__ ldxr(rscratch1, tmp);
	__ cmp(disp_hdr, rscratch1);
	__ br(Assembler::NE, fail);
	__ stxr(rscratch1, rthread, tmp);
	__ cbnzw(rscratch1, retry_load);
	__ bind(fail);
      }

      // Label next;
      // __ cmpxchgptr(/*oldv=*/disp_hdr,
      //               /*newv=*/rthread,
      //               /*addr=*/tmp,
      //               /*tmp=*/rscratch1,
      //               /*succeed*/next,
      //               /*fail*/NULL);
      // __ bind(next);

      // store a non-null value into the box.
      __ str(box, Address(box, BasicLock::displaced_header_offset_in_bytes()));

      // PPC port checks the following invariants
      // #ifdef ASSERT
      // bne(flag, cont);
      // We have acquired the monitor, check some invariants.
      // addw(/*monitor=*/tmp, tmp, -ObjectMonitor::owner_offset_in_bytes());
      // Invariant 1: _recursions should be 0.
      // assert(ObjectMonitor::recursions_size_in_bytes() == 8, "unexpected size");
      // assert_mem8_is_zero(ObjectMonitor::recursions_offset_in_bytes(), tmp,
      //                        "monitor->_recursions should be 0", -1);
      // Invariant 2: OwnerIsThread shouldn't be 0.
      // assert(ObjectMonitor::OwnerIsThread_size_in_bytes() == 4, "unexpected size");
      //assert_mem4_isnot_zero(ObjectMonitor::OwnerIsThread_offset_in_bytes(), tmp,
      //                           "monitor->OwnerIsThread shouldn't be 0", -1);
      // #endif
    }

    __ bind(cont);
    // flag == EQ indicates success
    // flag == NE indicates failure

  
#line 16986 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void cmpFastUnlockNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 3069 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register oop = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* object */);
    Register box = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* box */);
    Register disp_hdr = as_Register(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    Register tmp = as_Register(opnd_array(4)->reg(ra_,this,idx4)/* tmp2 */);
    Label cont;
    Label object_has_monitor;
    Label cas_failed;

    assert_different_registers(oop, box, tmp, disp_hdr);

    // Always do locking in runtime.
    if (EmitSync & 0x01) {
      __ cmp(oop, zr); // Oop can't be 0 here => always false.
      return;
    }

    if (UseBiasedLocking) {
      __ biased_locking_exit(oop, tmp, cont);
    }

    // Find the lock address and load the displaced header from the stack.
    __ ldr(disp_hdr, Address(box, BasicLock::displaced_header_offset_in_bytes()));

    // If the displaced header is 0, we have a recursive unlock.
    __ cmp(disp_hdr, zr);
    __ br(Assembler::EQ, cont);


    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ ldr(tmp, Address(oop, oopDesc::mark_offset_in_bytes()));
      __ tbnz(disp_hdr, exact_log2(markOopDesc::monitor_value), object_has_monitor);
    }

    // Check if it is still a light weight lock, this is is true if we
    // see the stack address of the basicLock in the markOop of the
    // object.

      {
	Label retry_load;
	__ bind(retry_load);
	__ ldxr(tmp, oop);
	__ cmp(box, tmp);
	__ br(Assembler::NE, cas_failed);
	__ stxr(tmp, disp_hdr, oop);
	__ cbzw(tmp, cont);
	__ b(retry_load);
      }

    // __ cmpxchgptr(/*compare_value=*/box,
    //               /*exchange_value=*/disp_hdr,
    //               /*where=*/oop,
    //               /*result=*/tmp,
    //               cont,
    //               /*cas_failed*/NULL);
    assert(oopDesc::mark_offset_in_bytes() == 0, "offset of _mark is not 0");

    __ bind(cas_failed);

    // Handle existing monitor.
    if ((EmitSync & 0x02) == 0) {
      __ b(cont);

      __ bind(object_has_monitor);
      __ add(tmp, tmp, -markOopDesc::monitor_value); // monitor
      __ ldr(rscratch1, Address(tmp, ObjectMonitor::owner_offset_in_bytes()));
      __ ldr(disp_hdr, Address(tmp, ObjectMonitor::recursions_offset_in_bytes()));
      __ eor(rscratch1, rscratch1, rthread); // Will be 0 if we are the owner.
      __ orr(rscratch1, rscratch1, disp_hdr); // Will be 0 if there are 0 recursions
      __ cmp(rscratch1, zr);
      __ br(Assembler::NE, cont);

      __ ldr(rscratch1, Address(tmp, ObjectMonitor::EntryList_offset_in_bytes()));
      __ ldr(disp_hdr, Address(tmp, ObjectMonitor::cxq_offset_in_bytes()));
      __ orr(rscratch1, rscratch1, disp_hdr); // Will be 0 if both are 0.
      __ cmp(rscratch1, zr);
      __ br(Assembler::NE, cont);
      // need a release store here
      __ lea(tmp, Address(tmp, ObjectMonitor::owner_offset_in_bytes()));
      __ stlr(rscratch1, tmp);
    }

    __ bind(cont);
    // flag == EQ indicates success
    // flag == NE indicates failure
  
#line 17089 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void safePointNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11731 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ read_polling_page(as_Register(opnd_array(1)->reg(ra_,this,idx1)/* poll */), relocInfo::poll_type);
  
#line 17105 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2812 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    address mark = __ pc();
    address addr = (address)opnd_array(1)->method();
    if (!_method) {
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      __ bl(Address(addr, relocInfo::runtime_call_type));
    } else if (_optimized_virtual) {
      __ bl(Address(addr, relocInfo::opt_virtual_call_type));
    } else {
      __ bl(Address(addr, relocInfo::static_call_type));
    }

    if (_method) {
      // Emit stub for static call
      CompiledStaticCall::emit_to_interp_stub(cbuf, mark);
    }
  
#line 17136 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2868 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 17148 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallStaticJavaDirectHandleNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// reg_mh_save
  {

#line 2832 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    relocInfo::relocType reloc;

    // TODO fixme
    // this is supposed to preserve and restore SP around the call
    // need to check it works
    __ mov(rfp, sp);

    address mark = __ pc();
    address addr = (address)opnd_array(1)->method();
    if (!_method) {
      // TODO check this
      // think we are calling generated Java here not x86
      // A call to a runtime wrapper, e.g. new, new_typeArray_Java, uncommon_trap.
      __ bl(Address(addr, relocInfo::runtime_call_type));
    } else if (_optimized_virtual) {
      __ bl(Address(addr, relocInfo::opt_virtual_call_type));
    } else {
      __ bl(Address(addr, relocInfo::static_call_type));
    }

    if (_method) {
      // Emit stub for static call
      CompiledStaticCall::emit_to_interp_stub(cbuf, mark);
    }

    // now restore sp
    __ mov(sp, rfp);
  
#line 17190 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2868 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 17202 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2863 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ ic_call((address)opnd_array(1)->method());
  
#line 17218 "../generated/adfiles/ad_aarch64.cpp"
  }
  {

#line 2868 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      __ call_Unimplemented();
    }
  
#line 17230 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallRuntimeDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2876 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      __ lea(rscratch1, RuntimeAddress(entry));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
    }
  
#line 17262 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallLeafDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2876 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      __ lea(rscratch1, RuntimeAddress(entry));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
    }
  
#line 17294 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2876 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);

    // some calls to generated routines (arraycopy code) are scheduled
    // by C2 as runtime calls. if so we can call them using a br (they
    // will be in a reachable segment) otherwise we have to use a blrt
    // which loads the absolute address into a register.
    address entry = (address)opnd_array(1)->method();
    CodeBlob *cb = CodeCache::find_blob(entry);
    if (cb) {
      __ bl(Address(entry));
    } else {
      int gpcnt;
      int fpcnt;
      int rtype;
      getCallInfo(tf(), gpcnt, fpcnt, rtype);
      __ lea(rscratch1, RuntimeAddress(entry));
      __ blrt(rscratch1, gpcnt, fpcnt, rtype);
    }
  
#line 17326 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void TailCalljmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2907 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    __ br(target_reg);
  
#line 17344 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void TailjmpIndNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 2913 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    Register target_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* jump_target */);
    // exception oop should be in r0
    // ret addr has been popped into lr
    // callee expects it in r3
    __ mov(r3, lr);
    __ br(target_reg);
  
#line 17366 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void CreateExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2897 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ b(RuntimeAddress(OptoRuntime::rethrow_stub()));
  
#line 17395 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void RetNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2902 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    MacroAssembler _masm(&cbuf);
    __ ret(lr);
  
#line 17411 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void ShouldNotReachHereNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {
    MacroAssembler _masm(&cbuf);

#line 11933 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO
    // implement proper trap call here
    __ brk(999);
  
#line 17429 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void partialSubtypeCheckNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 2795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(opnd_array(0)->reg(ra_,this)/* result */);

     Label miss;
     MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x1 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 17458 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void partialSubtypeCheckVsZeroNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 2795 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

     Register sub_reg = as_Register(opnd_array(1)->reg(ra_,this,idx1)/* sub */);
     Register super_reg = as_Register(opnd_array(2)->reg(ra_,this,idx2)/* super */);
     Register temp_reg = as_Register(R2_enc);
     Register result_reg = as_Register(R5_enc);

     Label miss;
     MacroAssembler _masm(&cbuf);
     __ check_klass_subtype_slow_path(sub_reg, super_reg, temp_reg, result_reg,
                                     NULL, &miss,
                                     /*set_cond_codes:*/ true);
     if ((0x0 /*primary()*/)) {
       __ mov(result_reg, zr);
     }
     __ bind(miss);
  
#line 17488 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_compareNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  {
    MacroAssembler _masm(&cbuf);

#line 11987 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc));
  
#line 17509 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_indexofNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 12003 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      -1, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 17536 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_indexof_conNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp4
  {
    MacroAssembler _masm(&cbuf);

#line 12022 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, zr,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */, opnd_array(8)->as_Register(ra_,this,idx8)/* tmp4 */,
                      icnt2, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 17564 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void string_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {
    MacroAssembler _masm(&cbuf);

#line 12040 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ string_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
		      opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      as_Register(R10_enc));
  
#line 17584 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void array_equalsNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  {
    MacroAssembler _masm(&cbuf);

#line 12055 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ char_arrays_equals(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                          opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(R10_enc));
  
#line 17602 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void encode_iso_arrayNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  {
    MacroAssembler _masm(&cbuf);

#line 12073 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
         opnd_array(0)->as_Register(ra_,this)/* result */, as_FloatRegister(V0_enc),  as_FloatRegister(V1_enc),
         as_FloatRegister(V2_enc),  as_FloatRegister(V3_enc));
  
#line 17622 "../generated/adfiles/ad_aarch64.cpp"
  }
}

void tlsLoadPNode::emit(CodeBuffer& cbuf, PhaseRegAlloc* ra_) const {
  cbuf.set_insts_mark();
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmCM0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeimmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeLastJavaPC_no_retaddrNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLastJavaPC_with_retaddrNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchrNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchwNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchntaNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2L_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadP_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadN_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadF_volatileNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_volatileNode::memory_operand() const { return _opnds[1]; }
const TypePtr *load_fenceNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* load_fenceNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *unnecessary_membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* unnecessary_membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquireNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquireNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_acquire_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_acquire_lockNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *store_fenceNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* store_fenceNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_releaseNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_releaseNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_storestoreNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_storestoreNode::memory_operand() const { return (MachOper*)-1; }
const TypePtr *membar_release_lockNode::adr_type() const { return TypePtr::BOTTOM; }
const MachOper* membar_release_lockNode::memory_operand() const { return (MachOper*)-1; }
const MachOper* loadPLockedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeIConditionalNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setNNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_setPNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addL_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addLi_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addINode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addI_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIiNode::memory_operand() const { return _opnds[1]; }
const MachOper* get_and_addIi_no_resNode::memory_operand() const { return _opnds[1]; }


const bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // RegFlags
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    false,  // AbsI
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    false,  // CProj
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastII
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // CosD
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // DivMod
    false,  // DivModI
    false,  // DivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    false,  // ExpD
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // Goto
    true ,  // Halt
    true ,  // If
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadPLocked
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // LogD
    false,  // Log10D
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachProj
    true ,  // MaxI
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // Opaque1
    false,  // Opaque2
    false,  // Opaque3
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    true ,  // OverflowMulI
    true ,  // OverflowAddL
    true ,  // OverflowSubL
    true ,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    true ,  // PartialSubtypeCheck
    false,  // Phi
    false,  // PopCountI
    false,  // PopCountL
    false,  // PowD
    true ,  // PrefetchAllocation
    true ,  // PrefetchRead
    true ,  // PrefetchWrite
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // Root
    false,  // RoundDouble
    false,  // RoundFloat
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SCMemProj
    false,  // SinD
    true ,  // SqrtD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StorePConditional
    true ,  // StoreIConditional
    true ,  // StoreLConditional
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // TanD
    true ,  // ThreadLocal
    false,  // Unlock
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    false,  // AddVB
    false,  // AddVS
    false,  // AddVI
    false,  // AddVL
    false,  // AddVF
    false,  // AddVD
    false,  // SubVB
    false,  // SubVS
    false,  // SubVI
    false,  // SubVL
    false,  // SubVF
    false,  // SubVD
    false,  // MulVS
    false,  // MulVI
    false,  // MulVF
    false,  // MulVD
    false,  // DivVF
    false,  // DivVD
    false,  // LShiftCntV
    false,  // RShiftCntV
    false,  // LShiftVB
    false,  // LShiftVS
    false,  // LShiftVI
    false,  // LShiftVL
    false,  // RShiftVB
    false,  // RShiftVS
    false,  // RShiftVI
    false,  // RShiftVL
    false,  // URShiftVB
    false,  // URShiftVS
    false,  // URShiftVI
    false,  // URShiftVL
    false,  // AndV
    false,  // OrV
    false,  // XorV
    false,  // LoadVector
    false,  // StoreVector
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    false,  // ReplicateB
    false,  // ReplicateS
    false,  // ReplicateI
    false,  // ReplicateL
    false,  // ReplicateF
    false,  // ReplicateD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false   // ExtractD
};


bool Matcher::stack_direction() const { return false; }

int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              round_to((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::in_preserve_stack_slots() { return 4; }

uint Compile::out_preserve_stack_slots() { return SharedRuntime::out_preserve_stack_slots(); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes/BytesPerInt; }

void Matcher::calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length, bool is_outgoing) {

#line 3278 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // No difference between ingoing/outgoing just pass false
    SharedRuntime::java_calling_convention(sig_bt, regs, length, false);
  
#line 18078 "../generated/adfiles/ad_aarch64.cpp"

}

void Matcher::c_calling_convention(BasicType *sig_bt, VMRegPair *regs, uint length) {

#line 3284 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // This is obviously always outgoing
    (void) SharedRuntime::c_calling_convention(sig_bt, regs, NULL, length);
  
#line 18089 "../generated/adfiles/ad_aarch64.cpp"

}

OptoRegPair Matcher::return_value(int ideal_reg, bool is_outgoing) {

#line 3291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };
  
    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                       // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 18125 "../generated/adfiles/ad_aarch64.cpp"

}

OptoRegPair Matcher::c_return_value(int ideal_reg, bool is_outgoing) {

#line 3291 "/builddir/build/BUILD/java-1.8.0-openjdk-1.8.0.25-4.b18.fc21.aarch64/jdk8/hotspot/src/cpu/aarch64/vm/aarch64.ad"

    // TODO do we allow ideal_reg == Op_RegN???
    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      R0_num,                            // Op_RegN
      R0_num,                            // Op_RegI
      R0_num,                            // Op_RegP
      V0_num,                            // Op_RegF
      V0_num,                            // Op_RegD
      R0_num                             // Op_RegL
    };
  
    static const int hi[Op_RegL + 1] = { // enum name
      0,                                 // Op_Node
      0,                                 // Op_Set
      OptoReg::Bad,                       // Op_RegN
      OptoReg::Bad,                      // Op_RegI
      R0_H_num,                          // Op_RegP
      OptoReg::Bad,                      // Op_RegF
      V0_H_num,                          // Op_RegD
      R0_H_num                           // Op_RegL
    };

    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 18161 "../generated/adfiles/ad_aarch64.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(R12_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_method_oop_reg() { return OptoReg::Name(R12_num); }

int Matcher::interpreter_method_oop_reg_encode() { return _regEncode[interpreter_method_oop_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(R29_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(R31_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAARCH64=1
#ifndef AARCH64
#  error "AARCH64 must be defined"
#endif // AARCH64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
